<?php
//////////////////////////////////////////////////////////////////////////////////
//                                                                              //
//    MG2                                                                       //
//    A PHP/HTML based image gallery script.                                    //
//                                                                              //
//    Copyright 2005 by Thomas Rybak                                            //
//    http://www.minigal.dk                                                     //
//    support@minigal.dk                                                        //
//                                                                              //
//    The script utilises Exif reader v 1.2 (free to use)                       //
//    Exif reader v 1.2                                                         //
//    By Richard James Kendall (richard@richardjameskendall.com)                //
//                                                                              //
//    -----------------                                                         //
//                                                                              //
//    MG2 is free software; you can redistribute it and/or modify               //
//    it under the terms of the GNU General Public License as published by      //
//    the Free Software Foundation; either version 2 of the License, or         //
//    (at your option) any later version.                                       //
//                                                                              //
//    MG2 is distributed in the hope that it will be useful,                    //
//    but WITHOUT ANY WARRANTY; without even the implied warranty of            //
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the              //
//    GNU General Public License for more details.                              //
//                                                                              //
//    TO COMPLY WITH THIS LICENSE, DO NOT REMOVE THE LINK TO THE MINIGAL        //
//    WEBSITE FROM YOUR GALLERY FRONT PAGE. THIS IS THE LEAST YOU CAN DO TO     //
//    SUPPORT THE DEVELOPMENT OF MG2!                                           //
//                                                                              //
//    You should have received a copy of the GNU General Public License         //
//    along with this program; if not, you can find it here:                    //
//    http://www.gnu.org/copyleft/gpl.html                                      //
//                                                                              //
//////////////////////////////////////////////////////////////////////////////////

class MG2gallery {

	var $gallerytitle;	// @var string
	var $adminemail;		// @var string
	var $metasetting;		//	@var int
	var $copyright;		// @var string
	var $defaultlang;		// @var string
	var $activeskin;		// @var string
	var $dateformat;		// @var string
	var $timeformat;		// @var string
	var $navtype;			//	@var int
	var $showexif;			//	@var int
	var $commentsets;		//	@var int
	var $foldersetting;	//	@var int
	var $marknew;			//	@var int
	var $adminpwd;			// @var string
	var $adminsalt;		// @var string
	var $extensions;		// @var string
	var $canvasWidth;		//	@var int
	var $contentWidth;	//	@var int
	var $introWidth;		//	@var int
	var $mediumimage;		//	@var int
	var $indexfile;		// @var string
	var $imagefolder;		// @var string
	var $layoutsetting;	//	@var int
	var $thumbquality;	//	@var int
	var $thumbMaxWidth;	//	@var int
	var $thumbMaxHeight;	//	@var int
	var $itemThumbCols;	//	@var int
	var $itemThumbRows;	//	@var int
	var $slideshowdelay;	//	@var int
	var $websitelink;		// @var string
	var $websitetext;		// @var string
	var $inactivetime;	//	@var int
	var $extendedset;		//	@var int
	var $modversion;		// @var string
	var $installdate;		// @var string

	//
	// RETURNS A SINGLETON INSTANCE OF THE CLASS
	// kh_mod 0.4.0, add
	function getInstance($class, $parm=false) {

		if (!isset($this->$class)) {
			$this->$class = new $class($this, $parm);
		}
		return $this->$class;
	}

	//
	// DISPLAY ITEM OR FOLDER DOES NOT EXISTS
	// kh_mod 0.4.0 rc1, changed
	function notexists($status='', $folderID=1, $page=1) {

		if ($status === 'demaged') {
			$this->notexists = $this->lang['requestfolder']  . $this->lang['damaged'];
		}
		elseif ($status === 'noimage') {
			$this->notexists = $this->lang['noimage'];
		}
		elseif ($status === 'nosearch') {
			$this->notexists = $this->lang['requestkeyword'] . $this->lang['notexists'];
		}
		else {
			$this->notexists = $this->lang['requestfolder']  . $this->lang['notexists'];
		}

		$this->startImageURI	= '';
		$this->breadCrumbNav	= $this->getBreadCrumbNav('root');
		$this->pagetitle		= $this->getPagetitle((int)$folderID, -1);
		$this->headline		= $this->gallerytitle;
		$this->galleryLink	= $this->getGalleryLink(array(
																		'fID'  => $folderID	? $folderID	: 1,
																		'page' => $page		? $page		: 1
																  ));

		// DISPLAY MISSING ITEM/FOLDER
		require_once(INC_FOLDER .'mg2_view_helper.php');
		$ViewfolderHelper = &$this->getInstance('MG2ViewHelper');
		$ViewfolderHelper->displayGalleryHead();
		include_once(SKIN_FOLDER .'templates/missing_item.php');
		$ViewfolderHelper->displayGalleryFoot();
		exit();
	}

	//
	// READ ENTIRE FLATFILE DATABASE
	// kh_mod 0.3.0, add; 0.4.5, changed
	function readDB() {

		// READ FROM MYSQL OR FLAT FILE
		$readResult = (isset($this->sqldatabase) && $this->sqldatabase === 1)?
							$this->readDBSQL()
							:
							$this->readDBFlatfile();

		// INIT FOLDER AND ITEM AUTO_ID
		$this->folderAutoID = false;
		$this->itemAutoID   = false;

		// ADMIN ONLY
		if (defined('USER_ADMIN')) {
			if ($readResult[0]) {
				$this->folderAutoID = max(array_keys($this->all_folders));
			}
			if ($readResult[1]) {
				$this->itemAutoID   = max(array_keys($this->all_items));
			}
			else {
				$this->itemAutoID   = $readResult[1];	// 0 or false
			}
		}

		return $readResult;
	}

	//
	// READ ENTIRE FLATFILE DATABASE
	// kh_mod 0.4.5, changed
	function readDBFlatfile($pathDB=null, $current=true) {

		// GET DEFAULT PATH
		if (!isset($pathDB)) {
			$fDB = DATA_FOLDER .'mg2db_folders.php';
			$iDB = DATA_FOLDER .'mg2db_items.php';
		}
		// GET CURRENT RESTORE PATH (ADMIN ONLY)
		elseif ($pathDB) {
			$fDB = sprintf($pathDB, $current ? 'folders':'fdatabase');
			$iDB = sprintf($pathDB, $current ?   'items':'idatabase');
		}
		else return array(false, false);	// no valid path

		// INIT START VALUES
		$now                = time();
		$this->all_folders  = array();
		$this->all_items    = array();

		// DOES FOLDER FILE EXIST
		$readFolders = is_file($fDB) ?
							$this->setDBFlatfile($fDB, 'all_folders', $now)
							:
							$this->setDefaultRootFolder();

		// DOES ITEM FILE EXIST
		$readItems   = is_file($iDB) ?
							$this->setDBFlatfile($iDB, 'all_items', $now)
							:
							0;

		return array($readFolders, $readItems);
	}

	//
	// READ DATA FILE (ITEM OR FOLDER) INTO AN ARRAY
	// kh_mod 0.4.5, add
	function setDBFlatfile($path, $data, $now) {
		$fp = fopen($path,'rb');
		if (!is_resource($fp))	return false;							// cannot open data file

		$numRecords = 0;
		if (defined('USER_ADMIN')) {
			while (!feof($fp)) {
				if (fgets($fp, 2) !== '#')					continue;	// no data row?
				$record = fgetcsv($fp, 8192, "\t");
				if (($recordID = (int)$record[0]) < 1) continue;	// invalid data id
				$this->{$data}[$recordID] = $record;
				$numRecords++;
			}
		}
		else {
			while (!feof($fp)) {
				if (fgets($fp, 2) !== '#')					continue;	// no data row
				$record = fgetcsv($fp, 8192, "\t");
				if (($recordID = (int)$record[0]) < 1) continue;	// invalid data id
				if ((int)$record[4] > $now)				continue;	// date in future
				if ((int)$record[5] < 0)   				continue;	// locked
				$this->{$data}[$recordID] = $record;
				$numRecords++;
			}
		}
		fclose($fp);

		return $numRecords;
	}

	//
	// READ ENTIRE MYSQL DATABASE
	// kh_mod 0.4.5, changed
	function readDBSQL() {

		// INIT  RETURN VALUES
		$readFolders = $readItems = false;

		// RESET CONTENT ARRAYS
		$this->all_folders = array();
		$this->all_items   = array();

		// FOLDER DATABASE
		$query = (defined('USER_ADMIN'))?
					'SELECT * FROM `mg2db_folders` WHERE 1'
					:
					// DATA IN PAST AND POSITION >=0 ONLY
					'SELECT * FROM `mg2db_folders`
					WHERE timestamp < UNIX_TIMESTAMP()
					AND   position >= 0';

		if ($result = mg2mysql_query($query)) {

			while ($record = mg2mysql_fetch_row($result)) {
				$folderID = (int)$record[0];
				$this->all_folders[$folderID] = $record;
			}
			$readFolders = isset($this->all_folders[1]) ?	// root folder
								count($this->all_folders)
								:
								$this->setDefaultRootFolder();
		}

		// ITEM DATABASE
		$query = (defined('USER_ADMIN'))?
					'SELECT * FROM `mg2db_items` WHERE 1'
					:
					// DATA IN PAST AND POSITION >=0 ONLY
					'SELECT * FROM `mg2db_items`
					WHERE timestamp < UNIX_TIMESTAMP()
					AND   position >=0';

		if ($result = mg2mysql_query($query)) {

			while ($record = mg2mysql_fetch_row($result)) {
				$itemID = (int)$record[0];
				$this->all_items[$itemID] = $record;
			}
			$readItems = count($this->all_items);
		}

		return array($readFolders, $readItems);
	}

	//
	// DEFAULT ROOT FOLDER
	// kh_mod 0.3.0, add; 0.4.5, changed
	function setDefaultRootFolder() {
		$this->all_folders[1] = array(
			1,								// folderID						[0]
			'root',						// in folder (#id)			[1]
			'',							// folder name					[2]
			'',							// introtext					[3]
			$this->installdate,		// timestamp (publish off)	[4]
			1,								// folder position			[5]
			0,								// imageID for folder icon	[6]
			6,								// folder sort mode			[7]
			'',							// password						[8]
			0,								// number of cols				[9]
			0,								// number of rows				[10]
			0								// folder type					[11]
		);

		return count($this->all_folders);
	}

	//
	// CREATE MYSQL DATABASE CONNECT
	// kh_mod 0.4.0 rc1, add; 0.4.2 changed
	function getSQLConnect($version='5.4.0') {

		// LOAD APPROPRIATE MYSQL API
		version_compare(PHP_VERSION, $version, '<') ?
		require_once(INC_FOLDER .'mg2_mysql_api.php')
		:
		require_once(INC_FOLDER .'mg2_mysqli_api.php');

		do {
			if (!$mg2dbLink = mg2mysql_connect(DB_SERVER, DB_USERNAME, DB_PASSWORD))	break;
			if (!$mg2dbOK   = mg2mysql_select_db(DB_NAME, $mg2dbLink))						break;

			return true;
		}
		while(0);

		// ERROR HANDLING (SWITCH TO SQL), kh_mod 0.4.4, changed
		if (defined('USER_ADMIN')) {
			return false;
		}

		// ERROR HANDLING FOR ALL OTHERS
		$msgTag  = '<span style="color:red;">%s</span>';
		$message = sprintf($msgTag, 'MySQL: No database connect!');
		include(ROOT_FOLDER .'/admin/fatal_error.php');
		exit();
	}

	//
	// READ THE SETTINGS FROM MYSQL
	// kh_mod 0.3.0, add; 0.4.2 changed
	function read_sDBSQL($useSettings=true) {

		// GET SETTINGS
		$query = 'SELECT * FROM `mg2db_settings` WHERE `settingID` = 1 LIMIT 1';
		if ($result = mg2mysql_query($query)) {
			$Settings = mg2mysql_fetch_object($result);
			if (is_object($Settings)) {

				settype($Settings->metasetting, 'integer');
				settype($Settings->navtype, 'integer');
				settype($Settings->showexif, 'integer');
				settype($Settings->commentsets, 'integer');
				settype($Settings->foldersetting, 'integer');
				settype($Settings->marknew, 'integer');
				settype($Settings->extensions, 'integer');
				settype($Settings->layoutsetting, 'integer');
				settype($Settings->thumbMaxWidth, 'integer');
				settype($Settings->thumbMaxHeight, 'integer');
				settype($Settings->itemThumbCols, 'integer');
				settype($Settings->itemThumbRows, 'integer');
				settype($Settings->inactivetime, 'integer');
				settype($Settings->extendedset, 'integer');
				settype($Settings->statisticsets, 'integer');
				settype($Settings->installdate, 'integer');

				// DO MAP SETTINGS TO OBJECT "MG2"
				if ($useSettings) {
					foreach ((array)$Settings as $property=>$value) {
						$this->$property = $value;
					}
				}

				$settingsOK = true;
			}
		}

		return isset($settingsOK) ? $Settings:false;
	}

	//
	// SELECT INDICES FROM DATABASE
	// kh_mod 0.4.0 b4, add
	function selectIndexDB($item, $arrayName, $col, $sortmode=-1) {

		// INIT RETURN VALUE
		$selected = array();

		// GET ARRAY REFERENCE
		if (!is_array($this->$arrayName)) return $selected;

		// SELECT IDs
		foreach (array_keys($this->$arrayName) as $id) {
			if ($this->{$arrayName}[$id][$col] == $item) $selected[] = $id;
		}
		if ($sortmode > -1) $this->sortIndexDB($selected, $arrayName, $sortmode);

		return $selected;
	}

	//
	// SWITCH FOR SORTING DATABASE INDICES
	// kh_mod 0.4.5, add
	function sortIndexDB(&$unsortedIDs, $arrayName, $sortmode=0) {

		// INIT DEFAULT VALUE
		$function = 'sortIndexDB_Default';

		if (function_exists('mb_strtolower')) {
			switch (strtolower($this->charset)) {
				case 'utf-8':
				case 'iso-8859-1':
				case 'iso-8859-15':
				case 'gb2312':
					$function = 'sortIndexDB_Advanced';
			}
		}
		$this->$function($unsortedIDs, $arrayName, $sortmode);
	}

	//
	// SORT DATABASE INDICES - DEFAULT
	// kh_mod 0.4.5, changed
	function sortIndexDB_Default(&$unsortedIDs, $arrayName, $sortmode) {
		if (count($unsortedIDs) < 2) return;

		$col	 = (int)$sortmode & 15;
		$comp  = (int)$sortmode & 16 ? '$b,$a':'$a,$b';
		$code  = '$array = &$GLOBALS[\'mg2\']->'.$arrayName.';$result=';
		// FOLDER NAME/ITEM TITLE(2), DESCRIPTION(3), FILE NAME(6)
		$code.= ($col===2||$col===3||$col===6)?
				  'strnatcasecmp($array[$a]['.$col.'],$array[$b]['.$col.']);'
				  :
				  '(int)$array[$a]['.$col.'] - (int)$array[$b]['.$col.'];';
		$code.= 'return ($result===0)? $a-$b:$result;';
		$comp_func = create_function($comp, $code);
		usort($unsortedIDs, $comp_func);
	}

	//
	// SORT DATABASE INDICES - Advanced
	// kh_mod 0.4.5, add
	function sortIndexDB_Advanced(&$unsortedIDs, $arrayName, $sortmode) {
		if (count($unsortedIDs) < 2) return;

		$pattern = array();
		$column  = (int)$sortmode & 15;
		$order   = (int)$sortmode & 16 ? SORT_DESC:SORT_ASC;
		$mode    = ($column===2||$column===3||$column===6)?
					  SORT_STRING
					  :
					  SORT_NUMERIC;

		// DO SORT RECORD IDs
		foreach ($unsortedIDs as $itemID) {
			eval('$sortItem = $this->'. $arrayName .'['. $itemID .']['. $column .'];');

			$pattern[] = ($mode === SORT_STRING)?
							 $this->prepareNatsort($sortItem)
							 :
							 (int)$sortItem;
		}
		array_multisort($pattern, $order, $mode, $unsortedIDs, SORT_NUMERIC, $order);
	}

	//
	// STRING PREPARING FOR NATURAL SORT
	// kh_mod 0.4.5, add
	function prepareNatsort($sortItem) {

		$sortItem = preg_replace_callback('/[0-9]+/', array($this, 'scaleNumber'), $sortItem);
		$sortItem = preg_replace(
			'/&([a-z]{1,2})(acute|cedil|circ|grave|lig|orn|ring|slash|tilde|uml);/i',
			'$1'. chr(255) .'$2',
			htmlentities(mb_strtolower($sortItem, $this->charset), ENT_QUOTES, $this->charset)
		);
		return $sortItem;
	}

	//
	// ZERO PADDING OF A NUMBER UP TO 32 DIGITS
	// kh_mod 0.4.5, add
	function scaleNumber($number) {
		return vsprintf('%032d', $number);
	}

	//
	// SORT TWO-DIMENSIONAL ARRAY - NUMERIC
	// kh_mod 0.4.0 b4, add
	function sortNumeric(&$array, $col, $order=0) {
		if (count($array) < 2) return;

		$col  = is_string($col) ? '\''. $col .'\'':(int)$col;
		$code = '$result = (int)$a['.$col.'] - (int)$b['.$col.'];';
		$code.= 'return ($result===0)? $a[0]-$b[0]:$result;';
		$comp = $order ? '$b,$a':'$a,$b';
		$comp_func = create_function($comp, $code);
		uasort($array, $comp_func);
	}

	//
	// SET KEYWORD MODE
	// kh_mod 0.4.0 rc1, add
	function setKeywordMode($searchID, $isAdminModeStart) {

		// ALLOW KEYWORD MODE
		if (!($this->layoutsetting & 1<<6)) return false;

		// INIT KEYWORD MODE
		$keywordMode = false;

		// KEYWORD SESSION ALREADY EXISTS
		if (!$isAdminModeStart													&&
			 isset($_SESSION[GALLERY_ID]['search']['searchID'])		&&
			 ($_SESSION[GALLERY_ID]['search']['searchID'] === $searchID))
		{
			$keywordMode = true;
		}
		// SET NEW KEYWORD SESSION
		else
		{
			$Keywords = &$this->getInstance('MG2Keywords');
			if (($itemIDs = $Keywords->selectItemIDs($searchID)) !== false) {
				$_SESSION[GALLERY_ID]['search'] = array();
				$searchResults = &$_SESSION[GALLERY_ID]['search'];
				$searchResults['searchID'] = $searchID;
				$searchResults['itemIDs']  = $itemIDs;
				$searchResults['folderRC'] = $Keywords->getKeywordFolder($searchID);
				$searchResults['navItem']  = sprintf('%s %s (%d)',
															$this->lang['search'],
															$searchResults['folderRC'][2],
															count($itemIDs)
													  );
				$keywordMode = true;
			}
		}

		return $keywordMode;
	}

	//
	// SET WEB SERVER TO CURRENT CHARSET (LANG FILE)
	// kh_mod 0.4.0 rc2, add
	function setServerToCharset() {

		$regexp = '/^([a-z]{2})(_|-)([a-z]{2})$/i';
		if (preg_match($regexp, $this->defaultlang, $item)) {
			setlocale(LC_CTYPE, sprintf('%s_%s.%s',
											strtolower($item[1]),
											strtoupper($item[3]),
											$this->charset
									  ));
		}
	}

	//
	// SET A VERIFY TOKEN FOR A FORM
	// kh_mod 0.4.0 b4, add, 0.4.1 changed
	function setVerificationToken($name, $len=20) {

		if (empty($_SESSION[GALLERY_ID]['verify'][$name])          ||
			 (strlen($_SESSION[GALLERY_ID]['verify'][$name]) !== $len))
		{
			$_SESSION[GALLERY_ID]['verify'][$name] =
				$this->buildVerificationToken($len);
		}

		return $_SESSION[GALLERY_ID]['verify'][$name];
	}

	//
	// CHECKED A VERIFY TOKEN FROM A FORM
	// kh_mod 0.4.0 b4, add, 0.4.1 changed
	function checkVerificationToken($name, $method='post') {

		$vstring = ($method === 'get') ? $_GET['verify']:$_POST['verify'];
		$session = false;
		do {
			if (empty($_SESSION[GALLERY_ID]['verify'][$name]))	break;
			if (empty($vstring))											break;

			// RESET TOKEN
			$session = $_SESSION[GALLERY_ID]['verify'][$name];
			unset($_SESSION[GALLERY_ID]['verify'][$name]);
		}
		while(0);

		return ($session === $vstring);
	}

	//
	// BUILD A TOKEN FOR VALIDATION FORM REQUESTS
	// kh_mod 0.3.1, add
	function buildVerificationToken($len=6) {

		// INIT VERIFY TOKEN
		$verifyToken = '';

		// DEFINE AVAILABLE CHARS
		$availableChars = "23456789abcdfghjkmnpqrstvwxABCDEFGHJKLMNPRSTUVWXYZ~#+";
		$maxCharsIndex  = strlen($availableChars) - 1;

		// CONCATENATE RANDOM CHARS TO TOKEN
		for ($idx=0; $idx<$len; $idx++) {
			$availableChars = str_shuffle($availableChars);
			$verifyToken	.= $availableChars[mt_rand(0, $maxCharsIndex)];
		}

		return (strlen($verifyToken) === $len)?
				 $verifyToken
				 :
				 null;
	}

	//
	// GET SORT MODE FOR FOLDER
	// kh_mod 0.3.0, add, 0.4.2 changed
	function getFolderSortMode($folderID=false) {

		// GLOBAL SORT SETTING (FORCE ALL FOLDERS)
		if ($this->foldersetting & 15) {
			$tmpSortmode = $this->foldersetting;
		}
		// USE FOLDER SETTING WITH ID
		elseif ($folderID && isset($this->all_folders[$folderID])) {
			$tmpSortmode = $this->all_folders[$folderID][7];
		}
		// USE CURRENT FOLDER SETTING
		else {
			$tmpSortmode = $this->imageSortMode;
		}

		// MAP IMAGE SORT MODE TO FOLDER
		switch ((int)$tmpSortmode & 15) {
			case  0 : $transSortby = 0; break;	// item id		->	folder id
			case  1 : $transSortby = 0; break;	// parent id	->	folder id
			case  2 : $transSortby = 5; break;	// title			->	position
			case  3 : $transSortby = 3; break;	// description	->	description
			case  4 : $transSortby = 4; break;	// timestamp	->	timestamp
			case  5 : $transSortby = 5; break;	// position		->	position
			case  6 : $transSortby = 2; break;	// filename		->	foldername
			case  8 : $transSortby = 5; break;	// width			->	position
			case  9 : $transSortby = 5; break;	// height		->	position
			case 12 : $transSortby = 5; break;	// filesize		->	position
			case 13 : $transSortby = 5; break;	// exif-date	->	position
			default : $transSortby = 2;
		}

		return ($transSortby | ($tmpSortmode & 16));
	}

	//
	// GET FOLDER URL
	// kh_mod 0.4.1, add
	function getFolderURL($folderID) {

		list($url, $target) = unserialize($this->all_folders[$folderID][12]);
		return array(
					$url ? $this->cleanLink($url):'#',
					$this->getTargetName($target)
				 );
	}

	//
	// GET TARGET NAME FOR FOLDER URL
	// kh_mod 0.4.1, add
	function getTargetName($code) {

		$targets = array('_blank','_self','_parent','_top');
		return isset($targets[(int)$code]) ?
				 $targets[(int)$code]
				 :
				 $targets[0];
	}

	//
	// BUILD URI FOR GALLERY CALL
	// kh_mod 0.4.0 b4, changed
	function getGalleryLink($param=array()) {

		// MAP VITRUAL FOLDER ID TO SEARCH ID EXCEPT ROOT
		if (defined('SEARCHVIEW')	&&
			 isset($param['fID'])	&&
			 ($param['fID'] > 1))
		{
			unset($param['fID']);
			$param = array('search'=>SEARCHVIEW) + $param;
		}

		// SEO URI
		if ($this->extendedset & 32) {

			$rawURI = array('index'=>'index', 'page'=>'', 'term'=>'.html');

			// SEARCH ID
			if (!empty($param['search'])) {
				$rawURI['index'] = 'search'. (int)$param['search'];
				unset($param['search']);
			}
			// FOLDER ID
			elseif (!empty($param['fID'])) {
				$rawURI['index'] = 'folder'. (int)$param['fID'];
				unset($param['fID']);
			}
			// ITEM ID
			elseif (!empty($param['iID'])) {
				$rawURI['index'] = 'image'. (int)$param['iID'];
				unset($param['iID']);
				if (!empty($param['showform'])) {
					$rawURI['index'].= '-showform';
					unset($param['showform']);
				}
			}
			// SLIDESHOW ID
			elseif (!empty($param['slideshow'])) {
				$rawURI['index'] = 'slideshow'. (int)$param['slideshow'];
				unset($param['slideshow']);
			}

			// FOLDER PAGE
			if (!empty($param['page'])) {
				$rawURI['page'] = '-'. $param['page'];
				unset($param['page']);
			}

			// BUILD SEO URI
			$uri = implode('', $rawURI);
		}
		else {
			// DEFAULT URI
			$uri = $this->indexfile;
		}

		// QUERY APPENDIX
		$and = '?';
		foreach ($param as $key=>$query) {
			$uri.= $and . $key .'='. $query;
			$and = '&amp;';
		}

		return $uri;
	}

	//
	// GET SLIDESHOW LINK
	// kh_mod 0.4.5, changed
	function getSlideshowStart($content, $target='', $inactiv=false) {

		// INIT RETURN VALUES
		$link		  = array();
		$delimiter = '&nbsp;';

		// IS THERE ANY CONTENT
		if (is_array($content))
		if (!empty($this->startImageURI)) {
			foreach($content as $key=>$chunk) {
				if (trim($chunk) == '') continue;

				$link[] = sprintf('<a href="%s" id="openSlideshow%d" target="%s">%s</a>',
								$this->startImageURI,
								$key,
								$target ? $target : '_self',
								$chunk
							 );
			}
		} elseif ($inactiv) {
			$link = $content;
		}

		return implode($delimiter, $link);
	}

	//
	// ITEM NAVIGATION
	// kh_mod 0.4.2, changed
	function getItemNavigation($itemID, $thumbset=false, $display='gallery') {

		// GET ITEM IDs OF CURRENT FOLDER
		if (defined('SEARCHVIEW')) {
			$itemIDs = $_SESSION[GALLERY_ID]['search']['itemIDs'];
		}
		elseif($display === 'lastimported') {
			$itemIDs = $this->getLastImportedIDs();
		}
		elseif($display === 'bookmarked') {
			$itemIDs = $this->selectIndexDB(true, 'all_items', 15, 31);
		}
		else {
			$itemIDs = $this->selectIndexDB($this->folderID, 'all_items', 1, $this->imageSortMode);
		}

		// ONE ITEM ONLY?
		if (($totalImages = count($itemIDs)) < 2) return array(1, -1, -1);

		// NUMBER OF FOLDERS - CATEGORIES, SEARCH MODE OR ADMIN
		$cfolders = (($this->foldersetting & 1024) || defined('SEARCHVIEW') || defined('USER_ADMIN'))?
						0
						:
						count($this->selectIndexDB($this->folderID, 'all_folders', 1));

		// CALCULATE CURRENT IMAGE AND PAGE
		$currPage = 1;
		$currItem = 0;
		$itemCols = $this->getThumbCols($this->folderID);	// values {1 ... n}
		$itemRows = $this->getThumbRows($this->folderID);	// values {1 ... n}
		if (($i = array_search($itemID, $itemIDs, true)) !== false) {
			$currItem = $i + 1;
			$currPage = (int)ceil(($currItem + $cfolders) / ($itemCols * $itemRows));
		}

		// GET LINK BUILDING FUNCTION
		$buildLink = defined('USER_ADMIN') ? '_buildAdminLink':'_buildGalleryLink';

		// NAVIGATION LINKS
		$links['first'] = ($itemIDs[0] != $itemID)?
								$this->$buildLink($itemIDs[0])
								:
								false;
		$links['prev']  = (isset($itemIDs[$currItem - 2]))?
								$this->$buildLink($itemIDs[$currItem - 2])
								:
								false;
		$links['next']  = (isset($itemIDs[$currItem]))?
								$this->$buildLink($itemIDs[$currItem])
								:
								false;
		$links['last']  = ($itemIDs[$totalImages - 1] != $itemID)?
								$this->$buildLink($itemIDs[$totalImages - 1])
								:
								false;

		// ITEM NUMBER OF TOTAL
		$this->nav_this = sprintf('%d %s %d', $currItem, $this->lang['of'],	$totalImages);

		if ($this->navtype & 16) {
			if ($this->navtype & 1) $this->text_imagenavigation($links);
			if ($this->navtype & 2) $this->icon_imagenavigation($links);
			if ($this->navtype & 4) $this->thumb_imagenavigation($currItem, $itemIDs, $thumbset);
		}

		return array(
					$currPage,
					($links['prev'])? $itemIDs[$currItem - 2]:-1,	// prev item id
					($links['next'])? $itemIDs[$currItem]:-1			// next item id
				);
	}

	// kh_mod 0.4.2, changed
	function _buildAdminLink($itemID) {
		return sprintf('<a href="%s?dialog=editItem&amp;iID=%s&amp;display=%s">%%s</a>',
					 ADMIN_INDEX,
					 $itemID,
					 $GLOBALS['display']
				 );
	}

	// kh_mod 0.4.0 b4, add
	function _buildGalleryLink($itemID) {
		return sprintf('<a href="%s">%%s</a>', $this->getGalleryLink(array('iID'=>$itemID)));
	}

	//
	// IMAGE NAVIGATION BY TEXTSTRING
	// kh_mod 0.4.0 b4, changed
	function text_imagenavigation($links) {
		// FIRST IMAGE
		$this->nav_first = ($links['first'])?
								 sprintf($links['first'], $this->lang['first'])
								 :
								 $this->lang['first'];

		// PREV IMAGE
		$this->nav_prev = ($links['prev'])?
								sprintf($links['prev'], $this->lang['prev'])
								:
								$this->lang['prev'];

		// NEXT IMAGE
		$this->nav_next = ($links['next'])?
								sprintf($links['next'], $this->lang['next'])
								:
								$this->lang['next'];

		// LAST IMAGE
		$this->nav_last = ($links['last'])?
								sprintf($links['last'], $this->lang['last'])
								:
								$this->lang['last'];
	}

	//
	// IMAGE NAVIGATION BY ICONS
	// kh_mod 0.4.0 b4, changed
	function icon_imagenavigation($links) {

		// GET NAVIGATION ICON PATH
		$iconpath = (defined('USER_ADMIN'))?
						ADMIN_IMAGES
						:
						SKIN_IMAGES;

		// SET NAVIGATION NAMES
		$navigation = array ('first' => 'nav_first',
									'prev'  => 'nav_prev',
									'next'  => 'nav_next',
									'last'  => 'nav_last'
								  );

		// BUILD NAVIGATION ICONS
		foreach ($navigation as $key=>$item) {
			// NAVIGATION ITEM INACTIV
			if ($links[$key]) {
				$icon  = $iconpath . $key .'_activ.gif';
				$size	 = is_readable($icon) ? getimagesize($icon):array(3=>'');
				$image = sprintf('<img class="icon" src="%s" %2$s alt="%3$s" title="%3$s" />',
								$icon,
								$size[3],
								$this->lang[$key]
							);
				$this->$item = sprintf($links[$key], $image);
			}
			// NAVIGATION ICON INACTIV OR NOT EXIST
			else {
				$icon  = $iconpath . $key .'_inactiv.gif';
				$size  = is_readable($icon) ? getimagesize($icon):array(3=>'');
				$image = sprintf('<img class="icon" src="%s" %s alt="" />',
								$icon,
								$size[3]
							);
				$this->$item = $image;
			}
		}
	}

	//
	// ITEM NAVIGATION BY THUMBS
	// kh_mod 0.2.0, add; 0.4.0 b4 changed
	function thumb_imagenavigation($currItem, $itemIDs, $thumbset) {

		// SET THUMB NUMBER AND SIZE
		$nthumbs = 5;		// default displayed nav thumbs total
		$sizeper = 40;		// default size (percent of thumb)
		$poscurr = 3;		// default position of current thumb
		$isuffix = '';		// image suffix
		if (is_array($thumbset)) {
			$nthumbs = ($thumbset['num'] < 1)? 0:$thumbset['num'];
			$sizeper = ($thumbset['div'] < 5)? 5:$thumbset['div'];
			$poscurr = (int)ceil($nthumbs/2);
		}
		elseif (defined('USER_ADMIN')) {
			$sizeper = 32;
			$isuffix = (string)('?'. rand(0,10000));
		}

		// GET START AND END INDEX
		$totalItems = count($itemIDs);
		$idx = max($currItem - $poscurr, 0);
		if ($idx + $nthumbs < $totalItems) {
			$end = $idx + $nthumbs;
		}
		else {
			$end = $totalItems;
			$idx = max($end - $nthumbs, 0);
		}

		// NAVIGATION TAGS
		$navLink = defined('USER_ADMIN') ?
					  '<a href="'.ADMIN_INDEX.'?dialog=editItem&amp;iID=%%5$s&amp;display='.$GLOBALS['display'].'">%s</a>'
					  :
					  '<a href="%%5$s">%s</a>';
		$navTag  = '<img class="%1$s" src="./%2$s'.$isuffix.'" %3$s title="%4$s" alt="%4$s" />';

		// CREATE THUMB NAVIGATION LINE
		$maxHeight = 0;
		$navItems  = array();
		for (; $idx < $end; $idx++) {

			// CURRENT ITEM ID
			$currID = (int)$itemIDs[$idx];

			// GET THUMB FILE
			list(
				$thumbID,
				$thumbFile,
				$thumbWidth,
				$thumbHeight
			) = $this->getFileIcon($currID);

			// THUMB SIZE ATTRIBUTE
			$thumbSize = sprintf('width="%d" height="%d"',
								 max((int)round($thumbWidth/100 * $sizeper,  0), 5),
								 max((int)round($thumbHeight/100 * $sizeper, 0), 5)
							 );

			// THUMB TITLE
			$title = ($idx+1) .' '. $this->lang['of'] .' '. $totalItems;

			// SAVE THUMB ATTRIBUTES
			if ($currItem === $idx+1) {
				$thumbHeight += 1;	// prefer the active one
				$navItems[$idx]['tags']	  = $navTag;
				$navItems[$idx]['values'] = array('activ', $thumbFile, $thumbSize, $title);
			}
			// NOT DISPLAYED ITEM (0...DEFAULT ICON, -1...NOT READABLE FILE)
			elseif ($thumbID > -1) {
				$navItems[$idx]['tags']	  = sprintf($navLink, $navTag);
				$navItems[$idx]['values'] = array('inactiv',
															 $thumbFile,
															 $thumbSize,
															 $title,
															 defined('USER_ADMIN') ?
															 $currID
															 :
															 $this->getGalleryLink(array('iID'=>$currID))
													 );
			}
			else continue;

			// GET THE HIGHEST THUMB
			if ($maxHeight < $thumbHeight) { $maxHeight = $thumbHeight; $maxItem = $idx; }
		}

		// CSS CLASS VALUE FOR THE HIGHEST THUMB
		$navItems[$maxItem]['values'][0].= ' highest';

		$this->nav_this = '';
		$delimiter		 = '';
		foreach ($navItems as $idx=>$navItem) {
			$this->nav_this.= $delimiter;
			$this->nav_this.= vsprintf($navItem['tags'], $navItem['values']);
			$delimiter		 = "&nbsp;\n";
		}
	}

	//
	// BUILD METATAG TITLE
	// kh_mod 0.2.0, add; 0.4.0 b4, changed
	function getPagetitle($folderID, $itemID, $delimiter=' - ') {

		// INIT RETURN VALUE
		$pagetitle = array();

		// GET TITEL ITEMS
		$gallerytitle = trim($this->gallerytitle);
		$gallerytitle = (empty($gallerytitle))?
							 ucfirst($this->lang['gallery'])
							 :
							 strip_tags($gallerytitle);
		$foldername	  = (array_key_exists($folderID, $this->all_folders))?
							 trim($this->all_folders[$folderID][2])
							 :
							 '';
		if (array_key_exists($itemID, $this->all_items)) {
			$imagetitle = trim($this->all_items[$itemID][2]);
			$filename	= $this->getFileName($itemID);
		}
		else {
			$imagetitle = $filename = '';
		}

		// BUILD METATAG TITLE
		if ($this->metasetting & 1)						$pagetitle[1] = strip_tags($gallerytitle);
		// FOLDER NAME
		if ($this->metasetting & 2) {
			if		 ($foldername)								$pagetitle[2] = strip_tags($foldername);
			elseif ($folderID === 1)						$pagetitle[1] = strip_tags($gallerytitle);
		}
		// FILE NAME
		if ($this->metasetting & 4 && $filename)		$pagetitle[3] = $filename;
		// IMAGE TITLE
		if ($this->metasetting & 8 && $imagetitle)	$pagetitle[4] = $imagetitle;

		// BUILD METATAG TITLE, kh_mod 0.4.1, changed
		return $this->htmlchars2entities(implode($delimiter, $pagetitle), ENT_QUOTES);
	}

	//
	// CREATE METATAG TITLE
	// kh_mod 0.3.0, add, 0.4.0 b4 changed
	function getFileName($itemID) {

		$filename = trim($this->all_items[$itemID][6]);

		// ORIGINAL BUT FIRST CAPITAL
		if (($this->layoutsetting & 128) === 128) {
			$filename = ucfirst($filename);
		}

		// FIRST CAPITAL ONLY
		elseif (($this->layoutsetting & 256) == 256) {
			$filename = ucfirst(strtolower($filename));
		}

		// ALL CAPITALS
		elseif (($this->layoutsetting & 384) === 384) {
			$filename = strtoupper($filename);
		}

		// ALL LOWER CASES
		elseif (($this->layoutsetting & 512) === 512) {
			$filename = strtolower($filename);
		}

		// WITHOUT EXTENSION?
		if (~$this->layoutsetting & 1024)
			$filename = substr($filename,0,strrpos($filename,'.'));

		return $filename;
	}

	//
	// PROVIDES THE EXTENSION OF AN ITEM
	// kh_mod 0.4.5, add
	function getFileExtension($itemID) {
		return substr(strrchr($this->all_items[$itemID][6], '.'), 1);
	}

	//
	// GET CONTENT TYPE
	// kh_mod 0.4.0 b3, add, 0.4.5 changed
	function getContentType($itemID, $type=NULL) {

		// EXISTS ITEM ID
		if (!isset($this->all_items[$itemID])) return false;

		// GET TYPE CODE OF CONTENT ITEM
		if (!$typeCode = (int)$this->all_items[$itemID][16] & 4095) {
			$filePath  = $this->getFilePathByID($itemID);
			$imageType = array(1=>'gif',2=>'jpg',3=>'png');
			if (is_file($filePath) && ($fileInfo = getimagesize($filePath))) { 	// takes about 0.2 sec. for 50 MB
				$fileExt = $imageType[$fileInfo[2]];										// video or sound file!
			}
			else {
				$fileExt = $this->getFileExtension($itemID);
			}
			$typeCode = $this->getContentCode($fileExt);
		}

		// SPLIT TYPE CODE IN FORMAT SECTIONS
		$formats = array (
			($typeCode &   63) => 'base',  	// base format
			($typeCode &  448) => 'meta',  	// meta format
			($typeCode & 3584) => 'plugin' 	// needed plug-in
		);

		// LOOK UP ONE FORMAT ONLY
		if (isset($type)) {
			$code = $this->contentCodeTable($type);
			return (isset($formats[$code]))? true:false;
		}
		// GET ALL ITEM FORMATS
		else {
			$contentTypes = array();
			foreach ($this->contentCodeTable() as $type=>$code) {
				if (isset($formats[$code])) $contentTypes[$type] = $code;
			}
			return $contentTypes;
		}
	}

	//
	// GET CONTENT TYPE CODE
	// kh_mod 0.4.0 b3, add
	function getContentCode($fileExt) {

		// GET BASE (EXTENSION) CODE
		$baseCode = $this->contentCodeTable($fileExt);

		// BUILD TYPE CODE
		switch ($baseCode) {
			case  1:
			case  2:
			case  3:
			case  4:
			case  6: $typeCode =	$baseCode + 64;			// image format
						break;
			case 16:
			case 17: $typeCode =	$baseCode + 128 +  512;	// audio format and flash
						break;
			case 32:
			case 33:
			case 34:
			case 35:
			case 36: $typeCode =	$baseCode + 192 +  512;	// video format and flash
						break;
			case 48:
			case 49: $typeCode =	$baseCode + 256;			// text/xhtml/html plain text
						break;
			case 50:
			case 51: $typeCode =	$baseCode + 256 + 2048;	// xhtml/html/pdf document and iFrame
						break;
			default: $typeCode = 0;
		}

		return $typeCode;
	}

	//
	// TABLE OF FILE TYPES
	// kh_mod 0.4.0 b3, add; 0.4.1 changed
	function contentCodeTable($type=NULL) {

		// CODE TABLE
		$codeTable = array (
							'gif'		  =>    1,	// 1 upto 15, images
							'jpg'		  =>    2,
							'jpeg'	  =>    2,
							'png'		  =>    3,
							'webp'	  =>    4,
							'svg'		  =>    6,
							'mp3'		  =>   16,	// 16 upto 31, audio
							'ogg'		  =>   17,
							'mp4'		  =>   32,	// 32 upto 47, video
							'flv'		  =>   33,
							'swf'		  =>   34,
							'mov'		  =>   35,
							'ogv'		  =>   36,
							'txt'		  =>   48,	// 48 upto 63, text
							'text'	  =>   48,
							'htm'      =>   49,
							'html'     =>   49,
							'website'  =>   50,
							'pdf'      =>   51,
							'img'		  =>   64,	// meta formats
							'image'	  =>   64,
							'audio'	  =>  128,
							'video'	  =>  192,
							'document' =>  256,	
							'flash'    =>  512,	// displaying
							'lbox'     => 1024,
							'lightbox' => 1024,
							'iframe'   => 2048
						 );

		// LOOK UP ONE FORMAT ONLY
		if (isset($type)) {
			$type = strtolower($type);
			return (isset($codeTable[$type]))? $codeTable[$type]:false;
		}
		// RETURN CODE TABLE
		else {
			return $codeTable;
		}
	}

	//
	// GET ATTRIBUTES OF A SKIN IMAGE BY NAME
	// kh_mod 0.4.3, changed
	function getImgAttributes($imageName) {

		// GET IMAGE ATTRIBUTES
		$buttonInf = is_readable(SKIN_IMAGES . $imageName) ?
						 getimagesize(SKIN_IMAGES . $imageName)
						 :
						 false;

		if ($buttonInf) {
			$imageName	 = rawurlencode($imageName);
			$imageWidth  = $buttonInf[0];
			$imageHeight = $buttonInf[1];
		}
		else {
			$imageName	 = '1x1.gif';
			$imageWidth  = 0;
			$imageHeight = 0;
		}

		return array(
					SKIN_IMAGES . $imageName,	// URL image path
					$imageWidth,
					$imageHeight
				 );
	}

	//
	// GALLERY NAVIGATION
	// kh_mod 0.4.0 b4, changed
	function getBreadCrumbNav($folderID) {

		// INIT NAVIGATION PATH
		$navPath = array();

		// IF SEARCH MODE
		if (defined('SEARCHVIEW')) {
			$navItem = $_SESSION[GALLERY_ID]['search']['navItem'];
			if (defined('FOLDERVIEW')) {
				$navPath[] = $navItem;								// no link
			} else {
				$this->all_folders[$folderID][2] = $navItem;	// link
			}
		}

		// BUILD NAVIGATION LINKS
		do {
			if (!array_key_exists($folderID, $this->all_folders))	break;

			$folderRC	= $this->all_folders[$folderID];
			$folderName = (empty($folderRC[2]))?
								$this->lang['gallery']
								:
								$folderRC[2];

			$navPath[$folderID] = sprintf('<a href="%s">%s</a>',
											$this->getGalleryLink(array('fID'=>$folderID)),
											strip_tags($folderName)
										 );
			$folderID = $folderRC[1];
			if (!empty($navPath[$folderID])) 							break;	// circle reference!
		}
		while ((int)$folderID > 0);

		// SET LINK TO MAINPAGE, kh_mod 0.3.1, changed
		if (!empty($this->websitelink) && !$this->string_empty($this->websitetext))
			$navPath[] = '<a href="'. $this->websitelink .'" target="_top">'. $this->websitetext .'</a>';

		return array_reverse($navPath);
	}

	//
	// PAGE NAVIGATION
	// kh_mod 0.3.0, changed
	function pageNavigation($folderID, $npages, $page=0, $delim=' | ') {
		if ($npages < 2) return '';

		// INITIALISE VALUES
		$navlink = '<a href="%s">%s</a>';
		$navarr  = array($this->lang['page']);

		// GENERATE PAGE LINKS
		for ($i=1; $i <= $npages; $i++) {
			if ($page === $i) {
				$navarr[] = $i;
			} else {
				$query	 = array('fID'=>$folderID,'page'=>$i);
				$navarr[] = sprintf($navlink, $this->getGalleryLink($query), $i);
			}
		}

		// ALL PAGES LINK
		if ($page === 'all') {
			$navarr[] = $this->lang['all'];
		} else {
			$query	 = array('fID'=>$folderID, 'page'=>'all');
			$navarr[] = sprintf($navlink, $this->getGalleryLink($query),$this->lang['all']);
		}

		// BUILD NAVIGATION STRING
		return implode($delim, $navarr);
	}

	//
	// GET THE ICON FOR AN IMAGE-, FLASH- OR SOUND-FILE
	// kh_mod 0.4.0, add
	function getFileIcon($itemID, $contentType=null, $useImage=false) {

		// DEFAULT VALUES
		$iconID   = $itemID;
		$iconFile = '';

		// GET SKIN IMAGE PATH
		$skinImagePath = defined('USER_ADMIN') ?
							  ADMIN_IMAGES
							  :
							  SKIN_IMAGES;

		// IF SET CONTENT TYPE NOT YET
		if (!isset($contentType)) $contentType = $this->getContentType($itemID);

		do {
			do {
				// IF ITEM 'IMAGE'
				if (isset($contentType['image'])) {
					$iconType = isset($contentType['svg']) ? 'item':'thumb';
					break;
				}

				// IF SET AND EXISTS SPLASH ICON
				$Splashes = &$this->getInstance('MG2Splashes');
				$iconID	 = $Splashes->getSplashID($itemID);
				if (isset($this->all_items[$iconID])) {
					$svgFlag  = $this->contentCodeTable('svg');
					$iconType = (($this->all_items[$iconID][16] & $svgFlag) === $svgFlag)?
									'item'
									:
									'thumb';
					break;
				}

				// GET DEFAULT FLASH ICON
				$iconID = 0;
				if (isset($contentType['video'])) {
					$iconFile	= $skinImagePath .'video.gif';
					$iconInfo   = getimagesize($iconFile);
					$iconWidth  = $iconInfo[0];
					$iconHeight = $iconInfo[1];
				}
				elseif (isset($contentType['audio'])) {
					$iconFile	= $skinImagePath .'audio.gif';
					$iconInfo   = getimagesize($iconFile);
					$iconWidth  = $iconInfo[0];
					$iconHeight = $iconInfo[1];
				}
				break 2;
			}
			while(0);

			// ITEM 'IMAGE' OR IF SET SPLASH ICON, 0.4.5 changed
			$iconFile   = $this->getFilePathByID($iconID, $iconType);
			$iconWidth  = (int)$this->all_items[$iconID][10];
			$iconHeight = (int)$this->all_items[$iconID][11];
			if ($iconWidth < 1 || $iconHeight < 1)		  break;

			// DOES NOT EXIST THUMB PICTURE?
			if($useImage && !is_readable($iconFile)) {
				$iconFile = $this->getFilePathByID($iconID, 'medium');
				// DOES NOT EXIST MEDIUM PICTURE?
				if(!is_readable($iconFile)) {
					$iconFile = $this->getFilePathByID($iconID);
				}
			}
		}
		while(0);

		// CHECK ICON FILE
		if (!is_readable($iconFile)) {
			$iconID		= -1;
			$iconFile   = $skinImagePath .'1x1.gif';
			$iconWidth  = $this->thumbMaxWidth;
			$iconHeight = $this->thumbMaxHeight;
		}

		return array (	$iconID,
							$this->cleanURLString($iconFile),
							$iconWidth,
							$iconHeight
				 );
	}

	//
	// GET FOLDER ICON
	// kh_mod 0.3.2, changed
	function getFolderIcon($folderID) {

		$thumbID = ($this->foldersetting & 16)?	// global default folder icon?
					  0
					  :
					  (int)$this->all_folders[$folderID][6];

		do {
			// IF SET IMAGE THUMBNAIL
			if ($thumbID > 0 && ($iconFile = $this->getThumbIcon($thumbID)))					break;

			// DEFAULT PASSWORD ICON
			if (strlen(trim($this->all_folders[$folderID][8])) === 32) {
				$iconFile = $this->getPasswordIcon();													break;
			}

			// RANDOM, LATEST OR FIRST IMAGE
			if ($thumbID < 0 && ($iconFile = $this->getRandomIcon($folderID, $thumbID)))	break;

			// DEFAULT FOLDER ICON
			$iconFile = $this->getDefaultIcon($folderID);
		}
		while(0);

		// RETURN ICON FILE, kh_mod 0.4.4, changed
		return array ( $this->cleanURLString($iconFile['file']),
							$iconFile['width'],
							$iconFile['height'],
							$iconFile['class']
				 );
	}

	//
	// GET THUMBNAIL AS FOLDER ICON
	// kh_mod 0.3.0, add, add, 0.4.0 rc1 changed
	function getThumbIcon($thumbID) {

		// GET THE ICON PATH
		$icon = $this->getFilePathByID($thumbID, 'thumb');

		// IF ICON PATH VALID
		return ($icon !== false || is_file($icon))?
				 array(
					'file'   => $icon,
					'width'  => (int)$this->all_items[$thumbID][10],
					'height' => (int)$this->all_items[$thumbID][11],
					'class'  => 'subfolder border'
				 )
				 :
				 false;
	}

	//
	// GET DEFAULT ICON FOR SET FOLDER PASSWORD
	// kh_mod 0.3.0, add, add, 0.4.0 final changed
	function getPasswordIcon() {
		$iconFile = SKIN_IMAGES .'locked.gif';
		$fileInfo = getimagesize($iconFile);
		return array(
					'file'   => $iconFile,
					'width'  => $fileInfo[0],
					'height' => $fileInfo[1],
					'class'  => 'subfolder'
				 );
	}

	//
	// GET RANDOM, LATEST OR FIRST IMAGE AS FOLDER ICON
	// kh_mod 0.3.0, add, 0.4.0 rc1 changed
	function getRandomIcon($subfolderID, $thumbID) {

		// NO ITEMS IN SUBFOLDERS?
		if (count($this->itemAllocation[$subfolderID]) < 1) return false;

		// INIT VALUES
		$thumbID  = abs($thumbID);
		$itemIDs  = array();
		$iconFile = false;

		// INCL. SUB FOLDERS?
		$subfolderIDs = ($thumbID & 8)?
							 $this->folderStructure[$subfolderID]
							 :
							 array($subfolderID=>1);

		// REMOVE PASSWORD PROTECTED FOLDERS
		foreach ($subfolderIDs as $id=>$level) {
			if (strlen(trim($this->all_folders[$id][8])) === 32) unset($subfolderIDs[$id]);
		}

		do {
			// NO SUBFOLDERS WITHOUT PASSWORD PROTECTION?
			if (count($subfolderIDs) < 1)	break;

			// RANDOM OR LATEST IMAGE
			if ($thumbID & 5) {
				$itemIDs = array_keys(array_intersect(
													$this->itemAllocation[$subfolderID],
													array_keys($subfolderIDs)
											));

				($thumbID & 1)?
					// RANDOM IMAGE, SHUFFLE
					shuffle($itemIDs)
					:
					// LATEST IMAGE, ORDER BY DATE, DESC
					$this->sortIndexDB($itemIDs, 'all_items', 20);

				break;
			}

			// IF FIRST IMAGE
			$level	 = 1;
			$sortmode = $this->getFolderSortMode((int)$this->all_folders[$subfolderID][7]);
			while ($fIDs = array_keys($subfolderIDs, $level++)) {
				$this->sortIndexDB($fIDs, 'all_folders', $sortmode); // sort fIDs on the same level
				foreach ($fIDs as $fID) {
					if (!$itemIDs = array_keys($this->itemAllocation[$subfolderID], $fID)) continue;
					$this->sortIndexDB($itemIDs, 'all_items', (int)$this->all_folders[$fID][7]);
					break 2;
				}
			}
		}
		while(0);

		// DOES FOLDER CONTAIN ITEMS
		while($itemID = array_shift($itemIDs)) {

			// GET THE ICON PATH
			$icon = $this->getFilePathByID($itemID, 'thumb');

			// IF ICON PATH INVALID
			if ($icon === false || !is_file($icon)) continue;

			$iconFile = array(
								'file'   => $icon,
								'width'  => (int)$this->all_items[$itemID][10],
								'height' => (int)$this->all_items[$itemID][11],
								'class'  => 'subfolder border'
							);
			break;
		}

		return $iconFile;
	}

	//
	// GET DEFAULT ICON
	// kh_mod 0.3.0, add, 0.4.0 final changed
	function getDefaultIcon($subfolderID) {

		$iconFile = ($this->itemAllocation[$subfolderID])?
						SKIN_IMAGES .'folder.gif'			// folder not empty
						:
						SKIN_IMAGES .'emptyfolder.gif';	// folder empty
		$fileInfo = getimagesize($iconFile);
		return array(
					'file'   => $iconFile,
					'width'  => $fileInfo[0],
					'height' => $fileInfo[1],
					'class'  => 'subfolder'
				 );
	}

	//
	// GET FOLDER NAME
	// kh_mod 0.4.1, changed
	function getFolderName($folderID, $html=false) {

		if ((int)$this->all_folders[$folderID][0] === 1)
			$folderName = $this->lang['root'];
		elseif (empty($this->all_folders[$folderID][2]))
			$folderName = '???';
		else
			$folderName = trim($this->all_folders[$folderID][2]);

		return $html ?
				 $this->htmlchars2entities(strip_tags($folderName))
				 :
				 $folderName;
	}

	//
	// READ FOLDER SETTINGS
	// kh_mod 0.4.1, changed
	function getFolderSettings($folderID) {

		// GET SETTINGS
		$folderRC = $this->all_folders[$folderID];
		$this->folderID	  	 = $folderID;
		$this->folderParentID = ($folderID > 1)?
										(int)$folderRC[1]
										:
										'root';
		$this->folderPublish  = (isset($folderRC[4]))?
										(int)$folderRC[4]
										:
										0;
		$this->folderPosition = (isset($folderRC[5]))?
										(int)$folderRC[5]
										:
										1;
		$this->imageSortMode	 = ((int)$folderRC[7] >= 0)?
										(int)$folderRC[7]
										:
										6;	// sort by name, ascending
		$this->folderSortMode = $this->getFolderSortMode();

		return true;
	}

	//
	// GET THUMB ROWS PER PAGE
	// kh_mod 0.4.0 rc1, add
	function getThumbCols($folderID) {

		$itemCols = ((int)$this->all_folders[$folderID][9] < 1)?
						(int)$this->itemThumbCols						// global setting
						:
						(int)$this->all_folders[$folderID][9];		// folder setting

		return max($itemCols, 1);	
	}

	//
	// GET THUMB ROWS PER PAGE
	// kh_mod 0.4.0 rc1, add
	function getThumbRows($folderID) {

		$itemRows = ((int)$this->all_folders[$folderID][10] < 1)?
						(int)$this->itemThumbRows						// global setting
						:
						(int)$this->all_folders[$folderID][10];	// folder setting

		return max($itemRows, 1);
	}

  /**
	* The function 'getValidSubfolders' expects a verified and valid $currentID.
	* This means that the related folder has to be valid. If this impossible, so
	* the $currentID has to be verified before the foreach loop runs, e.g.:
	* if (!isset($this->all_folders[$currentID])) return $subfolder;
	*
	* @access public
	* @return array Resulting array contains all valid sub folder IDs
	* @since   kh_mod 0.3.1a
	* @changed kh_mod 0.4.1
	*/
	function getValidSubfolders($currentID, $structure='struct') {

		// INIT VALUES
		$currentID  = ($currentID === 'all')? 1:(int)$currentID;				// 1 - means root folder
		$subfolders = array('struct'=>false, 'unstruct'=>false);				// sub folders hierarchic
		$folderpath	= array(0=>0);														// top of folder hierarchy

		// RUN THE WHOLE FOLDER DATABASE
		foreach (array_keys($this->all_folders) as $key) {
			$forbidden			= $folderpath;											// save forbidden folders
			$folderpath[$key] = $key;													// keep current folder id
			$folderID			= $key;													// to inspect folder id
			$level				= 0;														// sub folder level

			// GET PATH UPTO CURRENT ID FOR EACH FOLDER
			do {
				if ($folderID === $currentID)	{
					$subfolders['struct'][end($folderpath)][$key] = $level;	// get folder indices hierarchic
					$subfolders['unstruct'][$key]                 = $level;	// get folder indices in one array
					$folderpath = $forbidden;											// reset forbidden sub folders
					break;
				}

				$folderpath[$folderID] = $folderID;									// keep current folder id
				$folderID = (int)$this->all_folders[$folderID][1];				// get parent folder id
				if (isset($folderpath[$folderID]))			break;				// circle data or folder id == 0
				$level++;
			}
			while (isset($this->all_folders[$folderID]));
		}

		return ($structure === 'both')?
				 $subfolders
				 :
				 $subfolders[$structure];
	}

	//
	// SELECT ALL ITEM IDs INCL. IN SUB FOLDERS
	// kh_mod 0.3.1a, add, 0.4.0 b4 changed
	function getItemAllocation($subfolders) {

		// INIT ARRAY OF ITEMS IN SUB FOLDERS
		$itemIDs = array();

		// IS SUBFOLDERS EMPTY
		if (empty($subfolders)) return $itemIDs;

		// IN PHP 5.2 OR ABOVE BETTER 'array_fill_keys'
		foreach ($subfolders as $folderID=>$subs) {
			$itemIDs[$folderID] = array();
		}

		// SELECT ITEMS OF EACH SUB FOLDER
		foreach ($this->all_items as $itemID=>$record) {
			$parentID = (int)$record[1];
			foreach ($subfolders as $folderID=>$subs) {
				// SAVE AND GO TO NEXT ITEM ID
				if (isset($subs[$parentID])) {
					$itemIDs[$folderID][$itemID] = $parentID; break;
				}
			}
		}

		// NUMBER OF ITEMS
		return $itemIDs;
	}

	//
	// JAVASCRIPT VERIFY FOR COMMENTS
	// kh_mod 0.1.0, add; 0.4.0 b4, changed
	function jsformvalid() {
		$validpath = INC_FOLDER .'mg2_jsformvalid.php';
		return (($this->commentsets & 128) && is_readable($validpath))?
				 include($validpath)
				 :
				 false;
	}

	//
	// GET GD LIB VERSION
	//
	function gd_version() {
		$gdInfo = gd_info();
		$this->gd_version_number = trim(preg_replace('/[a-z()]/i', '', $gdInfo['GD Version']));	// kh_mod 0.1.0, changed
		return $this->gd_version_number;
	}

	// kh_mod 0.1.0 rc1, add, 0.4.1 changed
	function checkLanguage($lang, $user='gallery') {
		$langPath = sprintf('%s%2$s/%2$s.%%s.php', LANG_FOLDER, $lang);
		$testPath = sprintf($langPath, $user);
		return (empty($lang) || !is_readable($testPath))?
				 false
				 :
				 $langPath;
	}

	//
	// CHECK GALLERY FOLDER ACCESS PERMISSION
	// kh_mod 0.4.2, changed
	function checkGalleryPassword($folderID, $fIDstoRoot) {

		// IF ADMIN MODE
		if (!empty($_SESSION[GALLERY_ID]['adminmode']) &&
			$_SESSION[GALLERY_ID]['adminmode'] === $this->adminpwd)	return true;

		// INIT RETURN VALUE
		$permitted = true;

		// CHECK FOLDER PASSWORD
		foreach ($fIDstoRoot as $id) {
			$folderPwdHash = trim($this->all_folders[$id][8]);
			if ($folderPwdHash) {
				$sessionName = ($id > 1 && defined('SEARCHVIEW'))?	'keyPwdHash':'fPwdHash';
				$pwdHashID	 = (int)$this->all_folders[$id][0];

				// IF PASSWORD NOT YET SET
				if (!isset($_SESSION[GALLERY_ID][$sessionName][$pwdHashID]) || 
					 $_SESSION[GALLERY_ID][$sessionName][$pwdHashID] !== $folderPwdHash)
				{
					// IF PASSWORD ENTRY CORRECT
					if (isset($_POST['password'])                &&
						 strlen($_POST['password']) <= MAXLEN_PWD &&
						 md5(strrev(md5($_POST['password']))) === $folderPwdHash)
					{
						$_SESSION[GALLERY_ID][$sessionName][$pwdHashID] = $folderPwdHash;
						unset($_POST['password']);
					}
					// SAVE FOLDER ID FOR PASSWORD DIALOG
					else {
						$this->pwdDialogfID  = $id;
						$permitted           = false;
						break;
					}
				}
			}
			if ((int)$this->extendedset & 1) break;	// folder password doesn't include sub foders
		}

		return $permitted;
	}

	//
	// GET BRANCH UPTO ROOT FOLDER AND CHECK INTEGRITY
	// kh_mod 0.4.0 rc1, add
	function getFolderBranchToRoot($folderID, $errorMessage=false) {

		$nextID    = $folderID;
		$branchIDs = array();
		$branchOK  = false;

		while(isset($this->all_folders[$nextID])) {

			$branchIDs[$nextID] = $nextID;
			if ((int)$nextID === 1)	{									// OK, root folder achieved
				$branchOK = true;		 break;
			}

			$nextID = (int)$this->all_folders[$nextID][1];		// parent folder ID
			if (isset($branchIDs[$nextID])) {						// circle reference => 'demaged'
				$branchOK = 'circle'; break;
			}
		}

		// IF FOLDER BRANCH OK THEN RETURN IT ELSE EXIT
		if ($branchOK !== true) {
			if ($errorMessage) {
				if ($folderID === -1) {
					$status = 'nosearch';
				}
				elseif ($branchOK === 'circle') {
					$status = 'demaged';
				}
				elseif (defined('FOLDERVIEW')) {
					$status = 'nofolder';
				}
				else {
					$status = 'noimage';
				}
				$this->notexists($status);	// script exit
			}
			exit;
		}
		else {
			return $branchIDs;
		}
	}

	// kh_mod 0.4.1, changed
	function charfix($string, $trim=false, $html=false) {
		$string = trim($string);

		// REMOVE FURTHER START AND END CHARS
		if ($trim) {
			$string = trim($string, $trim);
		}

		// REPLACE DELIMITER (tab) FOR FLAT FILES
		$string = str_replace("\t", "   ", $string);

		// ELIMINATE MAGIC QUOTS
		if (function_exists('get_magic_quotes_gpc')	&&
			 get_magic_quotes_gpc())
		{
			$string = stripslashes($string);
		}

		return $html ?	// used in'mg2_comments.php'
				 $this->htmlchars2entities($string, ENT_QUOTES)
				 :
				 $string;
	}

	// kh_mod 0.3.0, add
	function cleanLink($link='') {
		$search  = array('<','>','"',' ','\\');
		$replace = array('%3C','%3E','%22','%20','/');
		return str_replace($search, $replace, trim($link));
	}

	//
	// CLEAN URL STRING FOR USING AS LINK
	// kh_mod 0.4.4, add
	function cleanURLString($string) {
		return preg_replace_callback('/[^\/]+/', array($this, 'mg2rawurlencode'), $string);
	}

	//
	// CALL BACK FUNCTION FOR 'cleanURLString'
	// kh_mod 0.4.4, add
	function mg2rawurlencode($matches) {
		return rawurlencode($matches[0]);
	}

	//
	// CLEAN HTML CONTENT, BUT ALLOW NAMED ENTITIES AND SELECTED TAGS
	// kh_mod 0.4.0 b4, add
	function cleanHTMLContent($subject, $allowed=array()) {

		// SPLIT STRING, USE EACH VALID TAG AS DELIMITER
		$chunks = preg_split('/<(\!--.*--|\/?(?=[a-z]{1,10}(?=\s|\/?>)|h[1-6](?=\s|>))[^><]*)>?/i', $subject, -1, PREG_SPLIT_DELIM_CAPTURE);

		// VERIFY SPLITED STRING
		$newContent = '';
		foreach($chunks as $key=>$chunk) {

			$newContent.= ($key % 2)?
							  $this->cleanUpHTMLTag($chunk, $allowed)		// clean or strip forbidden tag
							  :
							  $this->htmlchars2entities($chunk);			// convert '<, > ", &'
		}

		return $newContent;
	}

	//
	// HELPER OF 'cleanHTMLContent'
	// kh_mod 0.4.0 rc1, changed
	function cleanUpHTMLTag($tag, $allowed, $noEvents=true, $noScript=true) {

		if (!$allowed) return '';

		$allowedTags = '/^((?=\!--)|(\/?(?=[a-z])))('. implode('|', $allowed) .')/i';
		$stripStyles = '/\s*style\s*=\s*([\'"])?[^\1]*?(?(1)\1|[^>]*)/i';
		$stripEvents = '/\s*on\w*\s*=\s*([\'"])?[^\1]*?(?(1)\1|[^>]*)/i';
		$stripScript = '/\s*\w+\s*=\s*([\'"])?[^\1]*script\s*:[^\1]*?(?(1)\1|[^>]*)/i';
		$strReplace  = ' ';

		// IF TAG ALLOWED
		if (preg_match($allowedTags, $tag, $treffer) && $treffer[3]) {
			if ($noEvents)					 $tag = preg_replace($stripEvents, $strReplace, $tag);
			if ($noScript)					 $tag = preg_replace($stripScript, $strReplace, $tag);
			if (!defined('USER_ADMIN')) $tag = preg_replace($stripStyles, $strReplace, $tag);
			$tag = sprintf('<%s>', $this->htmlchars2entities(rtrim($tag), ENT_NOQUOTES));
		}
		else {
			$tag = '';
		}
		return $tag;
	}

	//
	// CONVERT SPECIAL CHARECTERS TO HTML ENTITIES WITH "DOUBLE_ENCODE" OPTION
	// kh_mod 0.4.1, changed
	function htmlchars2entities($string, $flags=ENT_COMPAT, $double_encode=false) {

		// IF CHARSET 'Windows-1253' OR 'cp1253' (Greek)
		$charset = (strpos($this->charset, '1253') !== false)?
					  'ISO-8859-1'
					  :
					  $this->charset;

		if (version_compare(PHP_VERSION, '5.2.3', '>=') ) {
			$string = htmlspecialchars($string, $flags, $charset, $double_encode);
		}
		elseif ($double_encode) {
			$string = htmlspecialchars($string, $flags, $charset);
		}
		else {
			$string = $this->htmlspecialcharsFallback($string, $flags);
		}
		return $string;
	}

	// kh_mod 0.4.1, add
	function htmlspecialcharsFallback($string, $flags) {

		$string  = $this->ampers2Entities($string);
		$search	= array('<', '>');
		$replace	= array('&lt;','&gt;');
		if (ENT_NOQUOTES !== $flags) {
			$search[]  = '"';
			$replace[] = '&quot;';
			if (ENT_QUOTES === $flags) {
				$search[]  = '\'';
				$replace[] = '&#039;';
			}
		}
		return str_replace($search, $replace, $string);
	}

	// kh_mod 0.4.0 rc1, add
	function ampers2Entities($string) {
		return preg_replace('/&(?!([a-z]{2,8}[1-4]{0,2};))/i', '&amp;', $string);
	}

	// kh_mod 0.3.1, add
	function setTextAlign($subject, $justify) {

		// SPLIT STRING ON TAGS WITH TEXT-ALIGN, 0.4.0 b4 changed
		$tags = preg_split('/\<([a-z]+\s[^><]*text-align\s*:[^><]*)>?/i', $subject, -1, PREG_SPLIT_DELIM_CAPTURE);

		$regexp	= '/text-align\s*:\s*\w*(\s*;)?/i';
		$replace	= 'text-align:'. $justify .';';
		$result	= '';
		foreach($tags as $key=>$tag) {
			$result.= ($key % 2)?
						 sprintf('<%s>', preg_replace($regexp, $replace, rtrim($tag)))
						 :
						 $tag;
		}
		return ($this->string_empty($tags[0]))?		// no intro text or text begin with align tag
				 $result
				 :
				 sprintf('<div style="text-align:%s;">%s</div>', $justify, $result);
	}

	// kh_mod 0.3.0, add, 0.4.1 changed
	function br2line($string) {
		return $string ?
				 preg_replace('/<br[^>]*>/i', ' ', $string)
				 :
				 '';
	}

	// kh_mod 0.3.1a, add, 0.4.1 changed
	function br2nl($string) {
		return $string ?
				 preg_replace("/<br[^>]*>/i", "\n", $string)
				 :
				 '';
	}

	// kh_mod 0.3.0, add, 0.4.1 changed
	function string_empty($string) {
		return (!$string || preg_match('/^(<[^>]*>|&nbsp;|\s)*$/i', $string))?
				 true
				 :
				 false;
	}

	// kh_mod 0.3.0, add
	function mb_shorten($string, $limit, $wildcard='...') {

		// NO CUTTING
		if ($limit === 0) return $string;

		// START AND END VALUES
		$chars  = abs($limit);
		$prefix = $suffix = '';
		$strip  = trim(strip_tags($string));
		if ($limit > 0) {
			$start  = 0;
			$suffix = $wildcard;
		}
		else {
			$start  = $limit;
			$prefix = $wildcard;
		}
		$wildcard = strip_tags($wildcard);	// strip to calculate lenght

		// CUTTING STRING, kh_mod 0.4.5 changed
		if ($this->getCharsetSupport()
			&& ($lenght = mb_strlen($strip, $this->charset))
			&& ($bonus  = mb_strlen($wildcard, '8bit')) !== false)
		{
			if ($lenght > $chars + $bonus) {
				$string = $prefix . mb_substr($strip, $start, $chars, $this->charset) . $suffix;
			}
		}
		// IF NO 'mbstring' SUPPORT BUT CHARSET IS UTF-8 
		elseif ((strcasecmp($this->charset, 'utf-8'))===0)
		{
			$bonus = strlen(utf8_decode($wildcard));
			$item_latin = utf8_decode($strip);
			if (strlen($item_latin) > $chars + $bonus) {
				$string = utf8_encode($prefix . substr($item_latin, $start, $chars) . $suffix);
			}
		}
		elseif (strlen($strip) > $chars + strlen($wildcard))
		{
			$string = $prefix . substr($strip, $start, $chars) . $suffix;
		}
		return $string;
	}

	// kh_mod 0.4.1 add, 0.4.5 changed
	function getCharsetSupport() {

		if (!isset($this->mbCharsetSupport))
		{
			// INIT $mbCharsetSupport
			$this->mbCharsetSupport = false;

			do {
				if (!extension_loaded('mbstring'))						break;
				if (!$lowerCharset = strtolower($this->charset))	break;
				switch ($lowerCharset) {
					case 'utf-8':
					case 'iso-8859-1':
					case 'iso-8859-15':
					case 'gb2312':
						$this->mbCharsetSupport = true;
				}
			}
			while(0);
		}
		return $this->mbCharsetSupport;
	}

	// kh_mod 0.2.0, add, 0.4.5 changed
	function displayCaptcha($width=250, $height=100, $size=22, $wave=2) {
		if ($width > 500) {
			$width = 500;
		}
		elseif ($width < 100) {
			$width = 100;
		}
		if ($height > 200) {
			$height = 200;
		}
		elseif ($height <  40) {
			$height = 40;
		}
		if ($size > 36) {
			$size = 36;
		}
		elseif ($size < 12) {
			$size = 12;
		}
		$_SESSION[GALLERY_ID]['captcha_width']  = $width;
		$_SESSION[GALLERY_ID]['captcha_height'] = $height;
		$_SESSION[GALLERY_ID]['captcha_size']   = $size;
		$_SESSION[GALLERY_ID]['captcha_wave']   = (int)$wave;
		return sprintf('<input type="image" src="%scaptcha/mg2_captcha.php?gID=%s&amp;rl=%d%s" style="width:%dpx;height:%dpx;border:0" alt="%7$s" title="%7$s" onclick="checkNoForm=true;" />',
						ADDON_FOLDER,
						GALLERY_ID,
						mt_rand(1000,9999),
						SID ? '&amp;'. SID:'',
						$width,
						$height,
						$this->lang['reload_captcha']
				 );
	}

	// kh_mod 0.1.0, changed
	function output($var) {
		echo isset($this->$var) ? $this->$var:'';
	}

	// kh_mod 0.4.0 b4, add
	// z.B. fr $this->imageMap, 
	function outputArray($var, $delimiter='') {
		echo is_array($this->$var) ?
			  implode($delimiter, $this->$var)
			  :
			  '';
	}

	// kh_mod 0.3.1, changed
	function log($entry='', $block=false) {
		$logfile  = DATA_FOLDER .'mg2_log.txt';
		$filesize = (is_file($logfile))? filesize($logfile):-1;

		// ENTRY DATE
		if (!$block) $entry = date('Ymd, H:i:s - ') . $entry . "\n";

		// SHORTEN LARGE LOG FILE
		if ($filesize > 307200 &&									// log file greater than 300 KB
			($content = file($logfile)))							// read file into array
		{
			$filesize = 0;												// write a new file head
			$content	 = array_slice($content, max(count($content) - 360, 0));
			$entry	 = implode('', $content) . $entry;
			unlink($logfile);
		}
		// CHECK FILE STATUS
		elseif (($filesize !== -1)			&&						// file exists
					!is_writeable($logfile)	&&						// but isn't writeable
					!chmod($logfile, 0666)	&&						// chmod don't work
				  ($content = file_get_contents($logfile)))	// but file is readable
		{
			$entry = $content . $entry;
			unlink($logfile);
		}

		// ADD LOG ENTRY
		if ($filesize > 0) {
			$fp = fopen($logfile, 'a+');
		}
		// CREATE NEW LOGFILE
		else {
			$head  = "MG2/kh_mod LFS (Log File System)\n\n";
			$head .= "Version: 0.5.1/{$this->modversion}\n";
			$head .= "Install date: " . date("Y-m-d", $this->installdate);
			$head .= "\n\n------------------ LOG BEGIN ------------------\n\n";
			$entry = $head . $entry;
			$fp = fopen($logfile, 'wb');
		}
		// WRITE NEW LOG FILE
		if (is_resource($fp)) {
			flock($fp, LOCK_EX);	// do an exclusive lock
			fwrite($fp, $entry);
			flock($fp, LOCK_UN);	// release the lock
			fclose($fp);
		}
	}

	//
	// BUILD FILE PATH FOR CONTENT ITEMS BY ID
	// kh_mod 0.4.0 rc1 add
	function getFilePathByID($itemID, $type='item') {
		$fname  = trim($this->all_items[$itemID][6]);
		$subdir = trim($this->all_items[$itemID][7]);

		return $this->getFilePathByName($fname, $subdir, $type);
	}

	//
	// BUILD FILE PATH FOR CONTENT ITEMS BY NAME
	// kh_mod 0.2.0, add, 0.4.0 rc1 changed
	function getFilePathByName($fname, $subdir, $type='item') {
		$ext = strrchr($fname, '.');
		$len = strlen($ext);
		if ($len > 1) {
			$path = $this->imagefolder . $subdir .'/';
			switch ($type) {
				case 'item':	return $path . $fname;
				case 'medium':	return $path . substr($fname, 0, -$len) .'_medium'. $ext;
				case 'thumb':	return $path . substr($fname, 0, -$len) .'_thumb'. $ext;
				case 'comment':return $path . $fname .'.comment';
			}
		}
		return false;
	}

	//
	// CONVERT DATE TO TIMESTAMP
	// kh_mod 0.1.0 b3, add, 0.3.1 changed
	function date2time($date='') {
		if (trim($date) === '')	return false;	// kh_mod 0.4.0 rc1, changed

		// ALLOW DATE FORMATS
		$regexp1 = '/(%d|%e)([^%]*)(%b|%m|%n)([^%]*)(%y|%Y)/';	// DAY, MONTH, YEAR
		$regexp2 = '/(%b|%m|%n)([^%]*)(%d|%e)([^%]*)(%y|%Y)/';	// MONTH, DAY, YEAR
		$regexp3 = '/(%y|%Y)([^%]*)(%b|%m|%n)([^%]*)(%d|%e)/';	// YEAR, MONTH, DAY

		// CHECK DATE FORMAT AND SET NEW ORDER (YEAR, MONTH, DAY)
		if (preg_match($regexp1, $this->dateformat, $item)) {
			$res = array(3,2,1);
		}
		elseif (preg_match($regexp2, $this->dateformat, $item)) {
			$res = array(3,1,2);
		}
		elseif (preg_match($regexp3, $this->dateformat, $item)) {
			$res = array(1,2,3);
		}
		else return false;

		// DETERMINE DATE REGEXP
		$regexp = '';
		for ($n=1; $n<6; $n++) {
			switch ($item[$n]) {
				case ''  : $regexp.= '';					break;
				case '%y': 
				case '%Y': $regexp.= '(\d{4}|\d{2})';	break;
				case '%m':
				case '%n':
				case '%d':
				case '%e': $regexp.= '(\d{1,2})';		break;
				case '%b': $cClass = '[\w'.$this->lang['specialchars'].']';
							  $regexp.= '('.$cClass.'{3,15})';
							  break;
				default:   $regexp.= '\W*';	// no letter, digit or the underscore character
			}
		}
		// ADD TIME EXPRESSION
		$regexp = '/'. $regexp .'\D*((\d{1,2})\D+(\d{1,2})[^a-z]*((a|p)(?=\W{0,3}m))?)?/i';

		// GET EACH DATE VALUE
		$timestamp = false;
		if (preg_match($regexp, $date, $split)) {
			$Y = (int)$split[$res[0]];							// YEAR
			$M = $split[$res[1]];								// MONTH
			$D = (int)$split[$res[2]];							// DAY
			$H = (isset($split[4]))? (int)$split[5]:0;	// HOUR
			$i = (isset($split[4]))? (int)$split[6]:0;	// MINUTE

			// AM/PM FORMAT, kh_mod 0.4.0 b3, add
			if (isset($split[7])) {
				$H+= (strcasecmp($split[7],'a') === 0)?
					  (($H > 11)? -12:0)		// AM
					  :
					  (($H < 12)?  12:0);	// PM
			}

			// MONTH TO NUMBER
			if (strlen($M) > 2) {
				for ($n=0; $n<12; $n++) {
					if (strncasecmp($M, $this->lang['months'][$n], 3)===0) break;
				}
				$M = ($n < 12)? ++$n : false;
			} else {
				settype($M, 'int');
			}

			// CHECK DATE
			if (checkdate($M, $D, $Y)) {
				if (($mk = mktime($H, $i, 0, $M, $D, $Y)) > 0) $timestamp = $mk;
			}
		}

		// RETURNS TIMESTAMP OR FALSE
		return $timestamp;
	}

	//
	// CONVERT TIMESTAMP TO DATE
	// kh_mod 0.4.2, changed
	function time2date($timestamp=0, $showTime=true, $showDate=true) {
		if ((int)$timestamp < 0) return '&ndash;';

		// TIMESTAMP EMPTY?
		if (empty($timestamp)) $timestamp = time();

		// DATE FORMAT
		$dateChunks = array();
		if ($showDate === true && $this->dateformat) {
			$dateChunks[] = $this->dateformat;
		}
		if ($showTime === true && $this->timeformat)	{
			$dateChunks[] = $this->timeformat;
		}
		$dateForm = trim(implode(', ', $dateChunks));

		// REPLACE MISSING PARAMETERS, kh_mod 0.4.4, changed
		$missing = array('%n', '%e', '%i', '%b', '%r');
		foreach ($missing as $parm) {
			if (strpos($dateForm, $parm) !== false) {
				$dateForm = str_replace($parm, $this->dateEmulation($parm, $timestamp), $dateForm);
			}
		}

		// DATE AND TIME FORMATTED
		return strftime($dateForm, $timestamp);
	}

	//
	// EMULATION OF MISSING DATE PARAMETERS
	// kh_mod 0.4.0 rc1, add
	function dateEmulation($parm, $timestamp){

		switch ($parm) {
			case '%n':	return date('n', $timestamp);							// '%n' as month without leading zero
			case '%e':	return date('j', $timestamp);							// '%e' as day without leading zero
			case '%i':	return date('g', $timestamp);							// '%i' as hour without leading zero
			case '%b':	$month = (int)date('n', $timestamp) - 1;			// '%b' as three chars of month (localised)
							return empty($this->lang['months'][$month]) ?
									 '%b'
									 :
									 $this->lang['months'][$month];
			case '%r':	return strtr(date('a', $timestamp), array('am'=>'a.m.','pm'=>'p.m.'));
			default:		return '';
		}
	}

	//
	// CONVERT A EXIF DATE TO MG2 DATE
	// kh_mod 0.3.0, add; 0.4.0 b4, changed
	function exif2date($date='', $nomatch='&ndash;') {
		$regexp = '/(\d{4})\D*(\d{2})\D*(\d{2})\D+(\d{1,2})?\D+(\d{2})?\D+(\d{2})?/';
		return (preg_match($regexp, $date, $d) && ((int)$d[1] > 1970))?
				 $this->time2date(mktime((int)$d[4], (int)$d[5], (int)$d[6], (int)$d[2], (int)$d[3], (int)$d[1]))
				 :
				 $nomatch;
	}
}	// END CLASS 'MG2gallery'
?>
