<?php
	// DISPLAY ERRORS BUT HIDE WARNINGS AND NOTICES
	error_reporting(E_ERROR | E_PARSE);

	// DEFINE ADDITIONAL CONSTANTS
	define('INSTALL_INDEX',	$_SERVER['SCRIPT_NAME']);
	define('DATA_FOLDER',	ROOT_FOLDER .'/data/');
	define('BACKUP_FOLDER',	ROOT_FOLDER .'/data/backup/');
	define('ADMIN_FOLDER',	'./admin/');
	define('ADMIN_IMAGES',	'./admin/images/');

	// SET HTTP HEADERS
	header('X-Frame-Options: SAMEORIGIN');
	header('Expires: Mon, 20 Jul 2000 05:00:00 GMT');
	header('Last-Modified: '. gmdate('D, d M Y H:i:s') .' GMT');
	header('Content-Type: text/html; charset=utf-8');
	header('Content-Style-Type: text/css');
	header('Cache-Control: no-store, no-cache, must-revalidate');
	header('Cache-Control: post-check=0, pre-check=0', false);
	header('Pragma: no-cache');

	// MOD VERSION (SCRIPT)
	$install_version = '0.4.5';

	// INCLUDE INSTALL HEADER
	$charset   = 'utf-8';
	$pagetitle = 'Install kh_mod '. $install_version;
	include(ADMIN_FOLDER .'install_header.inc.php');

	// GET INSTALL STEP
	$installStep = (is_file(DATA_FOLDER .'mg2db_settings.php'))?
						-1
						:
						max((int)$_POST['step'], 1);

	if		 ($installStep === -1) installError();
	elseif ($installStep ===  1) installStep1($install_version);
	elseif ($installStep ===  2) installStep2($install_version);
	elseif ($installStep ===  3) installStep3($install_version);

	echo '</body></html>';

//
// MG2/kh_mod already installed!
//
function installError() {
?>
	<table class="install_table" cellpadding="0" cellspacing="0" summary="Installation already done">
	<tr valign="top">
		<td align="center" colspan="2">
			<div style="margin: 3em 0 2em 0">
				<p><strong>MG2/kh_mod is already installed!</strong></p>
				<p>The installation wizard is not available because MG2/kh_mod has already been configured.</p>
				<p>&nbsp;</p>
				<a href="admin.php" target="_top">Go to admin panel</a>
			</div>
		</td>
	</tr>
	</table>
<?php
}

//
// INSTALL START
//
function installStep1($install_version) {

	$failure = '<span class="install_failure">Failure</span>';
	$success = '<span class="install_success">Success</span>';
	$todo = '';

	// TEST 1
	if (is_file(DATA_FOLDER .'x')) rmdir(DATA_FOLDER .'x');
	if (mkdir(DATA_FOLDER .'x')) {
		$test1 = $success;
		rmdir(DATA_FOLDER .'x');
	} else {
		$test1 = $failure;
		$todo.= '<div><strong>&mdash;Create directory called \'data\' in the gallery root and/or set CHMOD to 777, using FTP &ndash; ';
		$todo.= '<a href="http://www.google.com/search?hl=en&q=chmod+tutorial" target="_blank">Help!</a></strong></div>';
	}

	// TEST 1a
	if (is_file(BACKUP_FOLDER .'x')) rmdir(BACKUP_FOLDER .'x');
	if (mkdir(BACKUP_FOLDER .'x')) {
		$test1a = $success;
		rmdir(BACKUP_FOLDER .'x');
	} else {
		$test1a = $failure;
		$todo.= '<div><strong>&mdash;Create sub directory called \'backup\' in directory \'data\' and/or set CHMOD to 777, using FTP &ndash; ';
		$todo.= '<a href="http://www.google.com/search?hl=en&q=chmod+tutorial" target="_blank">Help!</a></strong></div>';
	}

	// TEST 2
	if (is_file('pictures/x')) rmdir('pictures/x');
	if (mkdir('pictures/x')) {
		$test2 = $success;
		rmdir('pictures/x');
	} else {
		$test2 = $failure;
		$todo.= '<div><strong>&mdash;Create directory called \'pictures\' in the gallery root and/or set CHMOD to 777, using FTP &ndash; ';
		$todo.= '<a href="http://www.google.com/search?hl=en&q=chmod+tutorial" target="_blank">Help!</a></strong></div>';
	}

	// TEST 3
	$error3 = array();
	$test3  = $success;
	$main_file1 = array('index.php', 'f6284ffccb309d48928aa8d5fc29a329ee642d15');
	$main_file2 = array('admin.php', 'bf88081455874f99974b728ba1aa88b9a1a755de');
	$main_file3 = array('lang/en_US/en_US.gallery.php', '617e2ba367a565ca03e1ae2a72ed5bad4d68075c');
	$main_file4 = array(INC_FOLDER .'mg2_viewitem.php', '7a3a08d86aac2d431cda052c65575c7a8833ede4');
	$main_file5 = array(INC_FOLDER .'mg2_viewfolder.php', 'f337794856fb56af706a46eaed0c543468b5bb9a');
	$main_file6 = array(INC_FOLDER .'mg2_slideshow.php', 'da792bc5a39184949208bb8df7e038f5047b385d');
	$main_file7 = array(INC_FOLDER .'mg2_keywords.php', '82814724e98eab8dacaade698f2eccaa3ab9fcfe');
	$main_file8 = array(INC_FOLDER .'mg2admin_dbswitch.php', '7d574c2ff279e46f9b1cece65618112161d7ebf4');
	$main_file9 = array(INC_FOLDER .'mg2admin_tableview.php', 'f3596d69ecf073bcdcc2c4087f66103e23d5185e');
	if (sha1(file_get_contents($main_file1[0])) !== $main_file1[1]) $error3[] = $main_file1[0];
	if (sha1(file_get_contents($main_file2[0])) !== $main_file2[1]) $error3[] = $main_file2[0];
	if (sha1(file_get_contents($main_file3[0])) !== $main_file3[1]) $error3[] = $main_file3[0];
	if (sha1(file_get_contents($main_file4[0])) !== $main_file4[1]) $error3[] = $main_file4[0];
	if (sha1(file_get_contents($main_file5[0])) !== $main_file5[1]) $error3[] = $main_file5[0];
	if (sha1(file_get_contents($main_file6[0])) !== $main_file6[1]) $error3[] = $main_file6[0];
	if (sha1(file_get_contents($main_file7[0])) !== $main_file7[1]) $error3[] = $main_file7[0];
	if (sha1(file_get_contents($main_file8[0])) !== $main_file8[1]) $error3[] = $main_file8[0];
	if (sha1(file_get_contents($main_file9[0])) !== $main_file9[1]) $error3[] = $main_file9[0];

	// TEST 4
	$error4 = array();
	$test4  = $success;
	$class_file1 = array(INC_FOLDER .'mg2_functions.php', 'd41f80a1bde439c54f2a8d1d7750427e1123777e');
	$class_file2 = array(INC_FOLDER .'mg2admin_functions.php', 'c0dd0d8742661feea73f589ca4517bbcb4785567');
	if (sha1(file_get_contents($class_file1[0])) !== $class_file1[1]) $error4[] = $class_file1[0];
	if (sha1(file_get_contents($class_file2[0])) !== $class_file2[1]) $error4[] = $class_file2[0];

	if ($error3) {
		$test3 = $failure;
		foreach ($error3 as $missing) {
			$todo.= '<div><strong>&mdash;Upload file \''. $missing .'\'</strong></div>';
		}
	}
	if ($error4) {
		$test4 = $failure;
		foreach ($error4 as $missing) {
			$todo.= '<div><strong>&mdash;Upload file \''. $missing .'\'</strong></div>';
		}
	}

	// TEST 5
	$test5 = '<span class="install_failure">?</span>';
	if (empty($error4)) {
		include_once($class_file1[0]);
		$mg2 = new MG2gallery;
		// NEEDED GD VERSION 2.0.1
		if ($mg2->gd_version() < 2) {
			$test5 = $failure ." ($mg2->gd_version_number)";
			$todo.= '<div><strong>&mdash;Install GD image library version 2.0.1 or above ';
			$todo.= '(<a href="http://www.boutell.com/gd/" target="_blank">';
			$todo.= 'http://www.boutell.com/gd/</a>)</strong></div>';
		}
		else {
			$test5 = $success ." ($mg2->gd_version_number)";
		}
	}

	// TEST 6
	$phpvers	= phpversion();
	$order	= '<div><strong>&mdash;Install PHP version 4.3.0 or above ';
	$order  .= '(<a href="http://www.php.net/downloads.php" target="_blank">';
	$order  .= 'http://www.php.net/</a>)</strong></div>';
	if (!function_exists('version_compare')) {
		$test6 = $failure ." ($phpvers)";
		$todo	.= $order;
	}
	elseif (version_compare($phpvers,'4.3.0','<')) {
		$test6 = $failure ." ($phpvers)";
		$todo	.= $order;
	}
	else $test6 = $success ." ($phpvers)";

	$installStep = 1;
	include(ADMIN_FOLDER .'install_main.inc.php');
}

//
// STEP 2
//
function installStep2($install_version) {

	include_once(INC_FOLDER .'mg2_functions.php');
	$mg2 = new MG2gallery;

	// GET LANGUAGES
	$defaultlang = 'en_US';
	$exists		 = false;
	$lang			 = array();
	$regexp		 = '/^([a-z]{2})(_|-)([a-z]{2})$/i';
	$workdir		 = opendir(LANG_FOLDER);
	while (false !== ($pointer = readdir($workdir))) {
		if ($pointer{0} === '.')				continue;
		if (!is_dir(LANG_FOLDER. $pointer))	continue;
		if (!preg_match($regexp, $pointer))	continue;

		$value = 'value="'.$pointer.'"';
		if ($defaultlang === $pointer) {
			$value .= ' selected="selected"';
			$exists = true;
		}
		$lang[] = array($value, $pointer);
	}
	closedir($workdir);
	if (!$exists) $lang[] = array('value="" selected="selected"','--');
	sort($lang);

	if ($lang_path = $mg2->checkLanguage($defaultlang)) {
		include sprintf($lang_path, 'admin');
	}
	else {
		$mg2->lang['gallerytitle']	= 'Gallery title';
		$mg2->lang['adminemail']	= 'Admin email';
		$mg2->lang['language']		= 'Language';
		$mg2->lang['skin']			= 'Skin';
		$mg2->lang['password']		= 'Password';
	}

	// SKIN
	$skins	= array();
	$workdir	= opendir('skins');
	while (false !== ($pointer = readdir($workdir))) {
		if ($pointer{0} === '.')			continue;
		if ($pointer 	 === '_global_')	continue;
		$skins[] = $pointer;
	}
	closedir($workdir);
	sort($skins);

	$installStep = 2;
	include(ADMIN_FOLDER .'install_main.inc.php');
}

//
// STEP 3
//
function installStep3($install_version) {

	include_once(INC_FOLDER .'mg2_functions.php');
	include_once(INC_FOLDER .'mg2admin_functions.php');
	$mg2 = new MG2admin;

	// GALLERY TITEL VERIFICATION
	$gallerytitle = $mg2->charfix($_POST['gallerytitle']);
	$gallerytitle = $mg2->cleanHTMLContent($gallerytitle, array('b','i','a','br','img','span','div'));

	// E-MAIL VERIFICATION
	$cClass		 = '[_a-z0-9-]+';
	$regexp		 = '/^'.$cClass.'(\.'.$cClass.')*@'.$cClass.'(\.'.$cClass.')*\.([a-z]{2,5})$/i';
	$adminemail	 = preg_match($regexp, $_POST['adminemail'], $matches)?
						$matches[0]
						:
						'';

	// LANGUAGE VERIFICATION
	$regexp		 = '/^([a-z]{2})(_|-)([a-z]{2})$/i';
	$defaultlang = preg_match($regexp, $_POST['defaultlang'], $matches)?
						$matches[0]
						:
						'en_US';

	// GENERATE PASSWORD
	$adminsalt = $mg2->buildVerificationToken(40);
	$adminpwd  = trim($_POST['password']);
	$adminpwd  = sha1(strrev(sha1($adminpwd . $adminsalt)));

	// SET DEFAULT VALUES
	$mg2->gallerytitle	= $gallerytitle;
	$mg2->adminemail		= $adminemail;
	$mg2->metasetting		= 81;														// kh_mod 0.2.0, add
	$mg2->defaultlang		= $defaultlang;
	$mg2->activeskin		= $mg2->charfix($_POST['activeskin']);			// kh_mod 0.1.0, changed
	$mg2->dateformat		= '%d.%m.%Y';											// kh_mod 0.3.0, changed
	$mg2->timeformat		= '%H:%M';												// kh_mod 0.3.0, add
	$mg2->navtype			= 113;													// kh_mod 0.4.0 rc1, changed
	$mg2->showexif			= 510;													// kh_mod 0.2.0, changed
	$mg2->commentsets		= 159;													// kh_mod 0.3.0, changed
	$mg2->marknew			= 7;														// kh_mod 0.3.0, changed
	$mg2->copyright		= 'Copyright &copy; '. strftime('%Y');			// kh_mod 0.4.1, changed
	$mg2->adminpwd			= $adminpwd;											// kh_mod 0.4.0 b4, changed
	$mg2->adminsalt		= $adminsalt;											// kh_mod 0.4.0 b4, add
	$mg2->extensions		= 1711;													// kh_mod 0.4.1, changed
	$mg2->canvasWidth		= 'auto';												// kh_mod 0.4.0 b4, add
	$mg2->contentWidth	= 'auto';												// kh_mod 0.4.0 b4, add
	$mg2->introWidth		= 'auto';												// kh_mod 0.4.0 b4, add
	$mg2->mediumimage		= '924';													// kh_mod 0.3.0, changed
	$mg2->indexfile		= 'index.php';
	$mg2->imagefolder		= 'pictures';											// kh_mod 0.1.0, add
	$mg2->foldersetting	= 544;													// kh_mod 0.2.0, add
	$mg2->layoutsetting	= 8307;													// kh_mod 0.4.0 b4, changed
	$mg2->thumbquality	= 85;														// kh_mod 0.3.0, changed
	$mg2->thumbMaxWidth	= 150;													// kh_mod 0.3.0, changed
	$mg2->thumbMaxHeight	= 150;													// kh_mod 0.3.0, changed
	$mg2->itemThumbCols	= 4;														// kh_mod 0.4.0 b4, changed
	$mg2->itemThumbRows	= 6;														// kh_mod 0.4.0 b4, changed
	$mg2->slideshowdelay	= 8;														// kh_mod 0.3.0, changed
	$mg2->websitelink		= '';
	$mg2->websitetext		= 'Home';												// kh_mod 0.1.0, add
	$mg2->inactivetime	= 15;														// kh_mod 0.3.0, changed
	$mg2->extendedset		= 10460;													// kh_mod 0.4.0 rc1, changed
	$mg2->statisticsets	= 144;													// kh_mod 0.4.0 rc2, add
	$mg2->modversion		= $install_version;									// kh_mod 0.3.0, add
	$mg2->installdate		= time();

	$mg2->write_sDBFlatfile('flat');

	$installStep = 3;
	include(ADMIN_FOLDER .'install_main.inc.php');
}
?>
