<?php
//
// VIEWFOLDER HELPER CLASS, IMPLEMENTATION SHOULD BE A STATIC CLASS
// kh_mod 0.4.0 b4, add
class MG2ViewfolderHelper extends MG2ViewHelper {

	var $mg2;			// parent object reference
	var $folderID;		// folder id
	var $maxItems;		// max number of items per page
	var $numPages;		// total number of pages
	var $lineBreak;	// for displaying folders and thumbs

	// INITIALIZE VIEWFOLDER HELPER
	function MG2ViewfolderHelper(&$parent, $folderID) {
		$this->mg2       = &$parent;
		$this->folderID  = $folderID;
		$this->lineBreak = '</tr><tr>';	// table layout
	}

	// SUPPOSED TO BE USED BY SKINS
	function setLineBreak($lineBreak) {
		$this->lineBreak = empty($lineBreak) ? false:$lineBreak;
	}

	function getViewGrid($totalItems) {

		// GET COLS AND ROWS PER PAGE
		$itemCols = $this->mg2->getThumbCols($this->folderID);			// values {1 ... n}
		$itemRows = $this->mg2->getThumbRows($this->folderID);			// values {1 ... n}

		//CALCULATE THUMBS PER PAGE AND NUMBER OF PAGES
		$this->maxItems = $itemCols * $itemRows;								// max number of items (thumbs) per page
		$this->numPages = max(ceil(($totalItems)/$this->maxItems), 1);	// number of total pages per folder

		return array($itemCols, $itemRows, $this->maxItems, $this->numPages);
	}

	// DISPLAY FOLDER INTRO TEXT
	function displayIntroText() {

		$introText = $this->mg2->all_folders[$this->folderID][3];
		$emptyText = $this->mg2->string_empty($introText);

		printf(($emptyText || (int)$this->mg2->introWidth)?
			'<div class="introtext" style="width:%s;">%s</div>'."\n"
			:
			'</div>
			 <div class="introtext" style="width:%s;">%s</div>
			 <div style="margin:%s;width:%s;">
			',
			($this->mg2->thumbViewWidth === 'auto')? $this->mg2->introWidth:'auto',
			$emptyText ? '&nbsp;':$introText,
			$this->mg2->contentMargin,
			$this->mg2->contentWidth
		);
	}

	// DISPLAY FOLDER INTRO TEXT
	function displayPageNav($currentPage) {

		printf('<div class="pagenav">%s</div>'."\n",
			$this->mg2->pageNavigation($this->folderID, $this->numPages, $currentPage)
		);
	}

	// DISPLAY THUMBS OF FOLDERS
	function displayFolders($folderIDs, $itemCols) {

		foreach($folderIDs as $currFolder_idx=>$subfID) {

			$folderRC = &$this->mg2->all_folders[$subfID];

			// SET FOLDER LINK AND TARGET
			$thumbLink	 = $this->mg2->getGalleryLink(array('fID'=>$subfID));
			$thumbTarget = '_self';

			// IF FOLDER TYPE: "LINK"
			if (!empty($folderRC[11]) && (int)$folderRC[11] === 1) {
				list($thumbURL, $thumbTarget) = $this->mg2->getFolderURL($subfID);
				if (!trim($this->mg2->all_folders[$subfID][8])) {
					$thumbLink = $thumbURL;
				}
			}

			// GET FOLDER ICON
			list( $thumbFileURL,
					$thumbWidth,
					$thumbHeight,
					$thumbClass ) = $this->mg2->getFolderIcon($subfID);

			// GET FOLDERNAME
			$folderName   = strip_tags($this->mg2->getFolderName($subfID), '<br>');
			$nameMaxWidth = max($this->mg2->thumbMaxWidth*2, $thumbWidth);

			// DISTANCE BETWEEN FOLDER ICON AND FOLDER NAME
			$vDistance = max($this->mg2->thumbMaxHeight + 20 - $thumbHeight, 1);

			// MARK NEW FOLDER
			$isNewFolder = ((time() - (int)$folderRC[4]) < ($this->mg2->marknew * 84600))?
								true
								:
								false;

			// NEW ROW OF FOLDER THUMBS?
			if ($currFolder_idx
				 && $itemCols
				 && $this->lineBreak
				 && (($currFolder_idx % $itemCols) === 0))
			{
				echo $this->lineBreak;
			}

			// DISPLAY SUB FOLDER THUMB
			include(SKIN_FOLDER .'templates/subfolder.php');
		}
	}

	// DISPLAY THUMBS OF ITEMS
	function displayThumbs($itemIDs, $itemCols, $skinTitleLimit, $lastFolder_idx=0) {

		// IS THERE THE CLICK OR/AND COMMENT COUNTER ACTIVE?
		if ($this->mg2->foldersetting & 384) $Counter = &$this->mg2->getInstance('MG2Counter');

		// DISPLAY THUMBS
		$commentsCounted = false;
		$thumbTooltip	  = '';
		foreach ($itemIDs as $currItem_idx=>$itemID) {

			// GET ITEM RECORD AND TYPE
			$itemRecord  = $this->mg2->all_items[$itemID];
			$contentType = $this->mg2->getContentType($itemID);

			if     (isset($contentType['image'])) {
				$linkRel = 'cboxImage';
			}
			elseif (isset($contentType['flash'])) {
				$linkRel = sprintf('cboxFlash%dx%d', $itemRecord[8], $itemRecord[9]);
			}
			$linkHref	 = $this->mg2->getGalleryLink(array('iID'=>$itemID));
			$thumbTitle  = trim($itemRecord[2]);
			$linkTitle	 = '';
			$numComments = 0;

			// GET ITEM ICON
			list($thumbID,
				  $thumbFileURL,
				  $thumbWidth,
				  $thumbHeight) = $this->mg2->getFileIcon($itemID, $contentType, true);

			// GET NUMBER OF CLICKS
			if ($this->mg2->foldersetting & 128)
				$numClicks = $Counter->getNumClicks($itemID);

			// GET NUMBER OF COMMENTS
			if ($this->mg2->foldersetting & 256)
			if (($numComments = $Counter->getNumComments($itemID)) === -1) {

				// COUNT NUMBER OF COMMENTS
				$Comments = &$this->mg2->getInstance('MG2Comments');
				if (($numComments = $Comments->getNumComments($itemID)) !== false) {
					$Counter->setDatabase($itemID, -1, $numComments, false);
					$commentsCounted = true;
				}
				else {
					$numComments = 0;
				}
			}

			// USE HEADLINE FOR 'alt' AND 'title' ATTRIBUT
			if ($this->mg2->foldersetting & 512)
				$thumbTooltip = $this->mg2->htmlchars2entities(($this->mg2->layoutsetting & 8)?	// use file name
									 $this->mg2->getFileName($itemID)											// for headline 
									 :
									 strip_tags($this->mg2->br2line($thumbTitle)));

			// DISPLAY IMAGE TITLE UNDER THUMBNAIL
			$subLine = '';
			if (($this->mg2->foldersetting & 32) && !$this->mg2->string_empty($thumbTitle)) {
				// RELATIVE TITLE LIMIT?
				$titleLimit = ($skinTitleLimit < 0)?
								  abs(round(($this->mg2->thumbMaxWidth/$skinTitleLimit),0))
								  :
								  (int)$skinTitleLimit;

				// SHORT TITLE, '<span>' WILL HERE DISPLAYED AS 'block'
				$subLine.= sprintf('<span>%s</span>', $this->mg2->mb_shorten($thumbTitle, $titleLimit));
			}
			// DISPLAY FILE NAME UNDER THUMBNAIL, kh_mod 0.1.0, add, 0.3.1 changed
			if ($this->mg2->foldersetting & 64)	{
				$subLine.= sprintf('<span>%s</span>',
									$this->mg2->htmlchars2entities($this->mg2->getFileName($itemID))
							  );
			}

			// VERTICAL DISTANCE BETWEEN THUMB AND ITEM TITEL
			$vDistance = max($this->mg2->thumbMaxHeight + 20 - $thumbHeight, 1);

			// MARK NEW ITEM
			$isNewItem = ((time() - (int)$itemRecord[4]) < ($this->mg2->marknew * 84600))?
							 true
							 :
							 false;

			// NEW ROW OF ITEM THUMBS?
			$currReal_idx = $lastFolder_idx + $currItem_idx;
			if ($currReal_idx
				 && $itemCols
				 && $this->lineBreak
				 && (($currReal_idx % $itemCols) === 0))
			{
				echo $this->lineBreak;
			}

			// DISPLAY ITEM THUMB
			$mg2 = &$this->mg2;
			include(SKIN_FOLDER .'templates/thumbnail.php');
		}

		// COMMENTS COUNTED THEN UPDATE COUNTER ENTRIES
		if ($commentsCounted) $Counter->updateRecords();
	}

	// IS USED TABLE LAYOUT AND THE LAST ROW INCOMPLET
	function fillUpTableVoids($num) {

		if (stristr($this->lineBreak, '</tr>')) {
			echo str_repeat("<td>&nbsp;</td>\n", $num);
		}
	}

	// DISPLAY LINK TO ADMIN AREA
	function displayAdminLink() {

		// IF ROOT FOLDER
		if ($this->folderID === 1)
			printf('
				<div class="admin-link">
					<a href="%sadmin.php" target="_top"><img src="%skey.gif" width="13" height="7" alt="" border="0" /></a>
				</div>
				',
				MG2_INCLUDE_PATH,
				SKIN_IMAGES
			);
	}
}
?>