<?php
//
// VIEWITEM HELPER CLASS, IMPLEMENTATION SHOULD BE A STATIC CLASS
// kh_mod 0.4.0 b4, add
class MG2ViewitemHelper extends MG2ViewHelper {

	var $mg2;			// parent object reference
	var $imageMap;		// image navigation map

	// INITIALIZE VIEWITEM
	function MG2ViewitemHelper(&$parent) {
		$this->mg2      = &$parent;
		$this->imageMap = '';
	}

	// ADD GALLERY COMMENT ENTRY
	function addUserComment($itemID) {

		$workon		  = array('','','','');									// empty comment fields
		$verify		  = $this->mg2->buildVerificationToken(18);		// build new form token, used in 'comment_form.php'
		$hideCommForm = (!isset($_GET['showform']))? true:false;		// display or hide form in 'comment_form.php'
		$tokens		  = (isset($_SESSION[GALLERY_ID]['addComm']))?	// get form tokens
							 $_SESSION[GALLERY_ID]['addComm']
							 :
							 array();

		// ADD NEW COMMENT?
		if (!empty($_POST['action']) && $_POST['action'] === 'addComment') {
			$hideCommForm = true;					// hide comment form

			// FORM VERIFICATION TOKEN CORRECT?
			if (isset($tokens[$itemID])										&&
				 (strlen($_POST['verify'])							=== 18)	&&
				 (strcmp($_POST['verify'], $tokens[$itemID]) ===  0))
			{
				$Comments = &$this->mg2->getInstance('MG2Comments');
				if (($input = $Comments->addNewComment($itemID)) !== true) {
					$workon = $input;					// last comment input
					$verify = $tokens[$itemID];	// unused token (needed for reload!)
					$hideCommForm = false;			// if error, show comment form again
				}
			}
		}

		// SET FORM TOKEN INTO SESSION
		$tokens[$itemID] = $verify;
		while (count($tokens) > 10) {				// delete more then 10 items
			reset($tokens);							// set pointer to the first item
			unset($tokens[key($tokens)]);			// delete the first item
		}
		$_SESSION[GALLERY_ID]['addComm'] = $tokens;

		return array($workon, $verify, $hideCommForm);
	}

	// CREATE IMAGE MAP FOR NAVIGATION
	function buildImageMap($flagM, $folderID, $currentPage, $prevID, $itemID, $nextID) {

		// INIT START VALUE
		$areas = array();

		// IMAGE MAP - AREA TAG
		$areaTag = '<area shape="%s" coords="%s" href="%3$s" onmouseover="jsImageNavigation=\'%3$s\';" onmouseout="jsImageNavigation=\'\';" alt="%4$s" title="%4$s" />'."\n";

		// GENERATE NAVIGATION LINKS AND TITLES
		$link_back  = $this->mg2->getGalleryLink(array('fID'=>$folderID, 'page'=>$currentPage));
		$title_back = $this->mg2->lang['thumbsoverview'];
		if ($nextID > 0) {
			$link_next  = $this->mg2->getGalleryLink(array('iID'=>$nextID));
			$title_next = $this->mg2->lang['next'];
		} else {
			$link_next  = $link_back;
			$title_next = $title_back;
		}

		// IMAGE COORDINATS
		$left1 = 0;
		$left2 = $this->mg2->width/2;
		$left3 = $this->mg2->width-1;
		$top1  = 0;
		$top2  = $this->mg2->height/3;
		$top3  = $this->mg2->height-1;

		// DOWNLOAD AREA
		if ($flagM === 128) {
			$top4 = $top3;
			$top3 = max($top3 - 14, 0);
			$coords_down = sprintf('%d,%d,%d,%d',
									$left1, $top3, $left3, $top4
								);
			$link_verify = $this->mg2->setVerificationToken('download');
			$link_down   = $this->mg2->getGalleryLink(array('iID'=>$itemID, 'download'=>$link_verify));
			$title_down  = $this->mg2->lang['download'];
			$areas[] = sprintf($areaTag, 'rect', $coords_down, $link_down, $title_down);
			$flagM = 96;
		}

		// CALL THUMB OVERVIEW WITH MOUSE CLICK
		if ($flagM === 32) {
			$coords_back = sprintf('%d,%d,%d,%d',
									$left1, $top1, $left3, $top3
								);
			$areas[] = sprintf($areaTag, 'rect', $coords_back, $link_back, $title_back);
		}

		// CALL NEXT ITEM WITH MOUSE CLICK
		elseif ($flagM === 64) {
			$coords_next = sprintf('%d,%d,%d,%d',
									$left1, $top1, $left3, $top3
								);
			$areas[] = sprintf($areaTag, 'rect', $coords_next, $link_next, $title_next);
		}

		// CALL PREVIOUS, BACK, NEXT WITH MOUSE CLICK
		elseif ($flagM === 96) {
			// EXISTS AREA TO PREVIOUS ITEM?
			if ($prevID > 0) {
				$coords_prev = sprintf('%d,%d,%d,%d,%d,%d,%d,%d',
										$left1, $top1, $left2, $top2, $left2, $top3, $left1, $top3
									);
				$link_prev  = $this->mg2->getGalleryLink(array('iID'=>$prevID));
				$title_prev = $this->mg2->lang['prev'];
				$areas[] = sprintf($areaTag, 'poly', $coords_prev, $link_prev, $title_prev);
			}

			// AREA TO THUMBNAIL OVERVIEW
			$coords_back = sprintf('%d,%d,%d,%d,%d,%d',
									$left1+1, $top1, $left3-1, $top1, $left2+1, $top2-1
								);
			$areas[] = sprintf($areaTag, 'poly', $coords_back, $link_back, $title_back);

			// AREA TO NEXT ITEM
			$coords_next = sprintf('%d,%d,%d,%d,%d,%d,%d,%d',
									$left3, $top1, $left3, $top3, $left2+1,$top3, $left2+1, $top2
								);
			$areas[] = sprintf($areaTag, 'poly', $coords_next, $link_next, $title_next);
		}

		if ($areas) $this->imageMap = implode("\n", $areas);
	}

	// BUILD KEYWORD LINKS FOR GALLERY
	function getKeywordLinks($itemID, $rawLinkString, $delimiter=', ') {

		// DO NOT USE KEYWORDS
		if (~$this->mg2->layoutsetting & 1<<6) return '';

		// GET KEYWORDS
		$sorting  = $this->mg2->layoutsetting & 1<<15;
		$Keywords = &$this->mg2->getInstance('MG2Keywords');
		$keyArray = $Keywords->getKeywords($itemID, $sorting);

		$links = array();
		foreach($keyArray as $keywordID=>$keyword) {
			$links[] = sprintf($rawLinkString,
								$this->mg2->getGalleryLink(array('search'=>$keywordID)),
								$this->mg2->htmlchars2entities($keyword)
						  );
		}

		return implode($delimiter, $links);
	}

	// WRAPPER TO GET EXIF-DATA OF A GALLERY IMAGE
	function getExifData($imagePath, $editor='') {

		// INIT RETURN VALUE
		$exifData = false;

		if ((include(INC_FOLDER .'mg2_exif.php')) && ($Exif = new MG2Exif())) {
			$exifData = $Exif->getExifData($imagePath);
			if (!empty($editor)) {
				$exifData['Editor'] = trim($editor);
			}
			$exifData = $this->formatExifData($exifData);
		}

		return $exifData;
	}

	// GET EXIF-DATA OF A GALLERY IMAGE
	function formatExifData($exifData) {

		// INIT START VALUES
		$missedExif  = 0;
		$exifDisplay = array();

		// CHECK AND FORMAT EXIF DATA
		if (!empty($exifData)) {
			$empty = create_function('&$number', '$number++;return "&nbsp;&ndash;&nbsp;";');
			if ($this->mg2->showexif & 1)		{	// Make
				$exifDisplay['Make'] = (isset($exifData['Make']))?
					htmlentities($exifData['Make'], null, 'ISO-8859-1')
					:
					$empty($missedExif);
			}
			if ($this->mg2->showexif & 1<<1)	{	// Model
				$exifDisplay['Model'] = (isset($exifData['Model']))?
					htmlentities($exifData['Model'], null, 'ISO-8859-1')
					:
					$empty($missedExif);
			}
			if ($this->mg2->showexif & 1<<2)	{	// ExposureTime
				$exifDisplay['ExposureTime'] = (isset($exifData['ExposureTime']))?
					$exifData['ExposureTime'] .'&nbsp;'. $this->mg2->lang['seconds']
					:
					$empty($missedExif);
			}
			if ($this->mg2->showexif & 1<<3) {	// ExposureBias
				$exifDisplay['ExposureBias'] = (isset($exifData['ExposureBias']))?
					$exifData['ExposureBias'] .'&nbsp;EV'
					:
					$empty($missedExif);
			}
			if ($this->mg2->showexif & 1<<4) {	// FNumber
				$exifDisplay['FNumber'] = (isset($exifData['FNumber']))?
					'f'. round($exifData['FNumber'], 2)
					:
					$empty($missedExif);
			}
			if ($this->mg2->showexif & 1<<5) {	// FocalLength
				$exifDisplay['FocalLength'] = (isset($exifData['FocalLength']))?
					round($exifData['FocalLength'], 2) .'&nbsp;'. $this->mg2->lang['mm']
					:
					$empty($missedExif);
			}
			if ($this->mg2->showexif & 1<<6) {	// ISOSpeedRating
				$exifDisplay['ISOSpeedRating'] = (isset($exifData['ISOSpeedRating']))?
					$exifData['ISOSpeedRating']
					:
					$empty($missedExif);
			}
			if ($this->mg2->showexif & 1<<7) {	// Flash
				$exifDisplay['Flash'] = (isset($exifData['Flash']))?
					htmlentities($exifData['Flash'], null, 'ISO-8859-1')
					:
					$empty($missedExif);
			}
			if ($this->mg2->showexif & 1<<8) {	// DTOpticalCapture
				$exifDisplay['DTOpticalCapture'] = (isset($exifData['DTOpticalCapture']))?
					$this->mg2->exif2date($exifData['DTOpticalCapture'])
					:
					$empty($missedExif);
			}
			if ($this->mg2->showexif & 1<<9)	{	// Software
				$exifDisplay['Software'] = (isset($exifData['Software']))?
					htmlentities($exifData['Software'], null, 'ISO-8859-1')
					:
					$empty($missedExif);
			}
			if ($this->mg2->showexif & 1<<10) {	// DateTime
				$exifDisplay['DateTime'] = (isset($exifData['DateTime']))?
					$this->mg2->exif2date($exifData['DateTime'])
					:
					$empty($missedExif);
			}
			if ($this->mg2->showexif & 1<<11) {	// ColorSpace
				$exifDisplay['ColorSpace'] = (isset($exifData['ColorSpace']))?
					$exifData['ColorSpace']
					:
					$empty($missedExif);
			}
			if ($this->mg2->showexif & 1<<12) {	// Photographer
				if (isset($exifData['Editor'])) {
					$exifDisplay['Photographer'] = $this->mg2->htmlchars2entities($exifData['Editor']);
				}
				elseif (!empty($exifData['Artist'])) {
					$exifDisplay['Photographer'] = htmlentities($exifData['Artist'], null, 'ISO-8859-1');
				}
				elseif (!empty($exifData['Copyright'])) {
					$exifDisplay['Photographer'] = htmlentities($exifData['Copyright'], null, 'ISO-8859-1');
				}
				else {
					$exifDisplay['Photographer'] = $empty($missedExif);
				}
			}
			if ($this->mg2->showexif & 1<<13) {	// GPS
				if (isset($exifData['GPSLatitude'])) {
					$exifDisplay['GPS'] = array(
													'Latitude' 		=> $exifData['GPSLatitude'],
													'LatitudeRef'	=> $exifData['GPSLatitudeRef'],
													'Longitude'		=> $exifData['GPSLongitude'],
													'LongitudeRef'	=> $exifData['GPSLongitudeRef'],
													'DecLat'			=> $exifData['GPSDecLat'],
													'DecLong'		=> $exifData['GPSDecLong']
												 );
				}
			}
		}

		// IF MISSED EXIF ENTRIES LESS THAN SELECTED
		return ($missedExif < count($exifDisplay))?
				 $exifDisplay
				 :
				 false;
	}

	// GET SPLASH CONTENT FOR FLASH VIDEO
	function getSplashContent($starticon){

		$canvasWidth  = $this->mg2->width;
		$canvasHeight = $this->mg2->height;

		// GET START ICON ATTRIBUTES
		list($iconURL, $iconWidth, $iconHeight) = $this->mg2->getImgAttributes($starticon);

		// GET START ICON TAG
		return sprintf('
						<img src="'. SKIN_IMAGES .'1x1.gif" border="0" width="%d" height="%d" alt="" usemap="#imgmap" />
						<map id="imgmap" name="imgmap">'. $this->imageMap .'</map>
						<div class="starticon" style="z-index:20;position:absolute;left:%dpx;top:%dpx;width:%dpx;height:%dpx;">
							<img src="%7$s" border="0" width="%5$d" height="%6$d" alt="" usemap="#startvideo" />
							<map id="startvideo" name="startvideo">
								<area shape="circle" href="javascript:void();" onclick="$f(\'player\').play()" coords="%8$d,%8$d,%8$d" alt="%9$s" title="%9$s" />
							</map>
						</div>'
						,
						$canvasWidth,
						$canvasHeight,
						($canvasWidth - $iconWidth)/2,
						($canvasHeight - $iconHeight)/2,
						$iconWidth,
						$iconHeight,
						$iconURL,
						$iconHeight/2,
						$this->mg2->lang['playvideo']
				 );
	}
}
?>