<?php
//////////////////////////////////////////////////////////////////////////////////
//                                                                              //
//    MG2                                                                       //
//    A PHP/HTML based image gallery script.                                    //
//                                                                              //
//    Copyright 2005 by Thomas Rybak                                            //
//    http://www.minigal.dk                                                     //
//    support@minigal.dk                                                        //
//                                                                              //
//    The script utilises Exif reader v 1.2 (free to use)                       //
//    Exif reader v 1.2                                                         //
//    By Richard James Kendall (richard@richardjameskendall.com)                //
//                                                                              //
//    -----------------                                                         //
//                                                                              //
//    MG2 is free software; you can redistribute it and/or modify               //
//    it under the terms of the GNU General Public License as published by      //
//    the Free Software Foundation; either version 2 of the License, or         //
//    (at your option) any later version.                                       //
//                                                                              //
//    MG2 is distributed in the hope that it will be useful,                    //
//    but WITHOUT ANY WARRANTY; without even the implied warranty of            //
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the              //
//    GNU General Public License for more details.                              //
//                                                                              //
//    TO COMPLY WITH THIS LICENSE, DO NOT REMOVE THE LINK TO THE MINIGAL        //
//    WEBSITE FROM YOUR GALLERY FRONT PAGE. THIS IS THE LEAST YOU CAN DO TO     //
//    SUPPORT THE DEVELOPMENT OF MG2!                                           //
//                                                                              //
//    You should have received a copy of the GNU General Public License         //
//    along with this program; if not, you can find it here:                    //
//    http://www.gnu.org/copyleft/gpl.html                                      //
//                                                                              //
//////////////////////////////////////////////////////////////////////////////////

class MG2admin extends MG2gallery {

	var $Calendar;		// child object for javascript calendar

	//
	// SET STATUS MESSAGE
	// kh_mod 0.4.0 rc1, add
	function setStatus($message, $errorLevel=0) {

		if (empty($message)) return;

		$this->status = ($errorLevel < 0 || 3 < $errorLevel)?
							 array(0 => $message)
							 :
							 array($errorLevel => $message);
	}

	//
	// DISPLAY STATUS MESSAGE
	// kh_mod 0.4.0 rc1, changed
	function displayStatus($message='', $errorLevel=0) {

		// IS SET '$message' OR '$this->status'
		if (empty($message)) {
			if (empty($this->status)) return;

			if (is_array($this->status)) {
				list($errorLevel, $message) = each($this->status);
			}
			else {
				$message = $this->status;
			}
		}

		// FORMAT MESSAGE
		if ($message) {
			$style = '<div style="color:%s;">%s %s</div>';
			switch ($errorLevel) {
				case 1:	// notice
					$this->status = sprintf($style, 'teal', $this->lang['notice'], $message);
					break;
				case 2:	// warning
					$this->status = sprintf($style, '#C69023', $this->lang['warning'], $message);
					break;
				case 3:	// error
					$this->status = sprintf($style, 'red', $this->lang['error'], $message);
					break;
				default:	// ok
					$this->status = $message;
			}
		}

		// OUTPUT MESSAGE
		if ($this->status) {
			include(ADMIN_FOLDER .'admin_status.php');flush();
			$this->status = '';
		}
	}

	//
	// CHECK LOGIN
	// kh_mod, 0.4.2, changed
	function security($pagetitle='')
	{
		// INIT START VALUES
		$currentTime = time();
		$firstLogin  = false;

		if ( isset($_POST['password'])						&&
			  strlen($_POST['password']) <= MAXLEN_PWD	&&
			 !isset($_SESSION[GALLERY_ID]['adminpwd'])	&&
			 (sha1(strrev(sha1($_POST['password'] . $this->adminsalt))) === $this->adminpwd))
		{
			// FIRST LOGIN!
			$_SESSION[GALLERY_ID]['sorting']		  = false;								// sorting array
			$_SESSION[GALLERY_ID]['sortstart']	  = false;								// folder id of the sorted folder
			$_SESSION[GALLERY_ID]['adminpwd']	  = $this->adminpwd;					// admin password
			$_SESSION[GALLERY_ID]['accesstime']	  = $currentTime;						// timestamp - last access
			$_SESSION[GALLERY_ID]['inactivetime'] = ($this->inactivetime < 1)?
																 900									// time in seconds (15 minutes)
																 :
																 $this->inactivetime * 60;		// time in seconds
			$ip   = getenv('REMOTE_ADDR');
			$host = gethostbyaddr($ip);
			$this->log(sprintf('Login from IP: %s, HOST: %s', $ip, $host));
			$firstLogin = true;
		}

		// ALLOW INACTIVE ADMIN TIME IN SECONDS
		$inactivetime = isset($_SESSION[GALLERY_ID]['inactivetime']) ?
							 (int)$_SESSION[GALLERY_ID]['inactivetime']
							 :
							 0;

		// SHOW LOGIN SCREEN
		if (!isset($_SESSION[GALLERY_ID]['adminpwd'])					||
			 (strlen($_SESSION[GALLERY_ID]['adminpwd']) !== 40)		||
			 ($_SESSION[GALLERY_ID]['adminpwd'] !== $this->adminpwd))
		{
			$select = 1;
			unset($_SESSION[GALLERY_ID]);
			$pwdheadline = empty($_POST['password']) ?
								$this->lang['enterpassword']
								:
								$this->lang['wronglogin'];
			include(ADMIN_FOLDER .'admin_security.php');

			if (!empty($_GET['svg'])) $_SESSION[GALLERY_ID]['svg']=true;	// set svg support
			exit();
		}
		// TIME LOGOFF
		elseif ($currentTime > ($_SESSION[GALLERY_ID]['accesstime'] + $inactivetime))
		{
			$select = 2;
			unset($_SESSION[GALLERY_ID]);
			include(ADMIN_FOLDER .'admin_security.php');
			$this->log('Timeout logoff after '. (int)($inactivetime/60) .' minutes');
			exit();
		}
		// ADMIN LOGOUT
		elseif (isset($_GET['action']) && ($_GET['action'] === 'logoff'))
		{
			$select = 3;
			unset($_SESSION[GALLERY_ID]);
			include(ADMIN_FOLDER .'admin_security.php');
			$this->log('Logoff');
			exit();
		}

		// SET NEW ACCESSTIME
		$_SESSION[GALLERY_ID]['accesstime'] = $currentTime;

		// SET ADMIN PERMISSION ENVIRONMENT
		define('USER_ADMIN', true);

		// ADDITIONAL LOGIN PERMISSION CHECKS, kh_mod 04.0 rc1, changed
		if ($firstLogin === true) {
			if ($fp = fopen(DATA_FOLDER .'x', 'wb')) {
				@fclose($fp);
				@unlink(DATA_FOLDER .'x');
			} else {
				$this->permcheck(1);
			}
			if ($fp = fopen($this->imagefolder .'/x', 'wb')) {
				@fclose($fp);
				@unlink($this->imagefolder .'/x');
			} else {
				$this->permcheck(2);
			}
			// DELETE TEMP FILES
			$toDeletedFiles = array (
										DATA_FOLDER .'mg2db_counter_temp.php',
										DATA_FOLDER .'mg2db_chronicle_temp.php',
										DATA_FOLDER .'mg2db_keywords_temp.php',
										DATA_FOLDER .'mg2db_item_keyword_temp.php',
										DATA_FOLDER .'mg2db_splashes_temp.php',
										DATA_FOLDER .'mg2db_settings_temp.php',
										DATA_FOLDER .'mg2db_items_temp.php',
										DATA_FOLDER .'mg2db_folders_temp.php'
									);
			foreach ($toDeletedFiles as $file) {
				if (is_file($file)) unlink($file);
			}
			// ARE DATABASE FILES READ/WRITEABLE? changed kh_mod 0.4.3
			$wantedPerms    = 0640;
			$toCheckedFiles = array(
										3 => DATA_FOLDER .'mg2db_items.php',
										5 => DATA_FOLDER .'mg2db_folders.php'
									);
			foreach ($toCheckedFiles as $key=>$file) {
				if (is_file($file) && ((fileperms($file) & $wantedPerms) !== $wantedPerms)) {
					$this->permcheck($key);
				}
			}
		}

		// RETURN IF FIRST LOGIN
		return $firstLogin;
	}

	//
	// DISPLAY PERMISSION ERROR
	// kh_mod 0.3.1, changed
	function permcheck($level) {
		$permerror = $this->lang['permerror'.$level];
		$whattodo  = $this->lang['whattodo'.$level];
		include(ADMIN_FOLDER .'admin_header.php');
		include(ADMIN_FOLDER .'admin_permerror.php');
		unset($_SESSION[GALLERY_ID]);
		exit();
	}

	//
	// IS JAVASCRIPT ACTIVE AND WYSIWYG-EDITOR USED
	// kh_mod 0.4.0 rc1, add
	function isJavaScriptEditor() {

		if (isset($_POST['isJavaScript'])) {
			$_SESSION[GALLERY_ID]['isJavaScript'] = ($_POST['isJavaScript'] === 'on')?
																 true
																 :
																 false;
		}
		elseif (!isset($_SESSION[GALLERY_ID]['isJavaScript']))
		{
			$_SESSION[GALLERY_ID]['isJavaScript'] = false;
		}

		// SET WYSIWYG-EDITOR AND JAVASCRIPT ACTIVE
		return defined('JS_EDITOR') && $_SESSION[GALLERY_ID]['isJavaScript'];
	}

	//
	// SET MSIE VERSION AFTER LOGIN
	// kh_mod 0.4.1, add
	function setVersionIE() {

		// IF MS INTERNET EXPLORER
		if (isset($_POST['ie'])) {
			$_SESSION[GALLERY_ID]['ie'] = array();
		}

		// IF IE 8 OR LESS
		if (isset($_POST['ie8'])) {
			$_SESSION[GALLERY_ID]['ie'][8] = true;
		}

		// IF IE 7 OR LESS
		if (isset($_POST['ie7'])) {
			$_SESSION[GALLERY_ID]['ie'][7] = true;
		}

		// IF IE 6 OR LESS
		if (isset($_POST['ie6'])) {
			$_SESSION[GALLERY_ID]['ie'][6] = true;
		}
	}

	//
	// CHECK FOLDER ID
	// kh_mod 0.4.0 rc1, add
	function checkFolderID($folderID) {

		if (isset($this->all_folders[$folderID])) {
			$isFolderID = true;
		}
		else {
			$this->displayStatus($this->lang['nofolderid'] .' #'. $folderID, 3);
			$isFolderID = false;
		}

		return $isFolderID;
	}

	//
	// CHECK CURRENT SKIN
	// kh_mod 0.4.0 b4, add
	function checkCurrentSkin() {

		// USED SKIN NOT AVAILABLE OR UP TO DATE
		$skinPath = sprintf('%s/skins/%s/', ROOT_FOLDER, $this->activeskin);
		$skinUsed = ucfirst($this->activeskin);
		if (!is_readable($skinPath .'templates')) {
			$_REQUEST['display'] = 'options';
			$this->displayStatus(sprintf($this->lang['skin_unavailable'], $skinUsed), 3);
		}
		// CHECK SKIN VERSION
		elseif (is_readable($skinPath .'settings.php')) {
			include ($skinPath .'settings.php');
			$found = preg_match('/kh_mod\D*([0-9]\.[0-9]\.[0-9]((\s|-)[a-z]{1,2}\d)?)/', $skin_version, $treffer);
			if (!$found || version_compare($treffer[1], '0.4.0-rc1', '<')) {
				$version = ($skin_version)?
							  '('. htmlspecialchars(trim($skin_version), ENT_QUOTES, 'ISO-8859-1') .')'
							  :
							  '';
				$this->displayStatus(sprintf($this->lang['notuptodate_skin'], $version, $skinUsed), 2);
			}
		}
	}

	//
	// DISPLAY USED MEMORY
	// kh_mod 0.4.0 b4, add
	function displayUsedMemory() {

		$this->getMemoryStatus();
		if ($this->currentMemory['allocate'] > 0 && $this->currentMemory['limit'] > 0) {
			$allocate = $this->currentMemory['allocate']/$this->currentMemory['limit'] * 100;
			$message  = sprintf($this->lang['memoryallocated'] .'%s',
								sprintf('<span title="%s">%s</span>',
									$this->convertBytes($this->currentMemory['allocate']),
									number_format($allocate, 1, $this->lang['decimalsign'], '')
								),
								'<a href="'.ADMIN_INDEX.'?display=options&amp;tab=3">...</a>'
							);
			$this->displayStatus($message, ($allocate < 90) ? 1:2);
		}
	}

	//
	// DISPLAY SYSTEM FOLDER
	// kh_mod 0.4.0 rc1, add; 0.4.2 changed
	function displaySystem() {
		$Keywords        = &$this->getInstance('MG2Keywords');
		$numKeywords     = $Keywords->getNumKeywords();
		$numBookmarked   = count($this->selectIndexDB(true, 'all_items', 15));
		$numLastImported = count($this->getLastImportedIDs());
		include ADMIN_FOLDER .'admin_systemfolders.php';
	}

	//
	// DISPLAY BOOKMARKED ITEMS
	// kh_mod 0.4.0 rc1, add
	function displayBookmarked() {
		$bookmarkedItems = $this->selectIndexDB(true, 'all_items', 15, 31);
		$numItems		  = count($bookmarkedItems);
		include ADMIN_FOLDER .'admin_bookmarked.php';
	}

	//
	// DISPLAY LAST IMPORTED ITEMS
	// kh_mod 0.4.3, changed
	function displayLastImported() {
		$itemIDs  = $this->getLastImportedIDs();
		$numItems = count($itemIDs);
		include ADMIN_FOLDER .'admin_lastimported.php';
	}

	//
	// DISPLAY ALL KEYWORDS
	// kh_mod 0.4.0 rc1, add
	function displayKeywords() {
		$Keywords			    = &$this->getInstance('MG2Keywords');
		$this->all_folders    = $Keywords->getAllKeywordFolders();
		$this->itemAllocation = $Keywords->getNumItemAllocation();
		$keywordIDs		       = array_keys($this->all_folders);
		$this->sortIndexDB($keywordIDs, 'all_folders', 2);
		include ADMIN_FOLDER .'admin_keywords.php';
	}

	//
	// DISPLAY SORT VIEW
	// kh_mod 0.4.0 rc1, add
	function displaySortview($folderID, $currentPage) {

		if (!$this->checkFolderID($folderID)) {
			$this->displayTableview(1, 1);
			return;
		}

		require_once ADDON_FOLDER .'sorting/sorting_view.php';
	}

	//
	// DISPLAY FILE UPLOAD VIEW
	// kh_mod 0.4.0 rc1, add
	function displayUpload($folderID, $currentPage) {

		if (!$this->checkFolderID($folderID)) {
			$this->displayTableview(1, 1);
			return;
		}

		// DISPLAY MAX POSSIBLE UPLOADE PER FORM
		$max_upload = ini_get('post_max_size');
		$max_upload = preg_replace('/(\d+)M$/','${1} MByte', $max_upload);
		$this->displayStatus(sprintf('%s %s',
										$this->lang['maxupload'],
										$max_upload
								  ));

		// DISPLAY UPLOAD FORM
		$Treeview  = &$this->getInstance('MG2Treeview');
		$itemsDirs = $Treeview->getItemsDirs();
		$explorer  = $Treeview->buildExplorer($itemsDirs);
		$setupURL  = ADMIN_INDEX .'?display=options&amp;fID='. $folderID .'&amp;page=' .$currentPage;
		$checked   = $this->getResizeOptions('import');
		$verify    = $this->setVerificationToken('upload');
		include ADMIN_FOLDER .'admin_upload.php';
	}

	//
	// DISPLAY FILE IMPORT VIEW
	// kh_mod 0.4.1, add
	function displayImport($folderID, $currentPage) {

		if (!$this->checkFolderID($folderID)) {
			$this->displayTableview(1, 1);
			return;
		}

		include(INC_FOLDER .'mg2admin_import.php');
		$Import		 = &$this->getInstance('MG2Import');
		$Treeview	 = &$this->getInstance('MG2Treeview');
		$itemsDirs   = $Treeview->getItemsDirs();
		$explorer	 = $Treeview->buildExplorer($itemsDirs);
		$checked		 = $this->getResizeOptions('import');
		$verify		 = $this->setVerificationToken('import');
		$url2setup	 = ADMIN_INDEX .'?display=options&amp;fID='. $folderID .'&amp;page='. $currentPage;
		$importTofID = isset($_POST['importTofID']) ?
							max((int)$_POST['importTofID'], 1)
							:
							$folderID;
		$folderName  = $this->mb_shorten($this->getFolderName($importTofID), -47);
		$subdir		 = $Import->getCurrentSubdir();
		$newFiles	 = $Import->getNotImportedFiles($subdir);

		if (!$newFiles) {
			$this->displayStatus($this->lang['nofilestoimport'], 1);
		}
		include(ADMIN_FOLDER .'admin_import.php');
	}

	//
	// DISPLAY OPTIONS
	// kh_mod 0.4.0 rc1, add
	function displayOptions($folderID, $currentPage) {

		if (!$this->checkFolderID($folderID)) {
			$this->displayTableview(1, 1);
			return;
		}

		require INC_FOLDER .'mg2admin_options.php';
		$Options = &$this->getInstance('MG2Options');
		$Options->tabMenu($folderID, $currentPage);
	}

	//
	// DISPLAY DEFAULT TABLE VIEW
	// kh_mod 0.4.0 rc1, add
	function displayTableview($folderID, $currentPage) {

		if ($this->checkFolderID($folderID)) {
			include INC_FOLDER .'mg2admin_tableview.php';
		}
	}

	//
	//	GET ALL IDs OF THE LAST IMPORTED ITEMS
	// kh_mod 0.4.2, add
	function getLastImportedIDs() {

		// INIT RETURN VALUE
		$importedItems = array();

		if (isset($_SESSION[GALLERY_ID]['importedItems']) &&
			is_array($_SESSION[GALLERY_ID]['importedItems']))
		{
			foreach ($_SESSION[GALLERY_ID]['importedItems'] as $itemID) {
				if (isset($this->all_items[$itemID])) {
					$importedItems[] = $itemID;
				}
			}
		}

		return $importedItems;
	}

	//
	// CONVERT BYTES TO KB, MB OR GB
	// kh_mod 0.3.1, add
	function convertBytes($bytes, $precision=2) {

		// INIT VALUES
		$prec  = 0;
		$units = array('Bytes', 'KBytes', 'MBytes', 'GBytes');

		// CALCULATE
		foreach($units as $unit) {
			if ($bytes < 1024) break;
			$bytes /= 1024;
			$prec   = $precision;
		}

		// FORMAT CALCULATED BYTES
		return sprintf('%s %s',
					 number_format($bytes, $prec, $this->lang['decimalsign'],''),
					 $unit
				 );
	}

	//
	// GET ITEM PROCESS LIST (SESSION)
	// kh_mod 0.4.1, add
	function getItemProcessList() {

		$tasks    = array();
		$listName = 'rebuildTasks';
		if (!empty($_SESSION[GALLERY_ID][$listName])		&&
			 is_array($_SESSION[GALLERY_ID][$listName]))
		{
			$tasks = $_SESSION[GALLERY_ID][$listName];
		}
		return $tasks;
	}

	//
	// SELECT PENDING ITEM PROCESS TASKS
	// kh_mod 0.4.0 b4, add; 0.4.2 changed
	function selectPendingTasks() {

		// INIT RETURN VALUE
		$tasks = array();

		// SELECT IMPORT STATUS
		foreach (array_keys($this->all_items) as $itemID) {
			if (!$modify = (int)$this->all_items[$itemID][16] & 516096) continue;

			$tasks[$itemID] = array(
										'modify' => $modify >> 12,
										'fName'  => trim($this->all_items[$itemID][6]),
										'subdir' => trim($this->all_items[$itemID][7])
									);
		}

		// SET PENDING TASKS
		$_SESSION[GALLERY_ID]['rebuildTasks'] = $tasks;
	}

	//
	// DETERMINE ALL SELECTED ITEMS
	// kh_mod 0.4.3, add
	function getSelectedItems() {

		if (isset($_POST['filerow']) && is_array($_POST['filerow'])) {
			$itemIDs = array_intersect(
								$_POST['filerow'],
								array_keys($this->all_items)
						  );
		}
		else {
			$itemIDs = array();
		}

		return $itemIDs;
	}

	//
	// ITEM SETTING DIALOG
	// kh_mod 0.4.0 rc1, changed
	function editItem($editID, $updatedComment, $display) {
		if (!isset($this->all_items[$editID])) {
			$this->log('ERROR: In editID(), image ID #'. $editID .'not founded!');
			$this->displayStatus(sprintf($this->lang['nopictureid'], $editID), 3);
			return false;
		}

		// GET PARENT FOLDER SETTING
		$itemRC	 = $this->all_items[$editID];
		$folderID = max((int)$itemRC[1], 1);
		$this->getFolderSettings($folderID);

		// CREATE NAVIGATION ELEMENTS
		list( $currentPage,
				$prevID,
				$nextID
		) = $this->getItemNavigation($editID, null, $display);

		// GET ITEM VALUES
		$dialog			= ($nextID === -1) ? '':'editItem';
		$title			= $this->htmlchars2entities($itemRC[2]);
		$description	= $this->isJavaScriptEditor() ?
							  $itemRC[3]							// WYSIWYG HTML-editor
							  :
							  $this->br2nl($itemRC[3]);		// plain text-editor
		$description	= $this->htmlchars2entities($description);
		$publish			= $this->time2date($itemRC[4], true);
		$position		= (int)$itemRC[5];
		$filename		= $this->htmlchars2entities($itemRC[6]);
		$subdir			= $this->htmlchars2entities($itemRC[7]);
		$photographer	= $this->htmlchars2entities($itemRC[14]);
		$selected		= empty($itemRC[15]) ? '':'checked="checked"';

		// GET KEYWORDS
		$Keywords  = &$this->getInstance('MG2Keywords');
		$keyArray  = $Keywords->getKeywords($editID);
		$keyString = $this->htmlchars2entities(implode(', ', $keyArray));

		// GET CONTENT TYPE
		$contentType = $this->getContentType($editID);

		// GET ITEM ICON
		list( $thumbID,
				$thumbFile,
				$thumbWidth,
				$thumbHeight
		) = $this->getFileIcon($editID, $contentType, true);

		// ADD IMAGE SUFFIX
		$thumbFile.= $isuffix = sprintf('?%d', mt_rand(0,10000));

		// THUMB SIZE ATTRIBUTE
		$thumbSize = sprintf('width="%d" height="%d"', $thumbWidth, $thumbHeight);

		// DISPLAY IMAGE SETTING
		include(ADMIN_FOLDER .'admin_editItem.php');

		// DISPLAY COMMENT OVERVIEW
		$Comments	  = &$this->getInstance('MG2Comments');
		$itemComments = $Comments->getComments($editID);
		if (($numComments = count($itemComments)) > 0) {
			include(ADMIN_FOLDER .'admin_comments.php');
		}

		// CURRENT PAGE AND SUFFIX FOR IMAGE UPDATING
		return array($folderID, $currentPage);
	}

	//
	// UPDATE ITEM DATA RECORD ACTION
	// kh_mod 0.4.0 b3, changed
	function updateItem($itemID) {

		// EXISTS REQUEST ID?
		if (!isset($this->all_items[$itemID])) {
			$this->log('ERROR: Fct. updateID(), item ID #'. $itemID .' not founded!');
			$this->displayStatus(sprintf($this->lang['nopictureid'], $itemID), 3);
			return false;
		}

		// CLEAN INPUT VALUES
		$newFileName  = $this->charfix($_POST['filename']);
		$position	  = (int)$_POST['position'];									// order position for image
		$publish		  = $this->date2time($_POST['publish']);
		$title		  = $this->charfix($_POST['title']);
		$title		  = $this->cleanHTMLContent($title, array('a', 'br', '!--'));
		$description  = $this->getFormTextarea('description');
		$photographer = $this->charfix($_POST['photographer']);				// artist for exif display
		$selected	  = !empty($_POST['selected']) ? true:false;				// record selected
		$folderID	  = (int)$_POST['setthumb'];									// folder id for thumb icon

		// INITIALIZE STATUS MESSAGE AND REFERENCE TO ITEM DB
		$this->status = '';
		$itemRC		  = &$this->all_items[$itemID];

		// SET AS THUMBNAIL FOR FOLDER?
		$fDB_ok = true;
		if (isset($this->all_folders[$folderID])) {
			$thumbfile = $this->getFilePathByName($itemRC[6], $itemRC[7], 'thumb');
			if (is_file($thumbfile)) {
				$this->all_folders[$folderID][6] = $itemID;						// use image as folder icon
				$fDB_ok = ($this->write_fDB('upd', array($folderID)) > 0)?	// write folder to database
							 true
							 :
							 false;
			}
		}

		// SET TITLE, DESCRIPTION, POSITION
		$itemRC[2] = $title;
		$itemRC[3] = $description;
		$itemRC[5] = $position;

		// SET THE NEW DATE
		if ($publish !== false) {
			$diffTime = $itemRC[4] - $publish;
			if ($diffTime < 0 || 59 < $diffTime) $itemRC[4] = $publish;
		}

		// IF SET KEYWORDS, kh_mod 0.4.3, changed
		if (isset($_POST['keywords'])) {
			$Keywords = &$this->getInstance('MG2Keywords');
			$keysOK	 = $Keywords->setItemKeywords($itemID);
		}

		// IF VIDEO/SOUND FILE
		if ($this->getContentType($itemID, 'flash'))
		{
			// SET FLASH CANVAS SIZE
			$itemRC[8] = (int)$_POST['canvas_width'];
			$itemRC[9] = (int)$_POST['canvas_height'];

			// SET SPLASH OPTIONS
			$Splashes = &$this->getInstance('MG2Splashes');
			$Splashes->setSplashRecord($itemID);
		}

		// RENAME FILE NAME?
		$ren_ok = ($newFileName && ($itemRC[6] !== $newFileName))?
					 $this->renameFiles($itemID, $newFileName)
					 :
					 true;

		// SET PHOTOGRAPHER
		$itemRC[14] = $photographer;

		// SET RECORD UNSELECTED
		if (!$selected) {
			$itemRC[15] = 0;
		}
		// SET RECORD SELECTED
		elseif (empty($itemRC[15])) {
			$itemRC[15] = time();
		}

		// WRITE ITEM DATABASE AND UPDATE
		$iDB_ok = ($this->write_iDB('upd', array($itemID)) > 0)?
					 true
					 :
					 false;

		// OUTPUT STATUS MESSAGES
		if ($iDB_ok === false) {
			$this->displayStatus($this->lang['iDB_error'], 3);					// item database error
			$this->log('ERROR: In updateItem(), concerns item ID #'. $itemID);
		}
		elseif ($ren_ok === false) {
			$this->displayStatus();														// rename item
			$this->log('Warning: Couldn\'t rename item file, ID #'. $itemID);
		}
		else {
			$this->displayStatus($this->lang['updatesuccess']);				// update item record ok
			$this->log('Success of updating item record, ID #'. $itemID);
		}
		if ($fDB_ok === false) {														// set folder icon warning
			$this->displayStatus($this->lang['setfoldericon_error'], 2);
		}

		// COMPLETELY SUCCESSFULL?
		return ($ren_ok && $iDB_ok && $fDB_ok)?
				 max((int)$itemRC[1], 1)	//parent id
				 :
				 false;
	}

	//
	// RENAME ITEM NAME INCL. THUMB, MEDIUM AND COMMENT FILES
	// kh_mod 0.4.1, changed
	function renameFiles($itemID, $newFileName) {

		// GET NEEDED FILE VALUES
		$oldFileName = $this->all_items[$itemID][6];
		$subdir		 = $this->all_items[$itemID][7];
		$oldItemPath = $this->getFilePathByName($oldFileName, $subdir);
		$newItemPath = $this->getFilePathByName($newFileName, $subdir);

		// CHECK FILENAME FOR ILLEGAL CHARACTERS
		if (preg_match('/[:;<>\/\\\|\?"]/', $newFileName)) {
			$this->setStatus(sprintf('%s<span style="display:block;">\'%s\'</span>',
									 $this->lang['renamefailure'],
									 $this->htmlchars2entities($newFileName, ENT_QUOTES)
								 ), 2);
			return false;
		}

		// CHECK FILE EXTENSION
		$ext = substr(strrchr($newFileName, '.'), 1);
		if (!$ext || !$this->checkFileExtension($ext)) {
			$this->setStatus(sprintf('%s<span style="display:block;">\'%s\'</span>',
									 $this->lang['forebiddenxtensions'],
									 $this->htmlchars2entities($newFileName, ENT_QUOTES)
								 ), 2);
			return false;
		}

		// CHECK DUPLICATE FILE NAME
		if (is_file($newItemPath)) {
			$this->setStatus(sprintf($this->lang['duplicatefile'],
									 $this->htmlchars2entities($newFileName, ENT_QUOTES),
									 $subdir ? substr($subdir, 1):$this->imagefolder
								 ), 2);
			return false;
		}

		// RENAME ITEM
		if (
			!$newItemPath								||		// new file formally incorrect
			!$oldItemPath								||		// orig. file formally incorrect
			!is_file($oldItemPath)					||		// orig. file not found
			!rename($oldItemPath, $newItemPath)			// renaming error
		) {
			$this->setStatus(sprintf('%s<span style="display:block;">\'%s\'</span>',
									 $this->lang['renamefailure_image'],
									 $this->htmlchars2entities($newFileName, ENT_QUOTES)
								 ), 3);
			return false;
		}

		// SET NEW FILE NAME ENTRY
		$renameOK = true;
		$this->all_items[$itemID][6] = $newFileName;

		// RENAME THUMBNAIL
		$thumb_old = $this->getFilePathByName($oldFileName, $subdir, 'thumb');
		$thumb_new = $this->getFilePathByName($newFileName, $subdir, 'thumb');
		if (is_file($thumb_old) && !rename($thumb_old, $thumb_new)) {
			$this->setStatus($this->lang['renamefailure_thumb'], 2);
			$renameOK = false;
		}

		// RENAME MEDIUM
		$medium_old = $this->getFilePathByName($oldFileName, $subdir, 'medium');
		$medium_new = $this->getFilePathByName($newFileName, $subdir, 'medium');
		if (is_file($medium_old) && !rename($medium_old, $medium_new)) {
			$this->status[2].= sprintf('<div style="color:#C69023;margin-top:.5em;">%s %s</div>',
										$this->lang['warning'],
										$this->lang['renamefailure_medium']
									 );
			$renameOK = false;
		}

		// RENAME COMMENT
		$comment_old = $this->getFilePathByName($oldFileName, $subdir, 'comment');
		$comment_new = $this->getFilePathByName($newFileName, $subdir, 'comment');
		if (is_file($comment_old) && !rename($comment_old, $comment_new)) {
			$this->status[2].= sprintf('<div style="color:red;margin-top:.5em;">%s %s</div>',
										$this->lang['error'],
										$this->lang['renamefailure_comment']
									 );
			$renameOK = false;
		}

		return $renameOK;
	}

	//
	// START BOOKMARK REMOVE OF AN ITEM
	// kh_mod 0.4.0 rc1, add
	function removeItemBookmark($itemID) {

			return isset($this->all_items[$itemID]) ?
					 $this->removeBookmarksAction(array($itemID))
					 :
					 $this->displayStatus(sprintf($this->lang['nopictureid'], $itemID), 2);
	}

	//
	// START BOOKMARK REMOVE OF SELECTED ITEMS
	// kh_mod 0.4.3, changed
	function removeSelectedBookmarks() {

		// GET TO REMOVE ITEMS
		$itemIDs = $this->getSelectedItems();

		return count($itemIDs) ?
				 $this->removeBookmarksAction($itemIDs)
				 :
				 $this->displayStatus($this->lang['nobookmarks2remove'], 1);
	}

	//
	// START BOOKMARK REMOVE OF ALL ITEMS
	// kh_mod 0.4.0 rc1, add
	function removeAllBookmarks() {

		return ($itemIDs = $this->selectIndexDB(true, 'all_items', 15))?
				 $this->removeBookmarksAction($itemIDs)
				 :
				 $this->displayStatus($this->lang['nobookmarks2remove'], 1);
	}

	//
	// DELETE BOOKMARKS FROM ITEMS
	// kh_mod 0.4.0 rc1, add
	function removeBookmarksAction($itemIDs) {

		// INIT VALUES
		$removedIDs	= array();
		$writeOK		= false;

		foreach ($itemIDs as $itemID) {
			if((int)$this->all_items[$itemID][15] === 0) continue;

			$this->all_items[$itemID][15] = 0;
			$removedIDs[] = $itemID;
		}

		if ($removedIDs) {
			$writeOK = $this->write_iDB('upd', $removedIDs);
		}

		// DISPLAY MESSAGE
		($writeOK)?
			$this->displayStatus(sprintf($this->lang['bookmarksremoved'], count($removedIDs)))
			:
			$this->displayStatus($this->lang['bookmarksnotremoved'], 3);
	}

	//
	// ASK DELETE IMAGE DIALOG
	// kh_mod 0.1.0, add, kh_mod 0.4.2 changed
	function askDeleteID($deleteID, $page, $display) {

		// CHECK ITEM ID
		if (!array_key_exists($deleteID, $this->all_items)) {
			$this->displayStatus(sprintf($this->lang['nopictureid'], $deleteID), 3);
			return 1;
		}

		// GET ITEM ICON
		list(	$thumbID,
				$thumbFile,
				$thumbWidth,
				$thumbHeight
		) = $this->getFileIcon($deleteID, null, true);

		// GET DIALOG VALUES
		$delete		 = 'image';
		$folderID	 = (int)$this->all_items[$deleteID][1];
		$fileName	 = $this->all_items[$deleteID][6];
		$message		 = sprintf($this->lang['deletefile'], $fileName);
		$cancelTitle = $this->lang['cancel'];
		$okTitle	    = $this->lang['ok'];
		$cancelURL   = sprintf('%s?fID=%d&amp;page=%s&amp;display=%s',
								ADMIN_INDEX,
								$folderID,
								$page,
								$display
							);
		$hiddenParm	 = array (
								'action'  => 'deleteID',
								'iID'     => $deleteID,
								'page'    => $page,
								'display' => $display,
								'verify'  => $this->setVerificationToken('deleteID')
							);

		// DISPLAY DIALOG TEMPLATE
		include(ADMIN_FOLDER .'admin_delete.php');

		return $folderID;
	}

	//
	// DELETE SINGLE ITEM ACTION
	// kh_mod 0.4.0 rc1, changed
	function deleteID($itemID) {

		// GET PARENT ID
		$parentID = (int)$this->all_items[$itemID][1];

		// DELETE ITEM
		$delStatus = $this->deleteItem($itemID);

		// DELETE IMAGE USED AS FOLDER ICON
		$this->delFolderIcons(array($itemID));

		// DELETE COUNTER ENTRY
		include_once(INC_FOLDER .'mg2admin_counter.php');
		$Counter = &$this->getInstance('MG2AdminCounter');
		$Counter->deleteRecords(array($itemID));

		// DELETE FLASH ITEM OR IMAGE USED AS SPLASH
		$Splashes = &$this->getInstance('MG2Splashes');
		$Splashes->deleteSplashes(array($itemID));

		// DELETE ITEM KEYWORD RECORD
		$Keywords = &$this->getInstance('MG2Keywords');
		$Keywords->deleteItemKeywords(array($itemID));

		// DELETED DATA BASE ENTRY?
		if (($delStatus & 4) && ($this->write_iDB('del', array($itemID)) >= 0)) {
			$this->status.= '<div>'. $this->lang['recorddeleted'] .'</div>';
		}
		// PHYSICALLY IMAGE FILES AND/OR TEMPORARLY IMAGE RECORDS DELETED?
		elseif ($delStatus & 6) {
			$this->status.= sprintf('<div style="margin-top:8px;color:red">%s %s</div>',
									 $this->lang['error'],
									 $this->lang['iDB_error']
								 );
		}

		// ITEM ID EXISTS?
		if ($delStatus & 1)
			$errtype = ($delStatus & 2)?	// item file physically deleted?
						  0	// ok
						  :
						  2;	// warning
		else
			$errtype = 3;	// error

		$this->displayStatus($this->status, $errtype);

		// RETURN FOLDER ID
		return max($parentID, 1);
	}

	//
	// DELETE SEVERAL FILES
	// kh_mod 0.4.3, changed
	function deleteFiles() {

		// INIT VALUES
		$itemIDs    = $this->getSelectedItems();
		$todelete	= count($itemIDs);
		$delfiles	= 0;
		$delrecords	= array();

		// DELETE FILES
		$this->log('Delete file(s) started');

		foreach ($itemIDs as $itemID) {

			if ($delStatus = $this->deleteItem($itemID)) {
				if ($delStatus & 2) $delfiles++;						// item file deleted from server?
				if ($delStatus & 4) $delrecords[] = $itemID;		// temp database entry deleted?
			}
		}

		// DELETE IMAGES USED AS FOLDER ICONS
		$this->delFolderIcons($delrecords);

		// DELETE COUNTER ENTRIES
		include_once(INC_FOLDER .'mg2admin_counter.php');
		$Counter = &$this->getInstance('MG2AdminCounter');
		$Counter->deleteRecords($delrecords);

		// DELETE FLASH ITEM XOR IMAGE USED AS SPLASH
		$Splashes = &$this->getInstance('MG2Splashes');
		$Splashes->deleteSplashes($delrecords);

		// DELETE ITEM KEYWORD RECORD
		$Keywords = &$this->getInstance('MG2Keywords');
		$Keywords->deleteItemKeywords($delrecords);

		// BUILD STATUS MESSAGE
		$file_txt = ($todelete > 1)? $this->lang['filesdeleted']:$this->lang['filedeleted'];
		if ($todelete < 1) {
			$this->log('ERROR: No file selected to delete!');
			$message = $this->lang['filenotselected'];
			$errtype = 1;
		} elseif ($delfiles < $todelete) {
			$message = $delfiles .' '. $this->lang['of'] .' '. $todelete .' '. $file_txt;
			$errtype = 2;
		} else {
			$message = $delfiles .' '. $file_txt;
			$errtype = 0;
		}

		//  TEMPORARLY DELETED ITEM RECORDS FROM ARRAY
		$deleted = count($delrecords);
		// WRITE ITEM DATA BASE AND UPDATE IT
		if ($deleted && ($this->write_iDB('del', $delrecords) >= 0)) {
			$this->log('Summary: Deleted '. $deleted .' database entry(s) of '. $todelete .' selected');
			$record_txt = ($deleted > 1)? $this->lang['recordsdeleted']:$this->lang['recorddeleted'];
			$message.= '<div>'. $deleted .' '. $record_txt .'</div>';
		// ITEM FILES DELETED AND/OR ITEM RECORDS DELETED TEMPORARLY?
		} elseif ($deleted || $delfiles) {
			$message.= sprintf('<div style="margin-top:8px;color:red">%s %s</div>',
								$this->lang['error'],
								$this->lang['iDB_error']
						  );
		}
		$this->displayStatus($message, $errtype);
	}

	//
	// DELETE ITEM AND ASSOCIATED ENTRIES
	// kh_mod 0.4.1, changed
	function deleteItem($itemID) {

		// EXISTS REQUESTED ID?
		if (!isset($this->all_items[$itemID])) {
			$this->displayStatus(sprintf($this->lang['nopictureid'], $itemID), 3);
			return false;
		}

		// SET ITEM ID OK AND GET FILE NAME AND SUBDIR
		$delStatus = 1;
		$fileName  = trim($this->all_items[$itemID][6]);
		$subdir	  = trim($this->all_items[$itemID][7]);

		// IS EXISTS ITEM, DELETE IT!
		$filepath = $this->getFilePathByName($fileName, $subdir);
		if (is_file($filepath)) {
			if (!unlink($filepath)) {
				$this->log('ERROR: Couldn\'t delete file \''.$fileName.'\'');
				$this->status = $this->lang['filenotdeleted'].' \''.$fileName.'\'';
				return $delStatus;
			}
			else {
				$this->log('Deleting file \''. $fileName .'\'');
				$this->status = $this->lang['filedeleted'].' \''.$fileName.'\'';
				$delStatus |= 2;
			}
		}
		else {
			$this->log('ERROR: Couldn\'t found file \''. $fileName .'\' to delete!');
			$this->status = $this->lang['filenotfound'].' \''.$fileName.'\'';
		}

		// DELETE THUMBNAIL AND MEDIUM IMAGE
		$this->deleteThumbMedium($fileName, $subdir);

		// DELETE COMMENT FILE
		$this->deleteCommentFile($fileName, $subdir);

		// DELETE DATABASE ENTRY
		if ($del_ok = $this->delArrayItem('all_items', $itemID)) {
			$this->log('Database entry deleted of item ID #'. $itemID);
			$delStatus |= 4;
		} else {
			$this->log('ERROR: Couldn\'t delete item database entry!');
		}

		return $delStatus;
	}

	//
	// DELETE THUMBNAIL AND MEDIUM IMAGE
	// kh_mod 0.4.1, add
	function deleteThumbMedium($fileName, $subdir) {

		// INIT START VALUES
		$deleteOK = true;
		$modify   = 0;

		// DELETE THUMBNAIL
		$thumbPath = $this->getFilePathByName($fileName, $subdir, 'thumb');
		if (is_file($thumbPath)) {
			$modify |= 1;
			if (!unlink($thumbPath)) $deleteOK = false;
		}

		// DELETE MEDIUM IMAGE
		$mediumPath = $this->getFilePathByName($fileName, $subdir, 'medium');
		if (is_file($mediumPath)) {
			$modify |= 2;
			if (!unlink($mediumPath)) $deleteOK = false;
		}

		return $deleteOK ? $modify:false;
	}

	//
	// DELETE COMMENT FILE
	// kh_mod 0.4.1, add
	function deleteCommentFile($fileName, $subdir) {

		$commentPath = $this->getFilePathByName($fileName, $subdir, 'comment');
		return is_file($commentPath) ?
				 unlink($commentPath)
				 :
				 true;
	}

	//
	// DELETED ITEMS DELETE ALSO AS FOLDER ICON
	// kh_mod 0.3.1, add
	function delFolderIcons($delItems=array()) {

		$delItems = array_flip($delItems);
		$records  = array();
		foreach($this->all_folders as $folderID=>$folderRC) {

			// IMAGE NOT USED AS FOLDER ICON?
			if (!isset($delItems[(int)$folderRC[6]])) continue;

			$this->all_folders[$folderID][6] = 0;	// default icon, -1 random image
			$records[] = $folderID;
		}
		if (!empty($records)) $this->write_fDB('upd', $records);
	}

	//
	// GET DIRECTORY TO ITEM IMPORT
	// kh_mod 0.4.0 b4, add
	function getImportDir($subdir) {

		$valid	= !preg_match('(\.\./|//|\\|%\d)', $subdir);	// forbidden path chars
		$dirPath = $this->imagefolder . $subdir;

		return ($valid && is_dir($dirPath))?
				 $dirPath
				 :
				 false;
	}

	//
	// GET FOLDER ICON
	// kh_mod 0.2.0, add, 0.4.0 rc1 changed
	function getFolderIcon($folderID=-1) {

		// INIT RETURN VALUES
		$iconFile = '';
		$selected = '';
		$imageID	 = isset($this->all_folders[$folderID]) ?
						(int)$this->all_folders[$folderID][6]
						:
						-1;	// random picture

		// IF SET IMAGE AS FOLDER ICON
		if ($imageID > 0 && $folderID > 1) {
			$filename = $this->all_items[$imageID][6];
			$subdir	 = $this->all_items[$imageID][7];
			if ($iconFile = $this->getFilePathByName($filename, $subdir, 'thumb')) {
				$selected	 = $iconFile;
				$thumbWidth  = (int)$this->all_items[$imageID][10];
				$thumbHeight = (int)$this->all_items[$imageID][11];
				$classCSS	 = 'thumb';
			}
			else $imageID	 = 0;	// default picture
		}

		// DISPLAY DEFAULT FOLDER ICON?
		if (!$iconFile || !is_readable($iconFile) || ($this->foldersetting & 16)) {
			$iconFile	 = ADMIN_IMAGES .'folder.gif';
			$fileInfo	 = getimagesize($iconFile);
			$thumbWidth  = $fileInfo[0];
			$thumbHeight = $fileInfo[1];
			$classCSS	 = 'thumb_default';
		}

		// PREPARE RETURN VALUES
		$sizeAttrb = 'width="'. $thumbWidth .'" height="'. $thumbHeight .'"';
		$iconFile  = $this->cleanURLString($iconFile);

		return array(
					'id'		=> $imageID,	// image ID for folder icon
					'path'	=> $iconFile,	// icon path used for displaying
					'thumb'	=> $selected,	// icon path used for text hint
					'attrb'	=> $sizeAttrb,	// width and height for thumb
					'class'	=> $classCSS	// class for thumb <img>-tag
				 );
	}

	//
	// NEW FOLDER DIALOG
	// kh_mod 0.4.0 rc1, add
	function editNewFolder($infolder, $currentPage, $folderType) {

		$qualifierID	= 'fID';
		$valueID			= $infolder;						// parent folder
		$action			= 'buildNewFolder';
		$dialog			= '';
		$headline		= $this->lang['newfolder'];
		$icon				= $this->getFolderIcon();		// default icon
		$icon['url']	= '';
		$iconOptions	= true;
		$iconSorting	= false;
		$iconPwdLock	= false;
		$moveToFolder	= false;
		$setFolderType = true;
		$sortContentBy	= 6;									// record index (name)
		$sortDirection	= 0;									// 0 means 'ascending'
		$folderName		= '';
		$position		= 1;
		$publish			= $this->time2date();
		$introtext		= '';
		$fNumCols		= '';									// number of cols (folder setting)
		$fNumRows		= '';									// number of rows (folder setting)
		$localThumbSet	= false;								// grid checkbox (local setting)

		// IF FOLDER TYPE: "LINK"
		if ($folderType === 1) {
			$headline	  = $this->lang['new_linkfolder']; 
			$folderURL    = $this->lang['folderurl_text'];
			$folderTarget = 0;	// _blank
		}

		$mg2 = &$this;
		include(ADMIN_FOLDER .'admin_folderdialog.php');
	}

	//
	// MAKE A NEW FOLDER ACTION
	// kh_mod 0.4.1, changed
	function buildNewFolder($infolder) {

		// DOES NOT EXIST FOLDER ID?
		if (!isset($this->all_folders[$infolder])) {
			$this->log('ERROR: Folder ID #'. $infolder .' not found! (function \'newfolder\')');
			$this->displayStatus($this->lang['nofolderid'] .' #'. $infolder, 3);
			return false;
		}

		// CLEAN REQUEST VALUES
		$input    = $this->cleanFolderInput($infolder);
		$errorMsg = '';

		// INTENDED NEW LINK FOLDER WITHIN OTHER LINK FOLDER
		if ($input['moveError']) {
			$infolder = 1;
			$errorMsg.= sprintf('<div style="margin-top:8px;color:#C69023">%s %s</div>',
								$this->lang['warning'],
								$this->lang['sublinkfolder']
							);
		}

		// NO PASSWORD CONFIRM
		if ($input['pwdError']) {
			$errorMsg.= sprintf('<div style="margin-top:8px;color:#C69023">%s %s</div>',
								$this->lang['warning'],
								$this->lang['nopwdmatch']
							);
		}

		// SAVE NEW FOLDER VALUES
		$fID = ++$this->folderAutoID;
		$this->all_folders[$fID] = array(
												$fID,							// folder autoid				[0]
												$infolder,					// move in folder (#id)		[1]
												$input['fname'],			// folder name					[2]
												$input['introtext'],		// introtext					[3]
												$input['publish'],		// timestamp (publish off)	[4]
												$input['position'],		// folder position			[5]
												$input['ficonID'],		// imageID for folder icon	[6]
												$input['sortMode'],		// folder sort mode			[7]
												$input['password'],		// password						[8]
												$input['localCols'],		// number of cols				[9]
												$input['localRows'],		// number of rows				[10]
												$input['ftype'],			// folder type					[11]
												$input['fURL']				// folder url					[12]
											);

		// DISPLAY RESULT
		$parentfolder = $this->getFolderName($infolder);
		if ($this->write_fDB('new', array($fID)) > 0) {
			$this->log('Created folder \''. $input['fname'] .'\' in \''. $parentfolder .'\'');
			$this->status = $this->lang['foldercreated'] .' \''. $input['fname'] .'\''. $errorMsg;
		} else {
			$this->log('Couldn\'t create folder \''. $input['fname'] .'\' in \''. $parentfolder .'\'');
			$this->status = sprintf('<div style="color:red">%s %s</div>',
									 $this->lang['error'],
									 $this->lang['iDB_error']
								 );
		}
		$this->displayStatus();

		// ID OF THE NEW FOLDER
		return $infolder;
	}

	//
	// FOLDER SETTING DIALOG
	// kh_mod 0.4.3, changed
	function editFolder($folderID, $currentPage) {

		// DOES NOT EXIST FOLDER ID?
		if ($this->checkFolderID($folderID) === false) return 1;

		// FOLDER VALUES
		$folderRC		= &$this->all_folders[$folderID];
		$qualifierID	= 'fID';
		$valueID			= $folderID;
		$action			= 'updateFolder';
		$dialog			= 'editFolder';
		$headline		= $this->lang['editfolder'] . (($folderID === 1)? '&nbsp;('. $this->lang['root'] .')':'');
		$icon				= $this->getFolderIcon($folderID);
		$icon['url']	= $this->getAdminGalleryLink($folderID, $currentPage);
		$iconOptions	= $folderID > 1 ? true:false;
		$iconSorting	= true;
		$iconPwdLock	= empty($folderRC[8]) ? false:true;
		$moveToFolder	= $folderID > 1 ? true:false;
		$parentID		= (int)$folderRC[1];
		$folderName		= $this->htmlchars2entities($folderRC[2]);
		$introtext		= $this->isJavaScriptEditor() ?
							  $folderRC[3]							// WYSIWYG HTML-editor
							  :
							  $this->br2nl($folderRC[3]);		// plain text-editor
		$introtext		= $this->htmlchars2entities($introtext);
		$publish			= $this->time2date($folderRC[4], true);
		$position		= (int)$folderRC[5];
		$sortContentBy	= (int)$folderRC[7] & 15;
		$sortDirection	= (int)$folderRC[7] & 16;
		$fNumCols		= '';		// number of cols (folder setting)
		$fNumRows		= '';		// number of rows (folder setting)
		$localThumbSet	= false;	// grid checkbox  (local setting)
		$folderType    = 0;		// default folder

		// IF LOCAL FOLDER SETTING IS ENABLED FOR THUMB GRID
		if ($folderRC[9] > 0 || $folderRC[10] > 0) {
			$fNumCols = ($folderRC[9]  > 0)? (int)$folderRC[9] : $this->lang['default'];
			$fNumRows = ($folderRC[10] > 0)? (int)$folderRC[10]: $this->lang['default'];
			$localThumbSet = true;
		}

		// IF FOLDER TYPE "Link"
		if (($folderID > 1) && ((int)$folderRC[11] === 1)) {
			$headline = $this->lang['edit_linkfolder'];
			list($url, $target) = unserialize($folderRC[12]);
			$folderURL    = $this->htmlchars2entities($url);
			$folderTarget = (int)$target;
			$folderType   = 1;
		}

		// DISPLAY FOLDER DIALOG
		$mg2 = &$this;
		include(ADMIN_FOLDER .'admin_folderdialog.php');

		return $folderID;
	}

	//
	// UPDATE FOLDER ACTION
	// kh_mod 0.4.1, changed
	function updateFolder($folderID) {

		// MOVE TO FOLDER
		$moveto = empty($_POST['moveto']) ? -1:(int)$_POST['moveto'];

		// ROOT FOLDER
		if ((int)$folderID === 1) {
			$movetoID = 'root';
		}
		// DOES PARENT FOLDER ID EXIST
		elseif (array_key_exists($moveto, $this->all_folders)) {
			$movetoID = $moveto;
		}
		else {
			$movetoID = false;
		}

		// CHECK FOLDER IDs
		do {
			$isError = true;
			$log_msg = 'ERROR: %s folder ID #%s not found! (fct: \'updateFolder\')';

			// IS NOT EXISTS 'MOVETO' FOLDER ID
			if (!$movetoID) {
				$this->log(sprintf($log_msg, 'Moveto', $moveto));
				$this->displayStatus($this->lang['nofolderid'] .' #Moveto '. $moveto, 3);
				break;
			}

			// IS NOT EXISTS 'EDIT' FOLDER ID
			if (!array_key_exists($folderID, $this->all_folders)) {
				$this->log(sprintf($log_msg, 'Update', $folderID));
				$this->displayStatus($this->lang['nofolderid'] .' #Update '. $folderID, 3);
				break;
			}

			$isError = false;
		}
		while(0);

		// SET AND SAVE UPDATES
		return !$isError ?
				 $this->updateFolderHelp($movetoID, $folderID)
				 :
				 false;
	}

	//
	// UPDATE FOLDER (HELPER)
	// kh_mod 0.4.1, add
	function updateFolderHelp($movetoID, $folderID) {

		// BUILD FOLDER STRUCTURE AND ALLOCATE ITEMS
		$this->folderStructure = $this->getValidSubfolders($folderID);
		$this->itemAllocation  = $this->getItemAllocation($this->folderStructure);
		$folderIDs = array_diff(array_keys($this->folderStructure), array($folderID));
		$itemIDs   = array_keys($this->itemAllocation[$folderID]);

		// CLEAN REQUEST VALUES
		$input = $this->cleanFolderInput($movetoID, $folderID);

		// SAVE OLD FOLDER VALUES
		$oldFolderName = trim($this->all_folders[$folderID][2]);
		$oldItemSortBy = (int)$this->all_folders[$folderID][7] & 15;

		// IF SORT BY EXIF DATE THAN SET EXIF DATE
		if (($oldItemSortBy !== 13) && (($input['sortMode'] & 15) === 13)) {
			$this->setExifDate($itemIDs);
		}

		// IF MOVE FOLDER FORBIDDEN
		if ($input['moveError']) {
			$movetoID = (int)$this->all_folders[$folderID][1];
			$errorMsg = sprintf('<div style="margin-top:8px;color:#C69023">%s %s</div>',
								$this->lang['warning'],
								$this->lang['sublinkfolder']
							);
		}
		else {
			$errorMsg = '';
		}

		// SAVE NEW VALUES
		$this->all_folders[$folderID][0]  = $folderID;
		$this->all_folders[$folderID][1]  = $movetoID;
		$this->all_folders[$folderID][2]  = $input['fname'];
		$this->all_folders[$folderID][3]  = $input['introtext'];
		$this->all_folders[$folderID][4]  = $input['publish'];
		$this->all_folders[$folderID][5]  = $input['position'];
		$this->all_folders[$folderID][6]  = $input['ficonID'];
		$this->all_folders[$folderID][7]  = $input['sortMode'];
		$this->all_folders[$folderID][8]  = $input['password'];
		$this->all_folders[$folderID][9]  = $input['localCols'];
		$this->all_folders[$folderID][10] = $input['localRows'];
		$this->all_folders[$folderID][11] = $input['ftype'];
		$this->all_folders[$folderID][12] = $input['fURL'];

		// READ NEW FOLDER SETTINGS (USED IN NEXT BOTH FUNCTIONS)
		$this->getFolderSettings($folderID);

		// SET NEW POSITIONS OF SUB FOLDERS TEMP, kh_mod 0.3.0, add
		if ($_POST['generate_fPos'] === 'ok') $this->setFolderPositions($folderIDs);

		// SET NEW POSITIONS OF ITEMS TEMP, kh_mod 0.1.0, add
		if ($_POST['generate_iPos'] === 'ok') $this->setItemPositions($itemIDs);

		// WRITE FOLDER DATABASE AND UPDATE, kh_mod 0.3.1, changed
		if ($this->write_fDB('upd', array($folderID)) > 0) {
			$this->log('Update of folder \''. $oldFolderName .'\' complete.');
			$this->displayStatus($this->lang['folderupdated'] . $errorMsg);
		} else {
			$this->log('Couldn\'t update folder \''. $oldFolderName .'\'!');
			$this->displayStatus($this->lang['foldererror'], 3);
		}

		return $folderID;
	}

	//
	// CLEAN REQUEST VALUES FOR FOLDER
	// kh_mod 0.4.1, changed
	function cleanFolderInput($movetoID, $folderID=-1) {

		// INIT RETURN DEFAULT VALUES
		$input = array(
						'ftype'		=> 0,
						'moveError' => false,
						'fURL'		=> '',
						'fname'		=> '',
						'position'	=> 1,
						'publish'	=> -1,
						'introtext'	=> '',
						'ficonID'	=> -1,
						'sortMode'	=> 6,
						'localCols'	=> 0,
						'localCols'	=> 0,
						'password'	=> '',
						'pwdError'  => false,
						'fURL'		=> ''
					);

		// IF SET FOLDER TYPE: "LINK" (NEW FOLDER ONLY)
		if ($folderID === -1	&& isset($_POST['ftype'])) {
			if ((int)$_POST['ftype'] === 1) $input['ftype'] = 1;
		}
		// GET FOLDER TYPE: EXISTING FOLDER
		elseif (isset($this->all_folders[$folderID][11])) {
			$input['ftype'] = (int)$this->all_folders[$folderID][11];
		}

		// INTENDED NEW LINK FOLDER WITHIN OTHER LINK FOLDER
		if ($input['ftype'] === 1) {
			foreach ($this->getFolderBranchToRoot($movetoID) as $id) {
				if ((int)$this->all_folders[$id][11] === 1) {
					$input['moveError'] = true;
					break;
				}
			}
		}

		// IF FOLDER TYPE: "LINK"
		if ($input['ftype'] === 1 && isset($_POST['fURL'])) {
			$fURL = array(
						 substr($this->charfix($_POST['fURL']), 0, 228),
						 (int)$_POST['fTarget']
					  );
			$input['fURL'] = serialize($fURL);
		}

		// CHECK NEW FOLDER NAME
		$input['fname'] = $this->charfix($_POST['fname']);
		$input['fname'] = $this->cleanHTMLContent($input['fname'], array('a', 'br', '!--'));
		$input['fname'] = (string)substr($input['fname'], 0, 255);	

		// IS NOT ROOT FOLDER?
		if ($movetoID !== 'root') {
			$oldParentID   = ($folderID < 1)? -1:(int)$this->all_folders[$folderID][1]; 
			$oldFolderName	= ($folderID < 1)? '':trim($this->all_folders[$folderID][2]);

			// EMPTY FOLDER NAME?
			if ($this->string_empty($input['fname'])) {
				$input['fname'] = ($this->string_empty($oldFolderName))?
										'untitled'
										:
										$oldFolderName;
			}

			// CHECK IF FOLDER NAME UNIQUE?
			if (!($this->extendedset & 2)					&&		// same folder name forbidden
				 ($oldFolderName !== $input['fname']	||		// folder name changed
				  $oldParentID   !== $movetoID))					// parent folder changed
			{
				$subFolderNames = array();
				foreach($this->all_folders as $record) {
					if ((int)$record[1] === $movetoID)	$subFolderNames[] = $record[2];
				}

				$i = 0;
				$changeToFolderName = $input['fname'] .'_(%d)';
				while(in_array($input['fname'], $subFolderNames, true)) {
					$input['fname'] = sprintf($changeToFolderName, ++$i);
				}
			}
		}

		// GET INPUT VALUES
		$input['introtext'] = $this->getFormTextarea('introtext');
		if (isset($_POST['position']))  $input['position']  = (int)$_POST['position'];
		if (isset($_POST['ficonID']))   $input['ficonID']   = (int)$_POST['ficonID'];
		if (isset($_POST['sortby']))    $input['sortMode']  = (int)$_POST['sortby'] & 15;
		if (isset($_POST['direction'])) $input['sortMode'] |= (int)$_POST['direction'] ? 16:0;

		// SET COLS AND ROWS: USE LOCAL DATA
		if (isset($_POST['thumbGrid']) && (int)$_POST['thumbGrid'] === 1) {
			$input['localCols'] = isset($_POST['localCols']) ? (int)$_POST['localCols']:0;
			$input['localRows'] = isset($_POST['localRows']) ? (int)$_POST['localRows']:0;
		}

		// SET FOLDER ICON ID FOR RANDOM, FIRST OR LATEST ITEM
		$icon_mode = (int)$_POST['icon_mode'] & 7;							// set random, first or latest item?
		if ($input['ficonID'] < 0 && $icon_mode) {
			$input['ficonID'] = (empty($_POST['incsubs']))?					// without sub folders?
									  -$icon_mode
									  :
									  -($icon_mode | 8);
		}

		// SET TIMESTAMP
		$newTimestamp		= $this->date2time($_POST['publish']);
		$input['publish'] = ($folderID < 1)? time():(int)$this->all_folders[$folderID][4];
		do {
			if ($newTimestamp === false)								break;	// new publish date isn't valid
			if (abs($newTimestamp - $input['publish']) < 60)	break;	// set no seconds of new date

			$input['publish'] = $newTimestamp;
		}
		while(0);

		// SET CURRENT PASSWORD
		$input['password'] = ($folderID !== -1 && isset($this->all_folders[$folderID]))?
									$this->all_folders[$folderID][8]
									:
									'';

		// GET NEW PASSWORD INPUT, CHANGED 0.4.2
		$newPassword = isset($_POST['password']) ? trim($_POST['password']):'';
		$confirmPwd  = isset($_POST['confirm'])  ?
							trim($_POST['confirm'])
							:
							$newPassword;

		// DELETE CURRENT PASSWORD
		if (!empty($_POST['delPwd']) ) {
			$input['password'] = '';
		}
		// SET NEW PASSWORD
		elseif ($newPassword && strlen($newPassword) <= MAXLEN_PWD) {

			$newPassword === $confirmPwd ?
				$input['password'] = md5(strrev(md5($newPassword)))
				:
				$input['pwdError'] = true;
		}

		return $input;
	}

	//
	// GET AND CLEAN THE CONTENT OF A TEXAREA
	// kh_mod 0.4.1, add
	function getFormTextarea($areaName, $maxLength=7167) {

		$introtext = isset($_POST[$areaName]) ? $_POST[$areaName]:'';
		$introtext = $this->charfix($introtext);
		if ($introtext) {
			$regexp	  = '/\r\n|\r|\n/';											// line break stand for data record end
			$replace	  = $_POST['mimetype']==='html' ? '':'<br />';		// WYSIWYG HTML-Editor used?
			$introtext = preg_replace($regexp, $replace, $introtext);	// replace line breaks
			$introtext = $this->ampers2Entities($introtext);				// convert single ampersands
		}

		return (string)substr($introtext, 0, $maxLength);
	}

	//
	// GENERATE FOLDER POSITION NUMBERS ACTION
	// kh_mod 0.4.1, changed
	function setFolderPositions($folderIDs) {

		$this->sortIndexDB($folderIDs, 'all_folders', $this->folderSortMode);
		$setReords = $this->setPosNumbersTemp($folderIDs, 'all_folders', false);

		// WRITE FOLDER DATABASE AND UPDATE
		if ($setReords) $this->write_fDB('upd', $setReords);
	}

	//
	// GENERATE ITEM POSITION NUMBERS ACTION
	// kh_mod 0.4.1, changed
	function setItemPositions($itemIDs) {

		$this->sortIndexDB($itemIDs, 'all_items', $this->imageSortMode);
		$setReords = $this->setPosNumbersTemp($itemIDs, 'all_items', false);

		// WRITE ITEM DATABASE AND UPDATE
		if ($setReords) $this->write_iDB('upd', $setReords);
	}

	//
	// SET NEW POSITION NUMBERS TEMPORARLY
	// kh_mod 0.4.1, add
	function setPosNumbersTemp($toSetIDs, $setInData, $setNegative=true, $step=10) {

		// POSITIVE POSITIONS
		$newPos   = 0;
		$negative = array();
		$validIDs = array();
		foreach ($toSetIDs as $id) {
			if (!isset($this->{$setInData}[$id])) continue;

			if ($this->{$setInData}[$id][5] < 0) {
				$negative[] = $id;
			}
			else {
				$this->{$setInData}[$id][5] = $newPos += $step;
				$validIDs[] = $id;
			}
		}

		// NEGATIVE POSITIONS
		if ($setNegative && $negative) {
			$newPos = 0;
			foreach (array_reverse($negative) as $id) {
				$this->{$setInData}[$id][5] = $newPos -= $step;
				$validIDs[] = $id;
			}
		}

		return $validIDs;
	}

	//
	// SAVE DRAG 'N' DROP SORTING ACTION
	// kh_mod 0.3.0, add, 0.4.1, changed
	function setNewSorting($folderID) {

		// INIT SORT RESULT
		$sortOK = 'nosort';

		do {
			// NO VALID FOLDER ID?
			if (!isset($this->all_folders[$folderID])) { $sortOK = 'error';  break; }

			// GET SORT MODE SETTINGS
			$newSortColumn = $currSortColumn = (int)$this->all_folders[$folderID][7] & 15;
			$newSortDirect = $currSortDirect = (int)$this->all_folders[$folderID][7] & 16;
			if (isset($_POST['itemsSortBy'])) {
				$newSortColumn = (int)$_POST['itemsSortBy'];
			}
			if (isset($_POST['directItems'])) {
				$newSortDirect = (int)$_POST['directItems'] ? 16:0;
			}

			// NO VALID (PRE)SORTMODE
			if (!in_array($newSortColumn, array(0,2,3,4,5,6,8,9,12,13,20,21), true)) break;

			// INIT SORT SETTINGS
			$setToColumn   = 5;
			$getItemIDs    = true;
			$folderSortPos = array(2,8,9,12,13);			// pos 5 equivalent
			$validSortIdx  = array(0,2,3,4,6,8,9,12,13);	// item sort options

			// CHANGED BY DRAG 'N' DROP OR USED PRESORT ITEMS
			if ($_SESSION[GALLERY_ID]['sortItems']['changed']) {
				$checkNewIdx = $validSortIdx;
			}
			elseif ($_SESSION[GALLERY_ID]['sortFolders']['changed']) {
				$checkNewIdx = $folderSortPos;
			}
			elseif ($currSortColumn !== $newSortColumn) {
				$numFolders		= count($_SESSION[GALLERY_ID]['sortFolders']['IDs']);
				$checkNewIdx   = $numFolders > 1 ?
									  $folderSortPos
									  :
									  $validSortIdx;
				$checkNewIdx[] = 5; // no positioning for items
			}
			// NO (VALID) CHANGES
			else break;

			if (in_array($newSortColumn, $checkNewIdx, true))
			{
				$setToColumn = $newSortColumn;
				$getItemIDs  = false;
			}

			// VERIFY AND SET POSITION NUMBERS TEMPORARILY
			$sortFolderIDs = $this->setNewSortingTemp('sortFolders', 'all_folders', $newSortDirect);
			$sortItemIDs   = $getItemIDs ?
								  $this->setNewSortingTemp('sortItems', 'all_items', $newSortDirect)
								  :
								  false;

			// SET NEW SORTING MODE
			if ($currSortColumn !== $setToColumn ||
				 $currSortDirect !== $newSortDirect)
			{
				$this->all_folders[$folderID][7]  = $setToColumn;
				$this->all_folders[$folderID][7] |= $newSortDirect;
				$sortFolderIDs[] = $folderID;
			}

			// SAVE NEW FOLDER POSITIONS
			if ($sortFolderIDs) {
				$sortOK = $this->write_fDB('upd', $sortFolderIDs) > 0;
			}

			// SAVE NEW ITEM POSITIONS
			if ($sortItemIDs) {
				$sortOK = $this->write_iDB('upd', $sortItemIDs) > 0;
			}
		}
		while(0);

		// RESET SORTING START (FOR SAFTY)
		$_SESSION[GALLERY_ID]['sortstart'] = false;

		// DISPLAY RESULT MESSAGE
		if ($sortOK === 'nosort') {
			$this->displayStatus($this->lang['nonewsorting'], 1);
		}
		elseif ($sortOK === true) {
			$this->displayStatus($this->lang['newsortingsaved'], 0);
		}
		else {
			$this->displayStatus($this->lang['sortingnotsaved'], 3);
		}
	}

	//
	// SET ITEM AND FOLDER POSITIONS TEMPORARILY
	// kh_mod 0.4.0 b4, add; 0.4.1, changed
	function setNewSortingTemp($sortName, $setInData, $sortDirect) {
		if (!is_array($_SESSION[GALLERY_ID][$sortName]['IDs'])) return false;

		// SORT DESCENDING?
		$sortedIDs = $sortDirect ?
						 array_reverse($_SESSION[GALLERY_ID][$sortName]['IDs'])
						 :
						 $_SESSION[GALLERY_ID][$sortName]['IDs'];

		// RETURN TEMPORARLY SET POSITION NUMBERS 
		return $this->setPosNumbersTemp($sortedIDs, $setInData);
	}

	//
	// SORT ITEMS BY LAST MODIFICATION DATE
	// kh_mod 0.4.1, add
	function sortByFileDate(&$itemIDs, $direction=0) {

		$tempSort = array();
		foreach($itemIDs as $itemID) {
			if (!isset($this->all_items[$itemID])) continue;

			$filePath = ROOT_FOLDER .'/'. $this->getFilePathByID($itemID);
			$tempSort[$itemID] = is_file($filePath) ?
										filemtime($filePath)
										:
										0;
		}

		$sortFunc = $direction? 'arsort':'asort';
		$sortFunc($tempSort, SORT_NUMERIC);
		$itemIDs  = array_keys($tempSort);
	}

	//
	// CHECK ITEM TO COMPUTE EXIF-DATE
	// kh_mod 0.4.1, add
	function setExifDate($itemIDs) {

		$toSetItems  = array();
		$setFileDate = false;
		foreach ($itemIDs as $itemID) {
			if ((int)$this->all_items[$itemID][13] > 631148399)	continue;	// already set
			if ((int)$this->all_items[$itemID][13] === -1)			continue;	// no exif date, add kh_mod 0.4.5
			if (!$filePath = $this->getFilePathByID($itemID)) 		continue;	// wrong path
			if (!is_file($filePath))										continue;	// file doesn't exit
			if (!$this->getContentType($itemID, 'jpeg')) {							// type no jpeg
				$this->all_items[$itemID][13] = filemtime($filePath);
				$setFileDate = true;
				continue;
			}

			$toSetItems[$itemID] = $filePath;
		}

		// WRITE EXIF-/FILE-DATE
		$toWrite = ($toSetItems && $this->computeExifDate($toSetItems))?
					  true
					  :
					  $setFileDate;
		$writeOK = ($toWrite)?
					  $this->write_iDB('upd', array_keys($toSetItems))
					  :
					  -1;

		// RETURNS NUMBER OF WRITTEN ITEMS
		return $writeOK !== -1 ? $writeOK:false;
	}

	//
	// COMPUTE EXIF-DATE AND SET IT TEMPORARILY (FOR JPEG's ONLY)
	// kh_mod 0.4.1, add
	function computeExifDate($toSetItems) {

		include_once(INC_FOLDER .'mg2_exif.php');
		if (!$Exif = &$this->getInstance('MG2Exif')) return false;

		$regexp = '/(\d{4})\D*(\d{2})\D*(\d{2})\D+(\d{1,2})?\D+(\d{2})?\D+(\d{2})?/';
		foreach ($toSetItems as $itemID=>$filePath) {
			$exifData = $Exif->getExifData($filePath);
			$d        = array();

			if (isset($exifData['DTOpticalCapture'])	&&
				 preg_match($regexp, $exifData['DTOpticalCapture'], $d))
			{
				// date when it was taken
			}
			elseif (isset($exifData['DateTime'])	&&
					  preg_match($regexp, $exifData['DateTime'], $d))
			{
				// changed by software
			}
			elseif ((int)$this->all_items[$itemID][13] > 631148399)
			{
				continue;	// keep the old value
			}

			$this->all_items[$itemID][13] = $d ?
				mktime((int)$d[4],
						 (int)$d[5],
						 (int)$d[6],
						 (int)$d[2],
						 (int)$d[3],
						 (int)$d[1]
				)
				:
				-1;
		}

		return true;
	}

	//
	// ASK DELETE FOLDER DIALOG
	// kh_mod 0.4.3, changed
	function askDelFolder($delfolder, $folderID, $currentPage) {
		if ($this->checkFolderID($delfolder) === false) return false;

		// FOLDER NOT EMPTY?
		if (!$this->toDeleteFolders($delfolder))        return false;

		// GET FOLDER ICON ITEMS (ARRAY)
		$icon 	= $this->getFolderIcon($delfolder);
		$cancel	= ADMIN_INDEX .'?fID='. $folderID .'&amp;page='. $currentPage;
		include(ADMIN_FOLDER .'admin_deletefolder.php');
	}

	//
	// DELETE FOLDER ACTION
	// kh_mod 0.4.3, changed
	function delFolder($folderID) {
		if ($this->checkFolderID($folderID) === false)          return 1;

		// FOLDER NOT EMPTY?
		if (!$delFolderIDs = $this->toDeleteFolders($folderID)) return false;

		// GET PARENT ID AND DELETE FOLDER TEMPORARILY
		$parentID   = (int)$this->all_folders[$folderID][1];
		$foldername = $this->all_folders[$folderID][2];
		$parentname = $this->getFolderName($parentID);
		foreach($delFolderIDs as $delID) {
			if (!$delOK = $this->delArrayItem('all_folders', $delID)) break;
		}

		// WRITE FOLDER DATA AND UPDATE
		if ($delOK && ($this->write_fDB('del', $delFolderIDs) > 0)) {
			$this->log('Folder \''.$foldername.'\' deleted from \''. $parentname .'\'');
			$this->displayStatus($this->lang['folderdeleted'] .' \''. $foldername .'\'');
		} else {
			$this->log('Couldn\'t delete folder \''.$foldername.'\' from \''. $parentname .'\'');
			$this->displayStatus($this->lang['foldernotdeleted'], 3);
		}
		return ($delOK)? $parentID:$folderID;
	}

	//
	// DETERMINE TO DELETE FOLDERS INCL. SUB FOLDERS
	// kh_mod 0.4.1, changed
	function toDeleteFolders($folderID) {

		// GET FOLDER STRUCTURE AND ALLOCATE ITEMS TO FOLDER
		$folderStructure = $this->getValidSubfolders($folderID, 'unstruct');
		$itemAllocation  = $this->getItemAllocation(array($folderStructure));

		// ARE THERE ANY ITEMS LEFT
		if ($itemAllocation[0]) {
			$this->displayStatus(
						 sprintf($this->lang['foldernotempty'], $this->getFolderName($folderID, true)),
						 2
					 );
			return false;
		}
		else {
			return array_keys($folderStructure);	// to delete folders
		}
	}

	//
	// DEFAULT OPTIONS TO SCALE THUMBNAIL AND MEDIUM IMAGES
	// kh_mod 0.4.0 b4, add
	function getResizeOptions($event) {

		$marker = 'checked="checked"';
		if (isset($_SESSION[GALLERY_ID][$event .'_modify'])) {
			$checked['thumb']	 = ($_SESSION[GALLERY_ID][$event .'_modify'] & 1)? $marker:'';
			$checked['medium'] = ($_SESSION[GALLERY_ID][$event .'_modify'] & 2)? $marker:'';
			$checked['delete'] = ($_SESSION[GALLERY_ID][$event .'_modify'] & 4)? $marker:'';
			$checked['rotate'] = ($_SESSION[GALLERY_ID][$event .'_modify'] & 8)? $marker:'';
		} else {
			$checked['thumb']  = $marker;
			$checked['medium'] = $marker;
			$checked['delete'] = '';
			$checked['rotate'] = '';
		}
		return $checked;
	}

	//
	// ROTATE ORIGINAL IMAGE ONLY
	// kh_mod 0.4.2, changed
	function rotateImage($imageID) {

		// GET IMAGE PATHS
		$fileName      = trim($this->all_items[$imageID][6]);
		$imageSubdir   = trim($this->all_items[$imageID][7]);
		$imageFilePath = $this->getFilePathByName($fileName, $imageSubdir);

		// IMAGE DIRECTORY PERMISSION
		if ((fileperms(dirname($imageFilePath)) & 0750) !== 0750) {
			$this->log('Couldn\'t rotate image '. $fileName .' by '. $degrees);
			$this->displayStatus($this->lang['imagenotrotated'], 3);
			return;
		}

		// GET ROTATION SETTING
		$rotateOK = false;
		if ($_GET['direction'] === 'right') {
			$rotateFlag = 1 | 4;
			$degrees    = '-90';
		}
		else {
			$rotateFlag = 3 | 4;
			$degrees    = '90';
		}

		// SET MAX. ORIGINAL THUMB SIZE
		$this->thumbMaxWidth  =
		$this->thumbMaxHeight = max(
										  (int)$this->all_items[$imageID][11],
										  (int)$this->all_items[$imageID][10]
										);

		// ROTATE IMAGE
		$origThumbquality   = $this->thumbquality;
		$this->thumbquality = 100;
		require_once(INC_FOLDER .'mg2admin_itemprocess.php');
		$ItemProcess = &$this->getInstance('MG2ItemProcess');
		$ItemProcess->delItemProcessList();
		$ItemProcess->addItemProcessTask($imageID, $rotateFlag << 4);

		// ROTATE OK, UPDATE THUMB AND MEDIUM IMAGE
		if ($ItemProcess->doItemProcessList(false)) {
			$this->log(sprintf('Image #%d rotated by %d deg.', $imageID, $degrees));
			$this->displayStatus(sprintf('%s %d&#176;', $this->lang['imagerotated'], $degrees));

			// ORIGINAL THUMB QUALITY
			$this->thumbquality = $origThumbquality;

			// UPDATE AND WRITE IMAGE DATA, kh_mod 0.4.1, changed
			$modify = $this->deleteThumbMedium($fileName, $imageSubdir);
			$ItemProcess->addItemProcessTask($imageID, $modify);
			$ItemProcess->doItemProcessList();
		}
	}

	//
	// CALCULATE MEMORY DEMAND FOR IMAGE PROCESSING
	// kh_mod 0.4.1, add; 0.4.2 changed
	function calculateMemDemand($imageInfo, $toWidth, $toHeight, $errorMsg='') {

		// INT RETURN VALUE
		$memoryOK = true;

		// MEMORY CONSUMPTION OF UNPACKED IMAGE
		$unpackedImgMemory = $imageInfo[0] * $imageInfo[1];	// original image
		$unpackedImgMemory+= (int)$toWidth * (int)$toHeight;	// to create image
		$unpackedImgMemory*= $imageInfo['bits'] * 0.375;		// color part (3/8)
		$unpackedImgMemory*= 1.699;									// processing consumption
		$unpackedImgMemory = (int)$unpackedImgMemory;

		// CHECK AVAILABLE MEMORY
		if ($this->currentMemory['available'] > 0) {
			if ($this->currentMemory['available'] < $unpackedImgMemory) {
				// NOT ENOUGH MEMORY
				$memoryOK = $this->currentMemory['available'] - $unpackedImgMemory;
				if ($errorMsg) {
					$this->log(sprintf($errorMsg,	$this->convertBytes($unpackedImgMemory, 0)));
				}
			}
		}

		return $memoryOK;
	}

	//
	// GET, CLEAN AND SAVE SETTING VALUES
	// kh_mod 0.4.0 rc1, changed
	function prepareSetup() {

		// INITIALIZE MESSAGE BUFFER
		$message = '';

		// CLEAN AND PREPARE VALUES
		$this->websitelink			= $this->cleanLink(substr($this->charfix($_POST['websitelink']), 0, 4096));
		$this->websitetext			= substr($this->charfix($_POST['websitetext']), 0, 1024);
		$this->websitetext			= $this->cleanHTMLContent($this->websitetext, array('b','i','img','span','div'));
		$this->indexfile				= substr($this->charfix($_POST['indexfile'], '/'), 0, 1024);
		$this->imagefolder			= substr(rtrim($this->charfix($_POST['imagefolder']), '/'), 0, 4096);
		$this->commentsets			= ($_POST['showcomments'])?	  1:0;
		$this->commentsets		  |= ($_POST['commentmode'])?	  1<<1:0;
		$this->commentsets		  |= ($_POST['showmail'])?		  1<<2:0;
		$this->commentsets		  |= ($_POST['allowcomments'])? 1<<3:0;
		$this->commentsets		  |= ($_POST['hidecommform'])?  1<<4:0;
		$this->commentsets		  |= ($_POST['lockcomments'])?  1<<5:0;
		$this->commentsets		  |= ($_POST['sendmail'])?		  1<<6:0;
		$this->commentsets		  |= ($_POST['jsvalidate'])?	  1<<7:0;
		$this->commentsets		  |= ($_POST['cpvalidate'])?	  1<<8:0;
		$this->commentsets		  |= ($_POST['whitelist'])?	  1<<9:0;
		$this->commentsets		  |= ($_POST['blacklist'])?	  1<<10:0;
		$this->commentsets		  |= ($_POST['logip'])?			  1<<11:0;
		$this->metasetting			= ($_POST['_gallery'])?			1:0;
		$this->metasetting		  |= ($_POST['_foldername'])?	1<<1:0;
		$this->metasetting		  |= ($_POST['_imagename'])?	1<<2:0;
		$this->metasetting		  |= ($_POST['_imagetitle'])?	1<<3:0;
		$this->metasetting		  |= ($_POST['meta_index'])?	((int)$_POST['_index'] &3)<<4:0;
		$this->metasetting		  |= ($_POST['meta_follow'])?	((int)$_POST['_follow']&3)<<6:0;
		$this->metasetting		  |= ($_POST['meta_archive'])? 1<<8:0;
		$this->metasetting		  |= ($_POST['meta_snippet'])? 1<<9:0;
		$this->metasetting		  |= ($_POST['http_index'])?	 1<<10:0;
		$this->metasetting		  |= ($_POST['http_follow'])?  1<<11:0;
		$this->metasetting		  |= ($_POST['http_archive'])? 1<<12:0;
		$this->metasetting		  |= ($_POST['http_snippet'])? 1<<13:0;
		$this->showexif				= ($_POST['_make'])?				1:0;
		$this->showexif			  |= ($_POST['_model'])?		1<<1:0;
		$this->showexif			  |= ($_POST['_expotime'])?	1<<2:0;
		$this->showexif			  |= ($_POST['_expocomp'])?	1<<3:0;
		$this->showexif			  |= ($_POST['_aperture'])?	1<<4:0;
		$this->showexif			  |= ($_POST['_focallen'])?	1<<5:0;
		$this->showexif			  |= ($_POST['_iso'])?			1<<6:0;
		$this->showexif			  |= ($_POST['_flash'])?		1<<7:0;
		$this->showexif			  |= ($_POST['_original'])?	1<<8:0;
		$this->showexif			  |= ($_POST['_software'])?	1<<9:0;
		$this->showexif			  |= ($_POST['_datetime'])?	1<<10:0;
		$this->showexif			  |= ($_POST['_colorspace'])?	1<<11:0;
		$this->showexif			  |= ($_POST['_artist'])?		1<<12:0;
		$this->showexif			  |= ($_POST['_gps'])?			1<<13:0;
		$this->layoutsetting			= ($_POST['folderNavBar'])?	1:0;
		$this->layoutsetting		  |= ($_POST['itemNavBar'])?	1<<1:0;
		$this->layoutsetting		  |= ($_POST['transgif'])?		1<<2:0;
		$this->layoutsetting		  |= ($_POST['fileashead'])?	1<<3:0;
		$this->layoutsetting		  |= ($_POST['altattrib'])?	1<<4:0;
		$this->layoutsetting		  |= ($_POST['descript'])?		1<<5:0;
		$this->layoutsetting		  |= ($_POST['keywords'])?		1<<6:0;
		$this->layoutsetting		  |= ((int)$_POST['fileformat'] & 7)	 <<7;
		$this->layoutsetting		  |= ($_POST['withextion'])?	1<<10:0;
		$this->layoutsetting		  |= ((int)$_POST['justify_thumbs'] & 3)<<11;
		$this->layoutsetting		  |= ($_POST['fullsizeon'])? ((int)$_POST['fullsize']&3)<<13:0;
		$this->layoutsetting		  |= ($_POST['sortKeywords'])? 1<<15:0;
		$this->marknew					= (int)$_POST['marknew'];
		$this->thumbquality			= min(abs((int)$_POST['thumbquality']), 100);
		$this->canvasWidth			= (int)$_POST['canvasWidth'];
		$this->canvasWidth		  .= ($_POST['canvasUnit'] === '%')? '%':'px';
		$this->contentWidth			= (int)$_POST['contentWidth'];
		$this->contentWidth		  .= ($_POST['contentUnit'] === '%')? '%':'px';
		$this->introWidth				= (int)$_POST['introWidth'];
		$this->introWidth		  	  .= ($_POST['introUnit'] === '%')? '%':'px';
		$this->mediumimage			= (empty($_POST['mediumon']))?   '-':'';
		$this->mediumimage		  .= (int)$_POST['mediumwidth'];
		$this->slideshowdelay		= (int)$_POST['slideshowdelay'];
		$this->navtype					= (int)$_POST['navtype'] & 15;
		$this->navtype				  |= (empty($_POST['navtypeon']))? 0:16;
		$this->navtype				  |= ($_POST['clickonimage'])?	((int)$_POST['clickonimage']&7)<<5:0;
		$old_foldersetting			= $this->foldersetting;
		$this->foldersetting			= (int)$_POST['foldersort'] & 15;
		$this->foldersetting		  |= ($_POST['foldericons'])?		  1<< 4:0;		//    16
		$this->foldersetting		  |= ($_POST['displayheadline'])?  1<< 5:0;		//    32
		$this->foldersetting		  |= ($_POST['displayfile'])?		  1<< 6:0;		//    64
		$this->foldersetting		  |= ($_POST['clickcounter'])?	  1<< 7:0;		//   128
		$this->foldersetting		  |= ($_POST['commentcounter'])?	  1<< 8:0;		//   256
		$this->foldersetting		  |= ($_POST['thumbtooltip'])?	  1<< 9:0;		//   512
		$this->foldersetting		  |= ($_POST['categories'])?		  1<<10:0;		//  1024
		$this->foldersetting		  |= ($_POST['categories_icon'])?  1<<11:0;		//  2048
		$this->foldersetting		  |= ($_POST['categories_shad'])?  1<<12:0;		//  4096
		$this->foldersetting		  |= ($_POST['categories_desc'])?  ((int)$_POST['categories_align']&3)<<13:0;	//  8192
		$this->foldersetting		  |= ($_POST['categories_subs'])?  1<<15:0;		// 32768
		$this->foldersetting		  |= ($_POST['thumbForceValues'])? 1<<16:0;		// 65536

		// GALLERY COPYRIGHT
		$this->copyright = substr($this->charfix($_POST['copyright']), 0, 2048);
		$this->copyright = $this->cleanHTMLContent($this->copyright, array('b','i','a','br','img','span','div'));

		// COMMENT COUNTER SWITCH OFF?
		if (($old_foldersetting & 256) && !($this->foldersetting & 256)) {
			include_once(INC_FOLDER .'mg2admin_counter.php');
			$Counter = &$this->getInstance('MG2AdminCounter');
			$resetOK = $Counter->resetComments('upd');
			// RESET FAILED?
			if (!$resetOK || $resetOK === -1) $this->foldersetting |= 256;
		}

		// WEBMASTER EMAIL, kh_mod 0.4.4, changed
		$newAdminMail = trim($_POST['adminemail']);
		$cClassLocal  = '[_a-z0-9%{|\/*}-]';
		$cClassSecond = '[a-z0-9'. preg_quote($this->lang['specialchars']) .']';
		$cClassTop    = '[a-z]';
		$regexp       = sprintf('/(^%1$s+([+.]%1$s+)*)@(%2$s+([.-]%2$s+)*\.%3$s{2,8})$/i',
								$cClassLocal,
								$cClassSecond,
								$cClassTop
							 );
		if (($newAdminMail === '')                     ||
			 preg_match($regexp, $newAdminMail, $match) &&
			 strlen($match[1]) < 65                     &&
			 strlen($match[3]) < 256                    &&
			 checkdnsrr($match[3], 'MX'))
		{
			$this->adminemail = $newAdminMail;
		}
		else
		{
			$message.= '<div style="margin-top:8px;color:red">'.$this->lang['emailerror'].'</div>';
		}

		// SET ACTIVE SKIN, kh_mod 0.4.4, changed
		$activeskin  = $this->charfix($_POST['activeskin'], '/');
		$newSkinPath = sprintf('%s/skins/%s/templates', ROOT_FOLDER, $activeskin);
		$regexp      = '/^[a-z0-9_-]{1,22}$/i';
		if (preg_match($regexp, $activeskin)
			 && is_readable($newSkinPath))
		{
			$this->activeskin = $activeskin;
		}

		// PASSWORD
		$oldpassword = !isset($_POST['oldpassword']) ? '':substr(trim($_POST['oldpassword']),0,MAXLEN_PWD);
		$newpassword = !isset($_POST['newpassword']) ? '':substr(trim($_POST['newpassword']),0,MAXLEN_PWD);
		$confirmpwd  = !isset($_POST['confirmpwd'])  ? '':trim($_POST['confirmpwd']);

		if ($newpassword) {
			if ($newpassword === $confirmpwd	&&
				 sha1(strrev(sha1($oldpassword . $this->adminsalt))) === $this->adminpwd)
			{
				$this->adminsalt = $this->buildVerificationToken(40);
				$this->adminpwd  = sha1(strrev(sha1($newpassword . $this->adminsalt)));
				$_SESSION[GALLERY_ID]['adminpwd'] = $this->adminpwd;
				$message.= '<div style="margin-top:8px">'. $this->lang['pwdchanged'].'</div>';
			}
			else
			{
				$message.= sprintf('<div style="margin-top:8px;color:#C69023">%s %s</div>',
									$this->lang['warning'],
									$this->lang['nopwdmatch']
							  );
			}
		}

		// ALLOW INACTIVE TIME IN MINUTES
		$newinactivetime = (int)$_POST['inactivetime'];
		$this->inactivetime = ($newinactivetime < 1)?
									 (int)$this->inactivetime
									 :
									 $newinactivetime;
		// SET INACTIVE TIME IN SECONDS
		$_SESSION[GALLERY_ID]['inactivetime'] = $this->inactivetime * 60;

		// THUMBNAIL SIZE
		if ((int)$_POST['thumbMaxWidth'] > 4 && (int)$_POST['thumbMaxHeight'] > 4) {
			$this->thumbMaxWidth  = (int)$_POST['thumbMaxWidth'];
			$this->thumbMaxHeight = (int)$_POST['thumbMaxHeight'];
		}
		else {
			$message.= sprintf('<div style="margin-top:8px;color:#C69023">%s %s</div>',
								$this->lang['warning'],
								$this->lang['nothumbsize']
						  );
		}

		// ITEM COLS AND ROWS
		$this->itemThumbCols = ((int)$_POST['itemcols'] < 1)?
									  max($this->itemThumbCols, 1)
									  :
									  (int)$_POST['itemcols'];
		$this->itemThumbRows = ((int)$_POST['itemrows'] < 1)?
									  max($this->itemThumbRows, 1)
									  :
									  (int)$_POST['itemrows'];

		// ALLOWED FILE EXTENTIONS
		$this->extensions = 0;
		if (isset($_POST['extensions']) && is_array($_POST['extensions'])) {
			$setExtensions 	= array_intersect(
											$this->getSupportedExtensions(),
											$_POST['extensions']
									  );
			$this->extensions = array_sum(array_keys($setExtensions));
		}

		// GET DATE AND TIME FORMAT
		$this->dateformat = $this->getDateFormat((int)$_POST['dateformat']);
		$this->timeformat = $this->getTimeFormat((int)$_POST['timeformat']);

		// EXTENDED SETTING
		$this->extendedset  = ((int)$_POST['pwdrecursiv'])?	0:1;			// kh_mod 0.2.0 b2, changed
		$this->extendedset |= ((int)$_POST['samefolders'])? 	1<<1:0;		// kh_mod 0.1.0, add
		$this->extendedset |= ((int)$_POST['htmlarea'])?		1<<2:0;		// kh_mod 0.1.0, add
		$this->extendedset |= ((int)$_POST['tooltips'])?		1<<3:0;		// kh_mod 0.1.0, add
		$this->extendedset |= ((int)$_POST['calendar'])?		1<<4:0;		// kh_mod 0.1.0, add
		$this->extendedset |= ((int)$_POST['seolink'])?			1<<5:0;		// kh_mod 0.3.0, add
		$this->extendedset |= ((int)$_POST['ctype'])?			1<<6:0;		// kh_mod 0.3.0, add
		$this->extendedset |= ((int)$_POST['adminmode'])?		1<<7:0;		// kh_mod 0.3.0, add
		$this->extendedset |= ((int)$_POST['pCounter'])?		1<<8:0;		// kh_mod 0.4.0 rc1, add
		$this->extendedset |= ((int)$_POST['includeGal'])?		1<<9:0;		// kh_mod 0.4.0 rc1, add
		$this->extendedset |= ((int)$_POST['canvasAlign']  & 3)<<10;		// kh_mod 0.4.0 b4, add
		$this->extendedset |= ((int)$_POST['contentAlign'] & 3)<<12;		// kh_mod 0.4.0 b4, add

		// GET MOD VERSION
		if (is_readable(INC_FOLDER .'mg2_version.php')) {
			include(INC_FOLDER .'mg2_version.php');
			if (preg_match('/^\d{1,2}\.\d{1,2}\.\d{1,2}.{0,5}$/', $modversion))
				$this->modversion = $modversion;
		}

		// WRITE MG2 SETTINGS
		$saveOk  = (!empty($this->sqldatabase))?
					  $this->SQLWrite->write2SQLTable('settings')
					  :
					  $this->write_sDBFlatfile('flat');
		$message = ($saveOk)?
					  $this->lang['settingssaved'] . $message
					  :
					  '<div style="color:red">'. $this->lang['nosettingssaved'] .'</div>';
		$this->displayStatus($message);
	}

	//
	// kh_mod 0.3.1, add
	// GET DATE FORMAT STRING
	function getDateFormat($idx=1) {

		$date = array(	1 => '%d.%m.%Y',
							2 => '%d. %b., %Y',
							3 => '%d. %b. %Y',
							4 => '%b. %d, %Y',
							5 => '%b. %e, %Y',
							6 => '%e.%m.%y',
							7 => '%m.%e.%y',
							8 => '%y%m%d',
							9 => '%Y%m%d',
						  10 => '%Y-%m-%d',
						  11 => '%d-%m-%Y',
						  12 => '%m-%d-%Y',
						  13 => '%d-%b-%Y',
						  14 => '%b-%d-%Y',
						  15 => '%d/%m/%Y',
						  16 => '%m/%d/%Y',
						  17 => '%e/%n/%y',
						  18 => '%n/%e/%y',
						  19 => '%d/%b/%Y',
						  20 => '%b/%d/%Y',
						  21 => '%d/%m %Y',
						  22 => '%m/%d %Y',
						  23 => '%d/%b %Y',
						  24 => '%b/%d %Y',
						  25 => '%n/%e %Y',
						  26 => '%e/%n %Y',
						  27 => '%e/%m %Y',
						  28 => '%n/%d %Y'
				  );

		return (isset($date[$idx]))?
				 $date[$idx]				// return the selected date string
				 :
				 $date[1];					// return the default date string
	}

	//
	// kh_mod 0.3.1, add, 0.4.2 changed
	// GET TIME FORMAT STRING
	function getTimeFormat($idx=1) {

		$time = array(	0 => '',					// locked
							1 => '%H:%M',			// (00 to 23)
							2 => '%H:%M:%S',		// (00 to 23)
							3 => '%i:%M %p',		// AM/PM		 ( 1 to 12)
							4 => '%i:%M:%S %p',	// AM/PM 	 ( 1 to 12)
							5 => '%i:%M %r',		// a.m./p.m. ( 1 to 12)
							6 => '%i:%M:%S %r',	// a.m./p.m. ( 1 to 12)
							7 => '%I:%M %p',		// AM/PM		 (01 to 12)
							8 => '%I:%M:%S %p',	// AM/PM		 (01 to 12)
							9 => '%I:%M %r',		// a.m./p.m. (01 to 12)
						  10 => '%I:%M:%S %r',	// a.m./p.m. (01 to 12)
				  );

		return (isset($time[$idx]))?
				 $time[$idx]				// return the selected time string
				 :
				 $time[1];					// return the default time string
	}

	//
	// kh_mod 0.4.1, add
	// DEFINE ALL POSSIBLE FILE EXTENSIONS
	function getSupportedExtensions() {

		return array(
						1 => 'gif',
						2 => 'jpg',
						4 => 'jpeg',
						8 => 'png',
					  16 => 'webp',
					  32 => 'mp3',
					  64 => 'ogg',
					 128 => 'mp4',
					 256 => 'ogv',
					 512 => 'flv',
					1024 => 'swf',
					2048 => 'mov',
					4096 => 'svg'
				 );
	}

	//
	// kh_mod 0.4.1, add
	// CHECK IF EXTENSION ALLOWED
	function checkFileExtension($extension) {

		$extension = strtolower($extension);
		$extIndex  = array_search($extension, $this->getSupportedExtensions(), true);

		return $extIndex ?
				 (bool)($extIndex & $this->extensions)
				 :
				 false;
	}

	//
	// kh_mod 0.3.0, add; chanched 0.4.0 rc1
	// SWITCH DATABASE, ACTION
	function switchDatabase($database) {

		require_once(INC_FOLDER .'mg2admin_dbswitch.php');
		$DBSwitch = &$this->getInstance('DBSwitch');

		$finalMsgTag = '<div style="margin-top:1em;color:%s;">%s</div>';
		switch ($database) {
			case 'flatfile':	if ($this->sqldatabase) {			// if set sql database
										if ($DBSwitch->switch2Flatfile()) {
											$this->status.= sprintf($finalMsgTag,
																	'#1ACC03',
																	sprintf($this->lang['dbswitch_ok'], $this->lang['flatfile'])
																 );
											$this->sqldatabase = 0;		// use flat file
											$this->log('Switch from MySQL to Flat file OK');
										}
										else {
											$message = sprintf('%s '. $this->lang['dbswitch_error'],
																$this->lang['error'],
																$this->lang['flatfile']
															);
											$this->status.= sprintf($finalMsgTag, 'red', $message);
											$this->log('ERROR: Couldn\'t switch from MySQL to Flat file');
										}
									}
									else {
										$this->write_sDBFlatfile();
										$this->status = sprintf('<div style="color:teal;">'. $this->lang['db_xyz_active'] .'</div>', $this->lang['flatfile']);
									}
									break;
			case 'mysql'	:	if ($this->sqldatabase != 1) {	// isn't set mysql
										if ($DBSwitch->switch2MySQL() && $this->write_sDBFlatfile('sql', 1)) {
											$this->status.= sprintf($finalMsgTag,
																	'#1ACC03',
																	sprintf($this->lang['dbswitch_ok'], 'MySQL')
																 );
											$this->sqldatabase = 1;		// use mysql
											$this->log('Switch from Flat file to MySQL OK');
										}
										else {
											$this->status.= sprintf($finalMsgTag,
																	'red',
																	sprintf($this->lang['dbswitch_error'], 'MySQL')
																 );
											$this->log('ERROR: Couln\'t switch from Flat file to MySQL');
										}
									}
									else {
										$this->write_sDBFlatfile('sql');
										$this->status = sprintf('<div style="color:teal;">'. $this->lang['db_xyz_active'] .'</div>', 'MySQL');
									}
									break;
			default: $this->status = '<div style="color:teal;">'. $this->lang['nodbselected'] .'</div>';
		}
		$this->displayStatus();
	}

	//
	// MOVE ITEMS TO ANOTHER FOLDER
	// kh_mod 0.4.3, changed
	function moveItems() {
		$moveToID = (int)$_POST['moveToID'];

		if ($moveToID === -1) {
			$this->displayStatus($this->lang['nofolderselected'], 1);
			return false;
		}
		if (!$this->checkFolderID($moveToID)) {
			return false;
		}

		// GET TO MOVE ITEMS
		$itemIDs = $this->getSelectedItems();

		// SET NEW FOLDER
		foreach ($itemIDs as $itemID) {
			$this->all_items[$itemID][1] = $moveToID;
		}

		// DISPLAY STATUS MESSAGE
		$targetFolderName = $this->getFolderName($moveToID);
		$numSelectedItems = count($itemIDs);
		if ($numSelectedItems < 1) {
			$this->log('ERROR: No file selected to move!');
			$this->displayStatus($this->lang['filenotselected'], 1);
		}
		elseif ($this->write_iDB('upd', $itemIDs) > 0) {
			$this->log('Moved '.$numSelectedItems.' file(s) to \''. $targetFolderName .'\'');
			$this->displayStatus(sprintf('%d %s: <a href="%s?fID=%d">%s</a>',
											$numSelectedItems,
											$this->lang['filesmovedto'],
											ADMIN_INDEX,
											$moveToID,
											$this->htmlchars2entities($targetFolderName)
										));
		} else {
			$this->log('ERROR: Couldn\'t move '. $numSelectedItems .' files to \''. $targetFolderName. '\'!');
			$this->displayStatus($this->lang['iDB_error'], 3);
		}
	}

	//
	// DELETE DATABASE ENTRY
	// kh_mod 0.4.0 b4, changed
	function delArrayItem($data, $index) {
		unset($this->{$data}[$index]);
		return (isset($this->{$data}[$index]))?
				 false
				 :
				 true;
	}

	//
	// GET CURRENT MEMORY STATUS
	// kh_mod 0.3.1, add; 0.3.3 changed
	function getMemoryStatus() {

		do {
			// IF ALREADY EXISTS, kh_mod 04.0 b4, add
			if (isset($this->currentMemory)) return;

			// INIT START VALUES
			$this->currentMemory = array(
											 'limit'		 => -1,
											 'allocate'	 => -1,
											 'available' => -1
										  );

			// GET MEMORY LIMIT - RETURNS e.g. 32M or 32768K
			$global_memory = get_cfg_var('memory_limit');		// php.ini value
			$local_memory  = ini_get('memory_limit');				// current value

			// NO VALUE SET?
			if (!$global_memory && !$local_memory)		break;

			// CURRENT MEMORY LIMIT
			$memory_limit = ($local_memory)?
								 $local_memory
								 :
								 $global_memory;

			// CALCULATE BYTES
			$memory_unit  = substr($memory_limit, -1);
			if (strcasecmp($memory_unit,'M') === 0) {
				$limit = (int)$memory_limit * 1048576;
			}
			elseif (strcasecmp($memory_unit,'K') === 0) {
				$limit = (int)$memory_limit * 1024;
			}
			else {
				$limit = (int)$memory_limit;
			}

			// SAVE LIMIT MEMORY
			$this->currentMemory['limit'] = $limit;

			// EXISTS FUNCTION - MEMORY USAGE
			if (!function_exists('memory_get_usage'))	break;

			// ALLOCATE MEMORY
			$allocate = memory_get_usage(true);

			// SET MEMORY STATUS
			$this->currentMemory['allocate']  = $allocate;
			$this->currentMemory['available'] = $limit - $allocate;
		}
		while(0);
	}

	//
	// GET GALLERY LINK FOR ADMIN AREA
	// kh_mod 0.4.1, add
	function getAdminGalleryLink($folderID, $currentPage) {

		// IF FOLDER TYPE "LINK" GET URL
		if ((int)$this->all_folders[$folderID][11] === 1) {
			list($gLink, $target) = $this->getFolderURL($folderID);
		}
		// GET GALLERY LINK
		else {
			$urlParm = array('fID'=>$folderID, 'page'=>$currentPage, 'user'=>GALLERY_ID);
			$gLink   = $this->getGalleryLink($urlParm);
		}

		return $gLink;
	}

	//
	// ADMIN BREADCRUMB NAVIGATION
	// kh_mod 0.4.0 rc1, changed
	function adminNavigation($folderID=1){

		$folderNames = array();
		while ($folderID > 1) {
			if (!isset($this->all_folders[$folderID]))	break;				// id doesn't exist

			$folderNames[$folderID] = $this->getFolderName($folderID, true);
			$folderID = (int)$this->all_folders[$folderID][1];					// parent id
			if (!empty($folderNames[$folderID]))			break;				// circular reference!
		}
		$folderNames[1] = $this->lang['root'];

		$folderLinks = array();
		foreach ($folderNames as $folderID=>$folderName) {
			$folderLinks[] = sprintf(' <a href="%s?fID=%d">%s</a>',
										ADMIN_INDEX,
										$folderID,
										$this->br2line($folderName)
								  );
		}

		// BUILD NAVIGATION STRING
		$strBreadcrumb = implode(' : ', array_reverse($folderLinks));
		return sprintf('%s: %s', $this->lang['navigation'], $strBreadcrumb);
	}

	//
	// ADMIN PAGE NAVIGATION
	// kh_mod 0.4.1, changed
	function pageNavigation($folderID, $npages, $page=0, $delim=' | ') {
		$dislpay = '';
		if ($npages > 1) {
			$navarr[] = ' &nbsp;&ndash;&nbsp; '. $this->lang['page'];
			$navlink  = '<a href="%s?fID=%d&amp;page=%s">%s</a>';
			for ($i=1; $i <= $npages; $i++) {
				$navarr[] = ($page === $i)?
								$i
								:
								sprintf($navlink, ADMIN_INDEX, $folderID, $i, $i);
			}
			$navarr[] = ($page === 'all')?
							$this->lang['all']
							:
							sprintf($navlink, ADMIN_INDEX, $folderID, 'all', $this->lang['all']);
			$dislpay = implode($delim, $navarr);							
		}
		return $dislpay;
	}

	//
	// WRITE IMAGE DATABASE
	// kh_mod 0.3.0, add
	//
	// $action: 'all', 'del', 'new', 'upd', 'backup'
	//
	function write_iDB($action, $itemIDs=false) {

		// READ ERROR OF ITEM DATA
		if (!defined('ItemDataOK')) {
			return -1;
		}

		// NO ITEM ARRAY
		if (!is_array($this->all_items)) {
			$this->log('ERROR: \'$this->all_items\' is no array, didn\'t write item data!');
			return -1;
		}

		// NO ITEM TO ADD OR UPDATE?
		if (($action === 'new' || $action === 'upd') && count($this->all_items) < 1) {
			$this->log('ERROR: \'$this->all_items\' is empty, didn\'t write item data!');
			return -1;
		}

		// SAVE ITEM DATABASE
		return (isset($this->sqldatabase) && $this->sqldatabase === 1)?
				 $this->SQLWrite->write2SQLTable('items', $action, $itemIDs)
				 :
				 $this->write_iDBFlatfile($action, $itemIDs);
	}

	//
	// WRITE IMAGE DATABASE (FLATFILE)
	// kh_mod 0.4.1, changed
	function write_iDBFlatfile($action='all', $itemIDs=false) {

		// INIT START VALUES
		$fok		 = false;
		$iDB_temp = DATA_FOLDER .'mg2db_items_temp.php';

		// INIT WRITE BUFFER
		if (($action !== 'upd')					||
			 empty($this->itemBufferContent)	||
			 !is_array($itemIDs))
		{
			$this->itemBufferContent = '';
			$itemIDs = array_keys($this->all_items);
		}

		// CREATE WRITE BUFFER
		foreach ($itemIDs as $itemID) {
			$this->itemBufferContent .= sprintf(
													 "#%s\n",
													 implode("\t", $this->all_items[$itemID])
												 );
		}
		$writeBuffer = $this->itemAutoID ."\n". $this->itemBufferContent;

		// WRITE ITEM TEMP FILE, kh_mod 0.4.0 b4 changed
		do {
			if (!$fp = fopen($iDB_temp, 'wb'))		break;

			$locked = flock($fp, LOCK_EX);		// do an exclusive lock
			ftruncate($fp, 0);

			if (!$fok = fwrite($fp, $writeBuffer))	break;

			fflush($fp);
			if ($locked) flock($fp, LOCK_UN);	// release the lock
			fclose($fp);
			$this->log('Writing temp item data file');

			// CREATE ONLY A TEMP FILE FOR BACKUP
			if ($action === 'backup')					break;

			$this->updateDBFlatfile('items');
		}
		while(0);

		// DISPLAY STATUS MESSAGE
		if (empty($locked)) {
			$this->log('WARNING: Couldn\'t lock item data file for writing');
			$this->displayStatus('Couldn\'t lock temp file (function \'write_iDBFlatfile\')', 2);
		}

		return ($fok)? count($this->all_items):-1;
	}

	//
	// WRITE FOLDER DATABASE
	// kh_mod 0.3.0, add
	//
	// $action: 'all', 'del', 'new', 'upd', 'backup'
	//
	function write_fDB($action, $folderIDs=false) {

		// READ ERROR OF FOLDER DATA
		if (!defined('FolderDataOK')) {
			return -1;
		}

		// NO FOLDER ARRAY OR EMPTY
		if (!is_array($this->all_folders) || count($this->all_folders) < 1) {
			$this->log('ERROR: \'$this->all_folders\' is corrupted, don\'t write folder data!');
			return -1;
		}

		// SAVE FOLDER DATABASE
		return ($this->sqldatabase)?
				 $this->SQLWrite->write2SQLTable('folders', $action, $folderIDs)
				 :
				 $this->write_fDBFlatfile();
	}

	//
	// WRITE FOLDER DATABASE (FLATFILE)
	// kh_mod 0.3.0, changed
	function write_fDBFlatfile($action='all') {

		// INIT START VALUES
		$fok		 = false;
		$fDB_temp = DATA_FOLDER .'mg2db_folders_temp.php';

		// CREATE WRITE BUFFER
		$filebuffer = $this->folderAutoID ."\n";
		foreach ($this->all_folders as $record) {
			$filebuffer.= '#';
			$filebuffer.= implode("\t", $record);
			$filebuffer.= "\n";
		}

		// WRITE FOLDER TEMP FILE, kh_mod 0.4.0 b4 changed
		do {
			if (!$fp = fopen($fDB_temp, 'wb'))		break;

			$locked = flock($fp, LOCK_EX);		// do an exclusive lock
			ftruncate($fp, 0);

			if (!$fok = fwrite($fp, $filebuffer))	break;

			fflush($fp);
			if ($locked) flock($fp, LOCK_UN);	// release the lock
			fclose($fp);
			$this->log('Writing temp folder data file');

			// CREATE ONLY A TEMP FILE FOR BACKUP
			if ($action === 'backup')					break;

			$this->updateDBFlatfile('folders');
		}
		while(0);

		// DISPLAY STATUS MESSAGE
		if (empty($locked)) {
			$this->log('WARNING: Couldn\'t lock folder data file for writing');
			$this->displayStatus('Couldn\'t lock temp file (function \'write_fDBFlatfile\')', 2);
		}

		return ($fok)? count($this->all_folders):-1;
	}

	//
	// UPDATE DATA FROM TEMP FILES
	// kh_mod 0.2.0, 0.4.0 rc1, changed
	function updateDBFlatfile($db='all') {

		// ITEM DATA
		$iDB		 = DATA_FOLDER .'mg2db_items.php';
		$iDB_temp = DATA_FOLDER .'mg2db_items_temp.php';
		if (($db === 'all' || $db === 'items') && is_file($iDB_temp)) {
			if (!copy($iDB_temp, $iDB)) {
				$this->log('ERROR: Failed to copy temp item data file');
				$this->displayStatus('Failed to copy temp file (function \'updateDBFlatfile\')', 3);
				exit();
			}
			else {
				$this->log('Updated item data from temp file');
				unlink($iDB_temp);
			}
		}

		// FOLDER DATA
		$fDB		 = DATA_FOLDER .'mg2db_folders.php';
		$fDB_temp = DATA_FOLDER .'mg2db_folders_temp.php';
		if (($db === 'all' || $db === 'folders') && is_file($fDB_temp)) {
			if (!copy($fDB_temp, $fDB)) {
				$this->log('ERROR: Failed to copy temp folder data file');
				$this->displayStatus('Failed to copy temp file (function \'updateDBFlatfile\')', 3);
				exit();
			}
			else {
				$this->log('Updated folder data from temp file');
				unlink($fDB_temp);
			}
		}
	}

	// kh_mod 0.4.2, changed
	function write_sDBFlatfile($type='flat', $db=1) {
		// CREATE WRITE BUFFER
		if ($type === 'sql') {
			$filebuffer = "<?php\n";
			$filebuffer.= "define('DB_NAME','".		DB_NAME ."');\n";
			$filebuffer.= "define('DB_USERNAME','".DB_USERNAME ."');\n";
			$filebuffer.= "define('DB_PASSWORD','".DB_PASSWORD ."');\n";
			$filebuffer.= "define('DB_SERVER','".	DB_SERVER ."');\n";
			$filebuffer.= '$mg2->sqldatabase = '. (int)$db .";\n";
			$filebuffer.= '?>';
			$number = 5;
		}
		else {
			$filebuffer = "<?php\n";
			$filebuffer.= '$mg2->gallerytitle = "'.	addcslashes($this->gallerytitle, "\"\\") ."\";\n";
			$filebuffer.= '$mg2->adminemail = "'.		$this->adminemail		."\";\n";
			$filebuffer.= '$mg2->metasetting = '.		(int)$this->metasetting	.";\n";
			$filebuffer.= '$mg2->copyright = "'.		addcslashes($this->copyright, "\"\\") ."\";\n";
			$filebuffer.= '$mg2->defaultlang = "'.		$this->defaultlang	."\";\n";
			$filebuffer.= '$mg2->activeskin = "'.		$this->activeskin		."\";\n";
			$filebuffer.= '$mg2->dateformat = "'.		$this->dateformat		."\";\n";
			$filebuffer.= '$mg2->timeformat = "'.		$this->timeformat		."\";\n";
			$filebuffer.= '$mg2->navtype = '.			(int)$this->navtype			.";\n";	
			$filebuffer.= '$mg2->showexif = '.			(int)$this->showexif			.";\n";
			$filebuffer.= '$mg2->commentsets = '.		(int)$this->commentsets		.";\n";
			$filebuffer.= '$mg2->foldersetting = '.	(int)$this->foldersetting	.";\n";
			$filebuffer.= '$mg2->marknew = '.			(int)$this->marknew			.";\n";
			$filebuffer.= '$mg2->adminpwd = "'.			$this->adminpwd		."\";\n";
			$filebuffer.= '$mg2->adminsalt = "'.		$this->adminsalt		."\";\n";
			$filebuffer.= '$mg2->extensions = '.		(int)$this->extensions		.";\n";
			$filebuffer.= '$mg2->canvasWidth = "'.		$this->canvasWidth	."\";\n";
			$filebuffer.= '$mg2->contentWidth = "'.	$this->contentWidth	."\";\n";
			$filebuffer.= '$mg2->introWidth = "'.		$this->introWidth		."\";\n";
			$filebuffer.= '$mg2->mediumimage = "'.		$this->mediumimage	."\";\n";
			$filebuffer.= '$mg2->indexfile = "'.		$this->indexfile		."\";\n";
			$filebuffer.= '$mg2->imagefolder = "'.		$this->imagefolder	."\";\n";
			$filebuffer.= '$mg2->layoutsetting = '.	(int)$this->layoutsetting	.";\n";
			$filebuffer.= '$mg2->thumbquality = '.		(int)$this->thumbquality	.";\n";
			$filebuffer.= '$mg2->thumbMaxWidth = '.	(int)$this->thumbMaxWidth	.";\n";
			$filebuffer.= '$mg2->thumbMaxHeight = '.	(int)$this->thumbMaxHeight	.";\n";
			$filebuffer.= '$mg2->itemThumbCols = '.	(int)$this->itemThumbCols	.";\n";
			$filebuffer.= '$mg2->itemThumbRows = '.	(int)$this->itemThumbRows	.";\n";
			$filebuffer.= '$mg2->slideshowdelay = '.	(int)$this->slideshowdelay.";\n";
			$filebuffer.= '$mg2->websitelink = "'.		addcslashes($this->websitelink, "\"\\") ."\";\n";
			$filebuffer.= '$mg2->websitetext = "'.		addcslashes($this->websitetext, "\"\\") ."\";\n";
			$filebuffer.= '$mg2->inactivetime = '.		(int)$this->inactivetime	.";\n";
			$filebuffer.= '$mg2->extendedset = '.		(int)$this->extendedset		.";\n";
			$filebuffer.= '$mg2->statisticsets = '.	(int)$this->statisticsets	.";\n";
			$filebuffer.= '$mg2->modversion = "'.		$this->modversion		."\";\n";
			$filebuffer.= '$mg2->installdate = '.		(int)$this->installdate		.";\n";
			$filebuffer.= '?>';
			$number = 36;
		}

		// WRITE NEW SETTINGS, kh_mod 0.3.2 changed
		$sOK	 = false;
		$fname = 'mg2db_settings.php';
		$ftemp = 'mg2db_settings_temp.php';
		do {
			if (!$fp = fopen(DATA_FOLDER . $ftemp, 'wb'))	break;

			$sOK = fwrite($fp, $filebuffer);
			fflush($fp);
			fclose($fp);

			// WRITE ERROR OR CREATE ONLY A TEMP FILE FOR BACKUP
			if (!$sOK || $type === 'backup')						break;

			// 'unlink' NEEDED FOR rename() ON WINDOWS OS ONLY
			// 'IF' NEEDED FOR 'mg2_install.php' and 'mg2_update.php'
			if (is_file(DATA_FOLDER . $fname)) unlink(DATA_FOLDER . $fname);

			// RENAME TEMP SETTING FILE
			$sOK = rename(DATA_FOLDER . $ftemp, DATA_FOLDER . $fname);

			// LOG MESSAGES
			$this->log('Settings saved in \''.$fname.'\'');
		}
		while(0);

		return $sOK ? $number : false;
	}
}	// END CLASS' MG2admin'
?>
