<?php
/**
 * UPDATE CLASS, IMPLEMENTATION SHOULD BE AS SINGLETON
 * kh_mod 0.4.2, add
 */
class MG2AdminUpdate {

	var $mg2;	// parent object reference

	/**
	 * INITIALIZE UPDATE
	 */
	function MG2AdminUpdate(&$parent) {
		$this->mg2 = &$parent;
	}

	/**
	 * STEP 1, CONVERT SETTINGS
	 */
	function updateStep1($Settings, $updateVersion) {

		$updateStep = '1';

		echo '<p><strong>Step '. $updateStep .' / 2</strong></p>';

		// SET DEFAULT VALUES
		if (!isset($Settings->thumbwidth))		$Settings->thumbwidth    = 150;			// thumb max. width
		if (!isset($Settings->thumbheight))		$Settings->thumbheight   = 150;			// thumb max. height
		if (!isset($Settings->itemThumbCols))	$Settings->itemThumbCols = 4;				// items per row 
		if (!isset($Settings->itemThumbRows))	$Settings->itemThumbRows = 6;				// items per column
		if (!isset($Settings->imagefolder))		$Settings->imagefolder   = 'pictures';	// image directory
		if (!isset($Settings->navtype))			$Settings->navtype		 = 113;			// navigationstyp (Text, Icons, Thumbs)
		if (!isset($Settings->extensions))		$Settings->extensions	 = 1711;			// allowed extensions (gif, jpg, jpeg, png, mp3, mp4, flv, swf)
		if (!isset($Settings->accesstime))		$Settings->accesstime	 = 15;			// auto logout after 15 min.
		if (!isset($Settings->canvasWidth))		$Settings->canvasWidth	 = 'auto';		// width of the entire gallery
		if (!isset($Settings->contentWidth))	$Settings->contentWidth  = '90%';		// width of the gallery content
		if (!isset($Settings->introWidth))		$Settings->introWidth    = 'auto';		// width of the folder intro text
		if (!isset($Settings->layoutsetting))	$Settings->layoutsetting = 8304;			// layout settings, kh_mod 0.3.0 b2
		if (!isset($Settings->timeformat))		$Settings->timeformat	 = '%H:%M';		// time format, kh_mod 0.3.0 rc1
		if (!isset($Settings->statisticsets))	$Settings->statisticsets = 144;			// settings for stats, kh_mod 0.4.0 rc2
		if (isset($Settings->modversion))		$Settings->modversion    = strtr($Settings->modversion, ' ', '');

		// RENAMES IN, kh_mod 0.3.0 b6
		if (!isset($Settings->thumbMaxWidth))	$Settings->thumbMaxWidth  = max($Settings->thumbwidth, 1);
		if (!isset($Settings->thumbMaxHeight)) $Settings->thumbMaxHeight = max($Settings->thumbheight, 1);
		if (!isset($Settings->inactivetime))	$Settings->inactivetime   = max($Settings->accesstime, 1);

		// FOLDER SETTINGS, kh_mod 0.2.0 b2, add, 0.3.0 b2 changed
		if (!isset($Settings->foldersetting)) {
			if (!isset($Settings->folderseting)) {
				$Settings->foldersetting  = isset($Settings->foldersort) ?
													  $Settings->foldersort & 15		// use old settings for folder sorting 
													  :
													  0;										// sort folder content by folder setup
				$Settings->foldersetting |= $Settings->foldericons ? 16:0;	// default icon for all folders
				$Settings->foldersetting |= 544;										// display file title under thumbnails and thumbtooltip
				$Settings->foldersetting |= $Settings->displayfile ? 64:0;	// display file name under all thumbs
			}																					// 'displayfile' was added in kh_mod 0.1.0
			else {
				$Settings->foldersetting  = $Settings->folderseting;
				$Settings->foldersetting ^= 32;
				$Settings->foldersetting |= ($Settings->folderseting & 32)<<6;
			}
		}
		if (!$Settings->modversion) $Settings->foldersetting &= 1023;		// without categories, kh_mod 0.3.0 < b6

		// METASETTING, kh_mod, 0.3.0, add
		if (!isset($Settings->metasetting))
		$Settings->metasetting = (isset($Settings->metaseting))?
								  $Settings->metaseting
								  :
								  17;	// kh_mod > 0.3.0 b5 -> 81

		// COMMENT SETTINGS, kh_mod 0.3.0 b2, add
		if (!isset($Settings->commentsets))$Settings->commentsets = 79;	// kh_mod > 0.3.0 b5 -> default: 159
		elseif ($_SESSION['version'] < 3) {											// kh_mod < 0.3.0 b2
			if ($Settings->commentsets & 64) {	// logip
				$Settings->commentsets ^= 64;
				$Settings->commentsets |= 256;
			}
			if ($Settings->commentsets & 4) {	// jsvalidate
				$Settings->commentsets ^= 4;
				$Settings->commentsets |= 64;
			}
			if ($Settings->commentsets & 8) {	// sendmail
				$Settings->commentsets ^= 8;
				$Settings->commentsets |= 32;
			}
			$Settings->commentsets |=   4;		// show email in commets, yes
			$Settings->commentsets |=   8;		// allow new comments, yes
			$Settings->commentsets &= ~16;		// lock new comment entries, no
		}

		// CHANGES IN kh_mod 0.3.0 b6
		if (!isset($Settings->modversion)) { // kh_mod < 0.3.0 b6

			// META SETTINGS
			$new_metasetting = ($Settings->metasetting & 15);	// take the first four flags
			if ($Settings->metasetting &  16) $new_metasetting |=  64;
			if ($Settings->metasetting &  32) $new_metasetting |=  64;
			if ($Settings->metasetting &  64) $new_metasetting |= 144;
			if ($Settings->metasetting & 128) $new_metasetting |=  32;
			$Settings->metasetting = $new_metasetting;

			// COMMENT SETTINGS
			$new_commentsets  = ($Settings->commentsets & 15);					// take the first four flags
			$new_commentsets |= 16;														// hide comment form
			if ($Settings->commentsets &   16) $new_commentsets |=   32;	// lockcomments
			if ($Settings->commentsets &   32) $new_commentsets |=   64;	// sendmail
			if ($Settings->commentsets &   64) $new_commentsets |=  128;	// jsvalidate
			if ($Settings->commentsets &  128) $new_commentsets |=  256;	// cpvalidate
			if ($Settings->commentsets &  256) $new_commentsets |= 2048;	// logip
			$Settings->commentsets = $new_commentsets;
		}

		// PERMISSION TEST, kh_mod 0.4.0 b4, changed
		$error_message = '';

		// ITEM DIRECTORY
		if (is_dir($Settings->imagefolder .'/x')) rmdir($Settings->imagefolder .'/x');
		if (mkdir($Settings->imagefolder .'/x')) {
			rmdir($Settings->imagefolder .'/x');
		}
		else {
			$nofolder		= is_dir($Settings->imagefolder) ? '':'create <b>and</b>';
			$error_message.= '<div style="padding:.2em">
										<b>Warning</b>: Cannot write into directory \''. $Settings->imagefolder .'\' in the gallery root,
										'.$nofolder.' set the directory to CHMOD 777 via FTP &ndash;
										<a href="http://www.google.com/search?hl=en&q=chmod+tutorial" target="_blank">Help!</a>
									</div>';
		}

		// DATA DIRECTORY
		if (is_dir(DATA_FOLDER .'x')) rmdir(DATA_FOLDER .'x');
		if (mkdir(DATA_FOLDER .'x')) {
			rmdir(DATA_FOLDER .'x');
		}
		else {
			$nofolder		= is_dir(DATA_FOLDER) ? '':'create <b>and</b>';
			$error_message.= '<div style="padding:.2em">
										<b>Warning</b>: Cannot write into directory \'data\' in the gallery root, '.$nofolder.'
										set the directory to CHMOD 777 via FTP &ndash;
										<a href="http://www.google.com/search?hl=en&q=chmod+tutorial" target="_blank">Help!</a>
									</div>';
		}

		// BACKUP DIRECTORY
		if (is_dir(BACKUP_FOLDER .'x')) rmdir(BACKUP_FOLDER .'x');
		if (is_dir(BACKUP_FOLDER) && mkdir(BACKUP_FOLDER .'x')) {
			rmdir(BACKUP_FOLDER .'x');
		}
		else {
			$nofolder		= is_dir(BACKUP_FOLDER) ? '':'create <b>and</b>';
			$error_message.= '<div style="padding:.2em">
										<b>Warning</b>: Cannot write directory \'data/backup\', '.$nofolder.'	set the directory
										to CHMOD 777 via FTP &ndash;
										<a href="http://www.google.com/search?hl=en&q=chmod+tutorial" target="_blank">Help!</a>
									</div>';
		}

		// DISPLAY ERROR MESSAGE
		if ($error_message != '') {
			echo $error_message .'
				<div style="margin:2em 0 1em 0;">
					<form action="'. UPDATE_INDEX .'" method="post">
					<input type="hidden" name="step" value="1" />
					<input type="image" src="'. ADMIN_IMAGES .'rebuild.gif" class="adminpicbutton" alt="Try it again" title="Try it again" />
					</form>
				</div>
				';
			return false;
		}

		// DISPLAY EXIF INFOS, kh_mod 0.2.0 b2, add
		if ($Settings->showexif === '1') $Settings->showexif = 510;

		// EXTENDED SETTINGS, kh_mod 0.2.0 b2, add
		if (!isset($Settings->extendedset)) {
			$Settings->extendedset = 156;											// fckeditor(4), tooltips(8), calendar(16), admin mode(128)
		}
		elseif ($_SESSION['version'] < 2) {
			$Settings->extendedset = (int)$Settings->extendedset | 16;	// update calendar
			$Settings->extendedset^= 1;											// change bit 1 (password recursiv)
		}

		// ADMIN MODE OPTION, ONLY FOR kh_mod < 0.3.0 rc2
		if (!isset($Settings->modversion) || preg_match('/0\.3\.0\s*(rc1|b6)/i', $Settings->modversion))
			$Settings->extendedset	|= 128;

		// UPDATE FOR DATE FORMAT, BUILT IN kh_mod 0.1.0 final
		// kh_mod, 0.3.0 b5, changed
		if (empty($Settings->dateformat)) $Settings->dateformat = '%d.%m.%Y';
		if ($_SESSION['version'] < 2) {
			if (substr_count($Settings->dateformat, '%') < 2) {
				$search  = array('%','M','j','i','n','a','A','D','m','d','H','y','Y');					// 13 items
				$replace = array('%%','%b','%e','%M','%n','%p','%p','%a','%m','%d','%H','%y','%Y');	// 13 items
				$Settings->dateformat = str_replace($search, $replace, $Settings->dateformat);
			}
		}

		// CHANGES IN kh_mod 0.3.1
		if (!isset($Settings->modversion) || version_compare($Settings->modversion, '0.3.0', '<=')) {
			if ((int)$Settings->foldersetting & (1<<14)) {	// categories_subs
				$Settings->foldersetting |=  (1<<15);
				$Settings->foldersetting &= ~(1<<14);
			}
		}

		// CHANGES IN kh_mod 0.4.0 b2
		if (!isset($Settings->modversion) || version_compare($Settings->modversion, '0.4.0-b2', '<')) {
			if (is_string($Settings->extensions)) {
				$Settings->extensions .= 'mp3,mp4,flv';
			}
		}

		// CHANGES IN kh_mod 0.4.0 b4
		if (!isset($Settings->modversion) || version_compare($Settings->modversion, '0.4.0-b4', '<')) {
			// IF kh_mod >= 0.3.0 b2 AND IF SET 'fileformat'
			if (($_SESSION['version'] >= 3) && ($Settings->layoutsetting & 960)) {
				$fileformat = $Settings->layoutsetting;
				$Settings->layoutsetting &= ~960;
				if     ($fileformat &  64) $Settings->layoutsetting |= 128;		// original but first capital
				elseif ($fileformat & 128)	$Settings->layoutsetting |= 256;		// first capital only
				elseif ($fileformat & 256)	$Settings->layoutsetting |= 384;		// all in upper case
				elseif ($fileformat & 512)	$Settings->layoutsetting |= 512;		// all in lower case
			}
			$Settings->layoutsetting |=    32;											// description
			$Settings->layoutsetting |=    64;											// keywords
			$Settings->layoutsetting |=  8192;											// fullsize image as lightbox
			$Settings->layoutsetting &= ~6144;											// thumbnail arrangement (auto)
			$Settings->navtype        = ((int)$Settings->navtype & 127) | 16;	// 16 - switch navigation on

			// RENAMES
			if (isset($Settings->imagecolumns)) {
				$Settings->itemThumbCols = max($Settings->imagecolumns, 1);		// kh_mod < 0.3.0 b6
			}
			if (isset($Settings->imagecols)) {
				$Settings->itemThumbCols = max($Settings->imagecols, 1);			// kh_mod < 0.4.0 b4
			}
			if (isset($Settings->imagerows)) {
				$Settings->itemThumbRows = max($Settings->imagerows, 1);			// kh_mod < 0.4.0 b4
			}
			if (isset($Settings->introwidth) && (int)$Settings->introwidth) {
				$Settings->contentWidth	 = $Settings->introwidth;					// kh_mod 0.1.0 b2 added
			}
			if (isset($Settings->introwidth)) {
				$Settings->introWidth    = $Settings->introwidth;					// kh_mod 0.1.0 b2 added
			}

			// VERSION FLAG
			$lt_040b4 = true;
		}

		// CHANGES IN kh_mod 0.4.0 rc1
		if (!isset($Settings->modversion) || version_compare($Settings->modversion, '0.4.0-rc1', '<')) {
			(int)$Settings->navtype       |= ((int)$Settings->layoutsetting & 3) << 5;
			(int)$Settings->layoutsetting |= 3;	// view navigation bar for folder and item

			$oldCanvasAlign  = (int)$Settings->extendedset &  768;
			$oldContentAlign = (int)$Settings->extendedset & 3072;
			(int)$Settings->extendedset &= 255;
			//  256 - switch on counter permanently
			//  512 - view gallery without header and footer
			// 1024 - canvas align 'left'
			(int)$Settings->extendedset |= $oldCanvasAlign  ? $oldCanvasAlign  << 2 : 2048;	// canvas align 'center'
			(int)$Settings->extendedset |= $oldContentAlign ? $oldContentAlign << 2 : 8192;	// content align 'center'
		}

		// CONVERT AND NORM SOME SETTINGS
		require_once(INC_FOLDER .'mg2admin_converter.php');
		$Converter = &$this->mg2->getInstance('MG2AdminConverter');
		$Settings  = $Converter->cleanSettingData($Settings);

		// SET NEW MOD VERSION
		if (is_readable(INC_FOLDER .'mg2_version.php')) {
			include(INC_FOLDER .'mg2_version.php');
			if (preg_match('/^\d{1,2}\.\d{1,2}\.\d{1,2}.{0,5}$/', $modversion))
				$Settings->modversion = $modversion;
		}

		// MAKE DATABASE UPDATE
		include_once(INC_FOLDER .'mg2_counter.php');
		include_once(INC_FOLDER .'mg2admin_backup.php');
		$Backup = &$this->mg2->getInstance('MG2Backup');
		$Backup->backup_DB( array(
									isset($lt_040b4) ? 'fdatabase':'folders',
									isset($lt_040b4) ? 'idatabase':'items',
									'keywords',
									'counter',
									'settings',
									'sauer'
								 )
					);

		// DO MAP SETTINGS TO OBJECT "MG2"
		foreach ((array)$Settings as $property=>$value) {
			$this->mg2->$property = $value;
		}

		// WRITE SETTINGS - SQL MODE
		if (!empty($Settings->sqldatabase)) {
			include_once(INC_FOLDER .'mg2admin_sqlwrite.php');
			$SQLWrite = &$this->mg2->getInstance('SQLWrite');
			$flat_ok  = $this->mg2->write_sDBFlatfile('sql') ?
							$SQLWrite->write2SQLTable('settings')
							:
							-1;
		}
		// WRITE SETTINGS - FLAT FILE MODE
		else {
			$flat_ok = ($this->mg2->write_sDBFlatfile('flat'))? 1:-1;
		}

		// DELETE OLD SETTINGS ('mg2_settings.php') < kh_mod 0.3.0 b5
		if (($flat_ok > 0) && is_file(DATA_FOLDER .'mg2_settings.php')) {
			unlink(DATA_FOLDER .'mg2_settings.php');
		}

		echo ($flat_ok > 0)?
			'<p>Your gallery settings now are upgraded to kh_mod '. $updateVersion .' (MG2 0.5.1)</p>
			 <form action="'. UPDATE_INDEX .'" method="post">
				<input type="hidden" name="step" value="2" />
				<p style="margin-top:2em">
					<input type="image" src="'. ADMIN_IMAGES .'ok.gif" class="adminpicbutton" alt="Next" title="Next" />
				</p>
			 </form>'
			:
			'<p>Couldn\'t upgrade your MG2 settings to kh_mod '. $updateVersion .' (MG2 0.5.1)!</p>
			 <form action="'. UPDATE_INDEX .'" method="post">
				<input type="hidden" name="step" value="1" />
				<p style="margin-top:2em">
					<input type="image" src="'. ADMIN_IMAGES .'rebuild.gif" class="adminpicbutton" alt="Try it again" title="Try it again" />
				</p>
			 </form>';
	}
	// END OF STEP 1

	/**
	 * STEP 2, SELECT GALLERY DATA TO CONVERT
	 */
	function updateStep2($imagefolder) {

		$updateStep	= '2';
		$checked		= (is_file('database.txt'))? 'checked="checked"':'';

		// kh_mod >= 0.2.0 b2
		if ($_SESSION['version'] >= 2) {
			echo '
				<p><strong>Step '. $updateStep .' / 2</strong></p>
				<form action="'. UPDATE_INDEX .'" method="post">
				<input type="hidden" name="step" value="3" />
				<table cellpadding="0" cellspacing="0" border="0" summary="Import the counter add-on">
					<tr>
						<td>
							<input type="checkbox" name="ctr" id="ctr" value="on" style="vertical-align:middle;" '.$checked.' />
							<label for="ctr"> Import the click counter add-on data from "database.txt" (gallery root)</label>
						</td>
					</tr>
					<tr>
						<td>
							<div style="margin-top:.6em">
							<input type="checkbox" name="del" id="del" value="on" style="vertical-align:middle;" checked="checked" />
							<label for="del"> Delete the update file "mg2_update.php" after updating</label>
							</div>
						</td>
					</tr>
				</table>
				<p style="margin-top:2em">
					<input type="image" src="'. ADMIN_IMAGES .'ok.gif"     name="convert" class="adminpicbutton" alt="OK" title="OK" />&nbsp;
					<input type="image" src="'. ADMIN_IMAGES .'cancel.gif" name="cancel"  class="adminpicbutton" alt="Cancel" title="Cancel" />
				</p>
				</form>
			';
		}
		// kh_mod < 0.2.0 b2
		else {
			echo '
				<p><strong>Step '. $updateStep .' / 2 &nbsp;&ndash;&nbsp; for MG2 0.5.1/kh_mod 0.1.0 or 0.2.0 b1 <span style="color:red">ONLY!</span></strong></p>
				<form action="'. UPDATE_INDEX .'" method="post">
				<input type="hidden" name="step" value="3" />
				<table cellpadding="0" cellspacing="0" border="0" summary="Import older database">
					<tr>
						<td>
							<input type="checkbox" name="fDB" id="fDB" value="on" style="vertical-align:middle;" checked="checked" />
							<label for="fDB"> Import folder data (from the gallery root)</label>
						</td>
					</tr><tr>
						<td>
							<input type="checkbox" name="iDB" id="iDB" value="on" style="vertical-align:middle;" checked="checked" />
							<label for="iDB"> Import image data (from the gallery root)</label>
						</td>
					</tr><tr>
						<td>
							<input type="checkbox" name="ctr" id="ctr" value="on" style="vertical-align:middle;" '. $checked .' />
							<label for="ctr"> Import the click counter add-on data (from the gallery root)</label>
						</td>
					</tr><tr>
						<td>
							<input type="checkbox" name="cDB" id="cDB" value="on" style="vertical-align:middle;" checked="checked" />
							<label for="cDB"> Convert the comment entries (in directory \''. $imagefolder .'\')</label>
						</td>
					</tr><tr>
						<td>
							<input type="checkbox" name="log" id="log" value="on" style="vertical-align:middle;" checked="checked" />
							<label for="log"> Import gallery log file (from the gallery root)</label>
						</td>
					</tr><tr>
						<td>
							<div style="margin-top:.6em">
							<input type="checkbox" name="del" id="del" value="on" style="vertical-align:middle;" checked="checked" />
							<label for="del"> Delete the update file "mg2_update.php" after import</label>
							</div>
						</td>
					</tr>
				</table>
				<p style="margin-top:2em">
					<input type="image" src="'. ADMIN_IMAGES .'cancel.gif" name="cancel"  class="adminpicbutton" alt="Cancel" title="Cancel" />&nbsp;
					<input type="image" src="'. ADMIN_IMAGES .'ok.gif"     name="convert" class="adminpicbutton" alt="OK" title="OK" />
				</p>
				</form>
			';
		}
	}
	// END OF STEP 2

	/**
	 * STEP 3, CONVERT GALLERY DATA
	 */
	function updateStep3($updateVersion) {

		$updateStep  = '3';
		$convertPath = INC_FOLDER .'mg2admin_converter.php';

		if (is_readable($convertPath)) {
			require_once($convertPath);
			$Converter = &$this->mg2->getInstance('MG2AdminConverter');

			// CONVERT DATABASE CONTENT
			if (isset($_POST['convert_x'])) {
				if (isset($_POST['ctr']) && $_POST['ctr']==='on') {
					$Converter->updateClickData();	// counter data
				}

				if ($_SESSION['version'] < 2) {		// kh_mod < 0.2.0 b2
					if (isset($_POST['iDB']) && $_POST['iDB']==='on') $Converter->updateItemData();		// item data
					if (isset($_POST['fDB']) && $_POST['fDB']==='on') $Converter->updateFolderData();	// folder data
					if (isset($_POST['cDB']) && $_POST['cDB']==='on') $Converter->updateCommentData();	// comment files
					if (isset($_POST['log']) && $_POST['log']==='on') {											// logfile
						if (!is_file('mg2_log.txt')) {
							$this->mg2->displayStatus('There is no log file to import', 1);
						} elseif (copy('mg2_log.txt', DATA_FOLDER .'mg2_log.txt')) {
							$this->mg2->displayStatus('Imoprted log file');
						} else {
							$this->mg2->displayStatus('Couldn\'t imoprt log file', 2);
						}
					}
				}
			}

			// FOR kh_mod >= 0.2.0b2 UP TO 0.4.0b4
			$checklistOK = $captchaOK = true;
			if (2 <= $_SESSION['version'] && $_SESSION['version'] <= 6) {

				// RENAME FOLDER, ITEM AND BACKUP DATA FILES
				if (($result = $Converter->renameOldDatabase()) !== true) {
					$this->displayRenameError($result); return;
				}
				if (($result = $Converter->renameOldBackups())  !== true) {
					$this->displayRenameError($result); return;
				}

				// MOVE ADDON DIRECTORY, FOR kh_mod >= 0.3.0 b6 UP TO 0.4.0 b4
				if (5 <= $_SESSION['version']) {
					list($checklistOK, $captchaOK) = $Converter->moveAddonDir();
				}
			}

			// FOR kh_mod 0.2.0b2 UP TO 0.4.0 pl3
			if (2 <= $_SESSION['version'] && $_SESSION['version'] <= 7) {
				$Converter->setContentType();
			}

			// FOR kh_mod 0.4.0 rc1 UP TO 0.4.1
			if (7 <= $_SESSION['version'] && $_SESSION['version'] <= 8 ) {
				$Converter->updateChronicleData();
			}

			// DELETE UPDATE FILE
			$unlinkOK = (isset($_POST['convert_x']) && isset($_POST['del']))?
							unlink(ROOT_FOLDER .'/mg2_update.php')
							:
							false;

			// DISPLAY MESSAGE
			printf('<p>Your gallery should now be updated to kh_mod %s.%s</p>',
				$updateVersion,
				($checklistOK && $captchaOK)? '':' But at the end <b>you have to move:</b>'
			);
			if (!$checklistOK)
				echo '<div class="status_message notice">&nbsp;&mdash;The directory \'skins/_global_/checklists\' to \'addons/checklists\' by FTP or SSH client</div>';
			if (!$captchaOK)
				echo '<div class="status_message notice">&nbsp;&mdash;The directory \'skins/_global_/captcha\' to \'addons/captcha\' by FTP or SSH client</div>';
			echo $unlinkOK ?
				'<p class="status_message notice" style="margin:1em;">Notice: The update file \'mg2_update\' has been deleted</p>'
				:
				'<p class="status_message warning" style="margin:1em;">IMPORTANT: DELETE \'mg2_update.php\' &ndash; USE FTP or SSH CLIENT NOW!</p>';
			echo '<div style="margin:2em 0 1.5em 0">
						<div>
							<a href="admin.php" target="_top">
							<img src="'. ADMIN_IMAGES .'ok.gif" class="adminpicbutton" width="24" height="24" alt="Go to the admin panel" /></a>
						</div>
						<div>
							<a href="admin.php" target="_top">Go to the admin panel</a>
						</div>
					</div>';

			// LOG ENTRY
			$this->mg2->log('Gallery updated to kh_mod '. $updateVersion .' (MG2 0.5.1)');
		}
		else {
			echo '
				<p><b>Couldn\'t upgrade your MG2 installation to kh_mod '. $updateVersion .' (MG2 0.5.1)!</b></p>
				<p>&mdash; The converter module \''. $convertPath .' \' isn\'t readable! &mdash;</p>
				<div style="margin:2em 0 1em 0;">
				<form action="'. UPDATE_INDEX .'" onsubmit="this.isJavaScript.value=\'on\'" method="post">
					<input type="hidden" name="step" value="2" />
					<input type="hidden" name="isJavaScript" value="off" />
					<!--[if IE]><input type="hidden" name="ie" value="1" /><![endif]-->
					<!--[if lt IE 9]><input type="hidden" name="ie8" value="1" /><![endif]-->
					<!--[if lt IE 8]><input type="hidden" name="ie7" value="1" /><![endif]-->
					<!--[if lt IE 7]><input type="hidden" name="ie6" value="1" /><![endif]-->
					<input type="image" src="'. ADMIN_IMAGES .'rebuild.gif" class="adminpicbutton" alt="Try it again" title="Try it again" />
				</form>
				</div>
			';
		}
		unset($_SESSION['updatepwd']);
		unset($_SESSION['version']);
	}
	// END OF STEP 3

	/**
	 * SEARCH AND GET SETTINGS
	 */
	function getSettings($updateStep) {

		$Settings     = false;
		$settingPaths = array (
								'current' 	=>	DATA_FOLDER .'mg2db_settings.php',	// >= kh_mod 0.3.0 b5
								'before'		=> DATA_FOLDER .'mg2_settings.php',		// >= kh_mod 0.2.0 b2 (with new data structure)
								'original'	=> 'mg2_settings.php'						// MG2 0.5.0/0.5.1
							 );

		if (is_file($settingPaths['current'])) {
			$Settings = $this->readSettings($settingPaths['current']);

			if ($updateStep === 1) {
				if (isset($Settings->modversion)) {
					if (version_compare($Settings->modversion, '0.4.2', '>=')) {
						$_SESSION['version'] = 9;
					}
					elseif (version_compare($Settings->modversion, '0.4.1', '>=')) {
						$_SESSION['version'] = 8;
					}
					elseif (version_compare($Settings->modversion, '0.4.0-rc1', '>=')) {
						$_SESSION['version'] = 7;
					}
					else {
						$_SESSION['version'] = 6;	// kh_mod >= 0.4.0 b2
					}
				}
				else {
					$_SESSION['version'] = (isset($Settings->thumbMaxWidth)	&&
													isset($Settings->thumbMaxHeight)	&&
													isset($Settings->inactivetime)	&&
													isset($Settings->modversion))?
													5	// kh_mod >= 0.3.0 b6
													:
													4;	// kh_mod == 0.3.0 b5
				}
			}
		}
		elseif (is_file($settingPaths['before'])) {
			$Settings = $this->readSettings($settingPaths['before']);

			if ($updateStep === 1) {
				$_SESSION['version'] = (isset($Settings->foldersetting)		&&
												isset($Settings->metasetting)			&&
												isset($Settings->layoutsetting))?
												3	// kh_mod >= 0.3.0 b2
												:
												2;	// kh_mod >= 0.2.0 b2
			}
		}
		elseif (is_file($settingPaths['original'])) {
			$Settings = $this->readSettings($settingPaths['original']);

			if ($updateStep === 1) {
				$_SESSION['version'] = 1;	// kh_mod <= 0.2.0 b1 or MG2 0.5.1/0.5.0
			}
		}

		return $Settings;
	}

	function readSettings($settingPath) {

		// READ SETTINGS
		$mg2 = new stdClass();
		if (is_readable($settingPath) && include($settingPath)) {

			// READ SETTINGS FROM MYSQL?
			if (defined('DB_NAME') 		&&
				 defined('DB_USERNAME') &&
				 defined('DB_PASSWORD')	&&
				 defined('DB_SERVER')) {

				// kh_mod 0.3.0 b2, b3 or b4 ONLY
				if (!isset($mg2->sqldatabase) || (int)$mg2->sqldatabase < 1) {
					$mg2->sqldatabase = 1;		// MySQL
					$mg2->extendedset&= ~32;	// delete old MySQL setting, now 'seolink'
				}

				// SET GLOBAL SQL FLAG FOR ERROR HANDLING
				$this->mg2->sqldatabase = (int)$mg2->sqldatabase;

				// READ SETTINGS FROM SQL DATABASE
				$mg2 = $this->mg2->read_sDBSQL(false);
			}

			return $mg2;
		}
		else {
			return false;
		}
	}

	function readLanguage($Settings) {

		// INCLUDE LANGUAGE FILE
		$mg2 = new stdClass();
		$mg2->imagefolder = $Settings->imagefolder;
		if ($langPath = $this->mg2->checkLanguage($Settings->defaultlang, 'gallery')) {
			include sprintf($langPath, 'gallery');
			include sprintf($langPath, 'admin');
		}
		elseif ($langPath = $this->mg2->checkLanguage('en_US', 'gallery')) {
			$Settings->defaultlang = 'en_US';
			include sprintf($langPath, 'gallery');
			include sprintf($langPath, 'admin');
		}
		else {
			$Settings->defaultlang = false;
		}

		// UPDATE LANGUAGE IN THE OBJECT "MG2"
		foreach ((array)$mg2 as $property=>$value) {
			$this->mg2->$property = $value;
		}

		return $Settings->defaultlang;
	}

	function inputPassword() {
		//	header('Content-Type: text/html; charset='. $this->mg2->charset);

		echo'
		<script language="JavaScript" type="text/javascript">
		/* <![CDATA[ */
			window.onload = function() { document.login.password.focus(); }
		/* ]]> */
		</script>
		<table class="install_table" cellpadding="0" cellspacing="0" summary="Enter password">
			<tr>
			<td class="install_td">
				<div style="margin: 1.5em 0 1em 0;text-align:center;">
					<form name="login" method="post" action="'. UPDATE_INDEX .'">
					<p><b>'. $this->mg2->lang['enterpassword'] .'</b></p>
					<p>'. $this->mg2->lang['thissection'] .'</p>
					<p><input type="password" name="updatepwd" class="admintext" /></p>
					<p><input type="image" src="'. ADMIN_IMAGES .'ok.gif" class="adminpicbutton" alt="OK" title="OK" /></p>
					</form>
				</div>
			</td>
		</tr>
		</table>
		';
	}

	/**
	 * CHECK LOGIN
	 */
	function updateSecurity($Settings) {

		// INIT RETURN VALUE
		$login = false;

		// PASSWORD RENAMED IN, kh_mod 0.3.0 rc1
		if (!isset($Settings->adminpwd)) $Settings->adminpwd = $Settings->password;

		// IF LOGIN, THEN SET PASSWORD
		if (!empty($_POST['updatepwd']) && strlen($_POST['updatepwd']) <= MAXLEN_PWD) {
			// PASSWORD FOR kh_mod >= 0.4.0 b4
			if (isset($Settings->adminsalt) && (strlen($Settings->adminpwd) === 40)) {
				$_SESSION['updatepwd'] = sha1(strrev(sha1($_POST['updatepwd'] . $Settings->adminsalt)));
			}
			// PASSWORD FOR kh_mod < 0.4.0 b4
			elseif (md5(strrev(md5($_POST['updatepwd']))) === $Settings->adminpwd) {
				$Settings->adminsalt   = $this->mg2->buildVerificationToken(40);
				$Settings->adminpwd    = sha1(strrev(sha1($_POST['updatepwd'] . $Settings->adminsalt)));
				$_SESSION['updatepwd'] = $Settings->adminpwd;
			}
		}

		// CHECK PASSWORD
		if (isset($_SESSION['updatepwd']) &&
			 ($_SESSION['updatepwd'] === $Settings->adminpwd))
		{
			define('USER_ADMIN', true);	// set admin permission
			$login = true;
		}

		return $login;
	}

	/**
	 * MG2/kh_mod SETTINGS NOT AVAILABLE!
	 */
	function displayUpdateError() {

		$message = $this->mg2->sqldatabase ?
					  'To update your gallery you have to switch to \'Flat file\' mode (Menu:
					  <a href="http://www.tangata.de/kh_mod/index.php?aktion=4&ln=en#data" target="_blank">Data</a>)!'
					  :
					  'Can\'t find the MG2 settings to update your gallery!';

		echo '
			<div>
				<div style="color:red;font-weight:bold;">ERROR: '. $message .'</div>
				<div style="margin-top:1.3em">
					<form action="'. UPDATE_INDEX .'" method="post">
					<input type="hidden" name="step" value="1" />
					<input type="image" src="'. ADMIN_IMAGES .'rebuild.gif" class="adminpicbutton" alt="Try it again" title="Try it again" />
					</form>
				</div>
			</div>
		';
	}

	/**
	 * UNRENAMEABLE FILES IN DATA FOLDER
	 */
	function displayRenameError($files) {

		// INIT START VALUES
		$renErrors = '';
		$search	  = array('idatabase', 'fdatabase');
		$replace   = array('items', 'folders');
		$fileType  = isset($files['backups']) ? 'backup':'data';

		if ($files['items']) {
			foreach($files['items'] as $file) {
				$renErrors.= "<div style='margin:0.2em'>'".  $file ."' => '". str_replace($search, $replace, $file) ."'</div>\n";
			}
		}
		if ($files['folders']) {
			foreach($files['folders'] as $file) {
				$renErrors.= "<div style='margin:0.2em'>'".  $file ."' => '". str_replace($search, $replace, $file) ."'</div>\n";
			}
		}
		if ($files['backups']) {
			foreach($files['backups'] as $file) {
				$renErrors.= "<div style='margin:0.2em'>'".  $file ."' => 'backup/". str_replace($search, $replace, $file) ."'</div>\n";
			}
		}

		echo '
			<div style="margin:1.2em 0 .8em 0">
				<div style="margin:1em 0 .6em 0"><b>ERROR:</b> Couldn\'t rename the following '. $fileType .' files:</div>
				'. $renErrors .'
				<div style="margin:1.3em 0">Please, try it again or rename the files by FTP client!</div>
				<div style="margin-top:1.6em">
					<form action="'. UPDATE_INDEX .'" method="post">
					<input type="hidden" name="step" value="3" />
					<input type="image" src="'. ADMIN_IMAGES .'rebuild.gif" class="adminpicbutton" alt="Try it again" title="Try it again" />
					</form>
				</div>
			</div>
		';
	}
}
?> 