<?php
//////////////////////////////////////////////////////////////////////////////////
//                                                                              //
//    MG2                                                                       //
//    A PHP/HTML based image gallery script.                                    //
//                                                                              //
//    Copyright 2005 by Thomas Rybak                                            //
//    http://www.minigal.dk                                                     //
//    support@minigal.dk                                                        //
//                                                                              //
//    The script utilises Exif reader v 1.2 (free to use)                       //
//    Exif reader v 1.2                                                         //
//    By Richard James Kendall (richard@richardjameskendall.com)                //
//                                                                              //
//    -----------------                                                         //
//                                                                              //
//    MG2 is free software; you can redistribute it and/or modify               //
//    it under the terms of the GNU General Public License as published by      //
//    the Free Software Foundation; either version 2 of the License, or         //
//    (at your option) any later version.                                       //
//                                                                              //
//    MG2 is distributed in the hope that it will be useful,                    //
//    but WITHOUT ANY WARRANTY; without even the implied warranty of            //
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the              //
//    GNU General Public License for more details.                              //
//                                                                              //
//    TO COMPLY WITH THIS LICENSE, DO NOT REMOVE THE LINK TO THE MINIGAL        //
//    WEBSITE FROM YOUR GALLERY FRONT PAGE. THIS IS THE LEAST YOU CAN DO TO     //
//    SUPPORT THE DEVELOPMENT OF MG2!                                           //
//                                                                              //
//    You should have received a copy of the GNU General Public License         //
//    along with this program; if not, you can find it here:                    //
//    http://www.gnu.org/copyleft/gpl.html                                      //
//                                                                              //
//////////////////////////////////////////////////////////////////////////////////

// SWITCH OFF ALL ERROR MESSAGES
error_reporting(0);

//SET PHP ARGUMENT SEPERATOR ON '&AMP'
ini_set('arg_separator.output', '&amp;');

// TO SUPPRESS DateTime E_WARNINGS
if (version_compare(PHP_VERSION, '5.1', '>')) {
	date_default_timezone_set(@date_default_timezone_get());
}

session_start();

//
// DEFINE SCRIPT CONSTANTS
// kh_mod 0.4.0 final, changed
if (!defined('MG2_INCLUDE_PATH')) define('MG2_INCLUDE_PATH', './');
define('ROOT_FOLDER',  dirname(__FILE__));
define('GALLERY_ID',	  'mg2'. (string)crc32(ROOT_FOLDER));
define('INC_FOLDER',   ROOT_FOLDER .'/includes/');
define('DATA_FOLDER',  ROOT_FOLDER .'/data/');
define('LANG_FOLDER',  ROOT_FOLDER .'/lang/');
define('ADDON_FOLDER', MG2_INCLUDE_PATH .'addons/');
define('MAXLEN_PWD',   4096);

//
// LOGOUT ALL FOLDERS (GALLERY)
// kh_mod 0.4.0 rc2, changed
$isLogoutMessage = false;
if (isset($_GET['action']) && $_GET['action'] === 'logout') {
	unset($_SESSION[GALLERY_ID]['keyPwdHash']);
	unset($_SESSION[GALLERY_ID]['fPwdHash']);
	$isLogoutMessage = true;
}

// TRIGGER INSTALLATION
if (!is_file(DATA_FOLDER .'mg2db_settings.php')) {
	$message = 'The MG2/kh_mod installation is invalid!';
	include (is_file(INC_FOLDER .'mg2_install.php'))?
		INC_FOLDER .'mg2_install.php'
		:
		ROOT_FOLDER .'admin/fatal_error.php';
	exit();
}

// MAKE NEW DATABASE OBJECT
require(INC_FOLDER .'mg2_functions.php');
require(INC_FOLDER .'mg2_comments.php');
require(INC_FOLDER .'mg2_counter.php');
require(INC_FOLDER .'mg2_splashes.php');
require(INC_FOLDER .'mg2_keywords.php');
$mg2 = new MG2gallery;

// DEFAULT SETTINGS
$mg2->imagefolder	  = 'pictures';
$mg2->layoutsetting =  8307;		// 1, 0, 0, 0, 0, 0, 0, 1, 1, 1, 0, 0, 1, 1
$mg2->extendedset	  = 10460;		// 1, 0, 1, 0, 0, 0, 1, 1, 0, 1, 1, 1, 0, 0
$mg2->commentsets	  =   159;		// 0, 0, 0, 0, 0, 0, 1, 0, 0, 1, 1, 1, 1, 1
$mg2->showexif		  =     0;		// displayed exif values
$mg2->sqldatabase   =     0;		// use flat file, 1 use MySQL
$mg2->sqlprefix	  = 'mg2_';		// prefix for database tables (current unused!)
$mg2->charset		  = 'utf-8';	// nessesary for mb_ functions

// READ SETTINGS
require(DATA_FOLDER .'mg2db_settings.php');

// IF SQL DATABASE
if ($mg2->sqldatabase) {

	// CONNECT TO SQL SERVER
	$mg2->getSQLConnect();

	// READ SETTINGS FROM SQL DATABASE
	$mg2->read_sDBSQL();
}

// DOWNLOAD ITEM
if (isset($_GET['download']) && isset($_GET['iID']) && (int)$mg2->navtype & 128) {
	require_once(INC_FOLDER .'mg2_view_helper.php');
	$ViewHelper = &$mg2->getInstance('MG2ViewHelper');
	$ViewHelper->downloadItem((int)$_GET['iID']);
	exit;
}

//
// CHECK LANGUAGE,  ISO 639-1, ISO 3166-1 ALPHA-2
// kh_mod 0.1.0 rc1, 0.4.0 rc2 changed
$regexp = '/^([a-z]{2})(_|-)([a-z]{2})$/i';
if (isset($_GET['ln']) && preg_match($regexp, $_GET['ln'], $match)) {
	$galleryLang = sprintf('%s_%s',
									strtolower($match[1]),
									strtoupper($match[3])
						);
}
elseif (isset($_SESSION[GALLERY_ID]['gallerylang'])) {
	$galleryLang = $_SESSION[GALLERY_ID]['gallerylang'];
}
else {
	$galleryLang = $mg2->defaultlang;
}

// INCLUDE LANGUAGE, kh_mod 0.4.0 rc2, changed
do {
	do {
		if ($langPath = $mg2->checkLanguage($galleryLang)) break;

		$galleryLang = isset($_SESSION[GALLERY_ID]['gallerylang']) ?
							$_SESSION[GALLERY_ID]['gallerylang']
							:
							$mg2->defaultlang;
		if ($langPath = $mg2->checkLanguage($galleryLang)) break;

		$galleryLang = 'en_US';
		if ($langPath = $mg2->checkLanguage($galleryLang)) break;

		$mg2->status = sprintf('The language "%s" is not available!',
								substr($mg2->defaultlang,0,5)
							);
		break 2;	// no valid language
	}
	while(0);

	// LOAD CURRENT LANG FILE
	include sprintf($langPath, 'gallery');

	// SET LANGUAGE SESSION AND COMPATIBILITY TO kh_mod 0.4.0
	$_SESSION[GALLERY_ID]['gallerylang'] = $gallerylang = $galleryLang;

	// SET WEB SERVER TO CURRENT CHARSET (LANG FILE)
	if ((int)$mg2->extendedset & 64) $mg2->setServerToCharset();
}
while(0);

// IF SET 'INCLUDE GALLERY'
if ($mg2->extendedset & 1<<9) {
	// SET PICTURES FOLDER PATH
	$mg2->imagefolder = MG2_INCLUDE_PATH . $mg2->imagefolder;
}
else {
	// SET X-ROBOTS-TAG, 
	$x_robots = array();
	if ($mg2->metasetting & 1024) $x_robots[] = 'noindex';
	if ($mg2->metasetting & 2048) $x_robots[] = 'nofollow';
	if ($mg2->metasetting & 4096) $x_robots[] = 'noarchive';
	if ($mg2->metasetting & 8192) $x_robots[] = 'nosnippet';
	if ($x_robots) header('X-Robots-Tag: '. implode(', ', $x_robots));

	// SET ANOTHER HTTP-HEADERS
	header('X-Frame-Options: SAMEORIGIN');
	header('Content-Type: text/html; charset='. $mg2->charset);
	header('Content-Script-Type: text/javascript');
	header('Content-Style-Type: text/css');
}

//
// SKIN SETTINGS
// kh_mod 0.4.0 final, changed
$activeSkinPath = 'skins/'. $mg2->activeskin .'/';
define('SKIN_FOLDER', ROOT_FOLDER .'/'. $activeSkinPath);
define('SKIN_IMAGES', MG2_INCLUDE_PATH . $activeSkinPath .'images/');
if (!is_readable(SKIN_FOLDER .'templates')) {
	$message = (empty($mg2->activeskin))?
				  'There isn\'t any installed skin!'
				  :
				  'The skin "'. ucfirst($mg2->activeskin) .'" is not available!';
	include('admin/fatal_error.php');
	exit();
}
if (is_file(SKIN_FOLDER .'settings.php')) {
	include(SKIN_FOLDER .'settings.php');
}

//
// SKIN CANVAS SETTINGS, CSS-VALUES, SET IN: 'settings.php'
// kh_mod 0.4.0 b4, add
if ((int)$mg2->canvasWidth < 1) $mg2->canvasWidth = 'auto';
switch (((int)$mg2->extendedset>>10) & 3) {
	case 1:  $mg2->canvasMargin = $margin_canvas_left;	 break;
	case 2:  $mg2->canvasMargin = $margin_canvas_center; break;
	case 3:  $mg2->canvasMargin = $margin_canvas_right;  break;
	default: $mg2->canvasMargin = 'auto';
}

//
// SKIN CONTENT SETTINGS, CSS-VALUES, SET IN: 'settings.php'
// kh_mod 0.4.0 b4, add
if ((int)$mg2->contentWidth < 1) $mg2->contentWidth = 'auto';
switch (((int)$mg2->extendedset>>12) & 3) {
	case 1:  $mg2->contentMargin = $margin_content_left;   break;
	case 2:  $mg2->contentMargin = $margin_content_center; break;
	case 3:  $mg2->contentMargin = $margin_content_right;  break;
	default: $mg2->contentMargin = 'auto';
}

//
// SET ADMIN MODE
// kh_mod 0.3.0 rc1, add; 0.4.0 rc1, changed
$isAdminModeStart = false;
if (isset($_GET['user'])) {
	if (($mg2->extendedset & 128)								&&
		 !empty($_SESSION[$_GET['user']]['adminpwd'])	&&
		 $_SESSION[$_GET['user']]['adminpwd'] === $mg2->adminpwd
		)
	// SET ADMIN MODE ON
	{
		$_SESSION[GALLERY_ID]['adminmode'] = $mg2->adminpwd;
		$isAdminModeStart = true;
	}
	// SET ADMIN MODE OFF
	elseif (isset($_SESSION[GALLERY_ID]['adminmode']))
	{
		unset($_SESSION[GALLERY_ID]['adminmode']);
		$isLogoutMessage = true;
	}
}

//
// READ DATABASE FOR GALLERY
// kh_mod 0.2.0, changed
$mg2->readDB();

//
// FOR LINK COMPATIBILITY WITH MG2 AND kh_mod 0.1.0
// kh_mod 0.2.1, add
if (!isset($_REQUEST['iID']) && !isset($_REQUEST['fID'])) {
	if (isset($_GET['iID'])) $_REQUEST['iID'] = $_GET['id'];
	if (isset($_GET['fID'])) $_REQUEST['fID'] = $_GET['list'];
}

//
// GET ITEM ID AND RELATED FOLDER ID
// kh_mod 0.1.0, add; 0.4.0 b4 changed
do {
	// ITEMVIEW
	if (!empty($_REQUEST['iID'])) {
		$itemID = (int)$_REQUEST['iID'];
		if (array_key_exists($itemID, $mg2->all_items)) {
			$imageRC  = $mg2->all_items[$itemID];
			$folderID = (int)$imageRC[1];
			define('ITEMVIEW', true);
			break;
		}
	}

	// REMOTEVIEW
	if (!empty($_GET['rID'])) {
		$remoteID = (int)$_GET['rID'];
		$itemID   = (int)$_SESSION[GALLERY_ID]['remoteID'][$remoteID];
		if (array_key_exists($itemID, $mg2->all_items)) {
			$imageRC  = $mg2->all_items[$itemID];
			$folderID = (int)$imageRC[1];
			define('ITEMVIEW', true);
			break;
		}
	}

	// SLIDESHOW
	if (!empty($_GET['slideshow'])) {
		$itemID = (int)$_GET['slideshow'];
		if (array_key_exists($itemID, $mg2->all_items)) {
			$imageRC  = $mg2->all_items[$itemID];
			$folderID = (int)$imageRC[1];
			define('SLIDESHOW', true);
			break;
		}
	}

	// FOLDERVIEW
	define('FOLDERVIEW', true);

	// SEARCHVIEW
	if (!empty($_GET['search'])) {
		$keywordMode = $mg2->setKeywordMode(
										(int)$_GET['search'],
										$isAdminModeStart
									);
		$folderID = -1;
		break;
	}

	// FOLDER ID
	$folderID = empty($_REQUEST['fID']) ?
					1
					:
					(int)$_REQUEST['fID'];
}
while(0);

// CHECK ITEM ID
if (!empty($itemID)			&&
	 !defined('ITEMVIEW')	&&
	 !defined('SLIDESHOW'))
{
	$mg2->notexists('noimage');	// item id not exists
}

// FULL SIZE MODE (IMAGE) - FOR 'mg2_viewitem.php' AND 'mg2_slideshow.php'
if (isset($_GET['fullsize']) && ((int)$_GET['fullsize'] === 1)) {
	define('FULLSIZE', true);
}

// KEYWORD MODE
if ($mg2->layoutsetting & 1<<6) {
	if (isset($_SESSION[GALLERY_ID]['search'])) {

		// SET KEYWORD MODE ON
		if (!empty($keywordMode) ||
			 (isset($itemID) && in_array($itemID, $_SESSION[GALLERY_ID]['search']['itemIDs'], true)))
		{
			$folderID = 2;
			$mg2->all_folders = array(
										 1				=> $mg2->all_folders[1],								// root folder
										 $folderID	=>	$_SESSION[GALLERY_ID]['search']['folderRC']	// key folder
									  );
			define('SEARCHVIEW', $_SESSION[GALLERY_ID]['search']['searchID']);
		}
		// SET KEYWORD MODE OFF
		else
		{
			unset($_SESSION[GALLERY_ID]['search']);
		}
	}
}

//
// CURRENT PAGE OF THUMBNAILS
// kh_mod 0.4.0 b4, changed
if (!isset($_GET['page'])) {
	$currentPage = 1;
}
elseif ($_GET['page'] === 'all') {
	$currentPage = 'all';
}
else {
	$currentPage = max((int)$_GET['page'], 1);
}

//
// SET METATAGS TITLE AND ROBOTS
// kh_mod 0.2.0, add, 0.3.0 changed
$mg2->pagetitle = $mg2->getPagetitle($folderID, defined('FOLDERVIEW')? -1:$itemID);
$mg2->robots	 = array();
$mg2->googlebot = '';
if ($mg2->metasetting &  16) $mg2->robots[]	= 'noindex';
if ($mg2->metasetting &  32) $mg2->robots[]	= 'index';
if ($mg2->metasetting &  64) $mg2->robots[]	= 'nofollow';
if ($mg2->metasetting & 128) $mg2->robots[]	= 'follow';
if ($mg2->metasetting & 256) $mg2->robots[]	= 'noarchive';
if ($mg2->metasetting & 512) $mg2->googlebot	= 'nosnippet';

// GET ALL FOLDER IDs UPTO THE ROOT FOLDER
$fIDstoRoot = $mg2->getFolderBranchToRoot($folderID, true);

//
// CHECK GALLERY PASSWORD AND FOLDER INTEGRITY
// kh_mod 0.4.1, changed
if (!$mg2->checkGalleryPassword($folderID, $fIDstoRoot)) {
	require_once(INC_FOLDER .'mg2_view_helper.php');
	$ViewHelper = &$mg2->getInstance('MG2ViewHelper');
	$ViewHelper->displayGalleryPwdDialog(defined('FOLDERVIEW')? -1:$itemID);
	exit();
}

// GET FOLDER SETTINGS
$mg2->getFolderSettings($folderID);

//////////////////////////////
//     DISPLAY CONTENT      //
//////////////////////////////
if ((int)$mg2->all_folders[$folderID][11] === 1) {
	// URL
	list($fURL, $fTarget) = $mg2->getFolderURL($folderID);
	@header('Location: '. $fURL);
	exit;
}
elseif (defined('SLIDESHOW')) {
	// SLIDESHOW
	include (INC_FOLDER .'mg2_slideshow.php');
}
elseif (defined('ITEMVIEW')) {
	// DISPLAY A ITEM
	include (INC_FOLDER .'mg2_viewitem.php');
}
else {
	// FOLDER CONTENT (THUMBS)
	include (INC_FOLDER .'mg2_viewfolder.php');
}
?>
